if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-aria/aui-aria.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-aria/aui-aria.js",
    code: []
};
_yuitest_coverage["build/aui-aria/aui-aria.js"].code=["YUI.add('aui-aria', function (A, NAME) {","","var Lang = A.Lang,","	isBoolean = Lang.isBoolean,","	isFunction = Lang.isFunction,","	isObject = Lang.isObject,","	isString = Lang.isString,","","	ATTRIBUTE_VALUE_FORMAT = 'attributeValueFormat',","	ATTRIBUTES = 'attributes',","	ARIA = 'aria',","	ARIA_PREFIX = 'aria-',","	ATTRIBUTE_NODE = 'attributeNode',","	BOUNDING_BOX = 'boundingBox',","	HOST = 'host',","	ROLE = 'role',","	ROLE_NAME = 'roleName',","	ROLE_NODE = 'roleNode',","	VALIDATE_W3C = 'validateW3C',","	CHANGE_PREFIX = 'Change',","","	EMPTY_STR = '',","	STR_REGEX = /([^a-z])/ig,","","	EV_PROCESS_ATTRIBUTE = 'aria:processAttribute',","","	_toAriaRole = A.cached(","		function(str) {","			return str.replace(STR_REGEX, function() {","				return EMPTY_STR;","			})","			.toLowerCase();","		}","	);","","var Aria = A.Component.create({","	NAME: ARIA,","","	NS: ARIA,","","	ATTRS: {","		attributes: {","			value: {},","			validator: isObject","		},","","		attributeValueFormat: {","			value: function(val) {","				return val;","			},","			validator: isFunction","		},","","		attributeNode: {","			writeOnce: true,","			setter: A.one,","			valueFn: function() {","				return this.get(HOST).get(BOUNDING_BOX);","			}","		},","","		roleName: {","			valueFn: function() {","				var instance = this;","				var host = instance.get(HOST);","				var roleName = _toAriaRole(host.constructor.NAME || EMPTY_STR);","","				return (instance.isValidRole(roleName) ? roleName : EMPTY_STR);","			},","			validator: isString","		},","","		roleNode: {","			writeOnce: true,","			setter: A.one,","			valueFn: function() {","				return this.get(HOST).get(BOUNDING_BOX);","			}","		},","","		validateW3C: {","			value: true,","			validator: isBoolean","		}","	},","","	EXTENDS: A.Plugin.Base,","","	prototype: {","		initializer: function() {","			var instance = this;","","			instance.publish(EV_PROCESS_ATTRIBUTE, {","	            defaultFn: instance._defProcessFn,","	            queuable: false,","	            emitFacade: true,","	            bubbles: true,","	            prefix: ARIA","	        });","","			instance._uiSetRoleName(","				instance.get(ROLE_NAME)","			);","","			instance.after('roleNameChange', instance._afterRoleNameChange);","","			instance._bindHostAttributes();","		},","","		isValidAttribute: function(attrName) {","			var instance = this;","","			return (instance.get(VALIDATE_W3C) ? A.Plugin.Aria.W3C_ATTRIBUTES[attrName] : true);","		},","","		isValidRole: function(roleName) {","			var instance = this;","","			return (instance.get(VALIDATE_W3C) ? A.Plugin.Aria.W3C_ROLES[roleName] : true);","		},","","		setAttribute: function(attrName, attrValue, node) {","			var instance = this;","","			if (instance.isValidAttribute(attrName)) {","				(node || instance.get(ATTRIBUTE_NODE)).set(ARIA_PREFIX+attrName, attrValue);","","				return true;","			}","","			return false;","		},","","		setAttributes: function(attributes) {","			var instance = this;","","			A.Array.each(attributes, function(attribute, index, attributes) {","				instance.setAttribute(attribute.name, attribute.value, attribute.node);","			});","		},","","		setRole: function(roleName, node) {","			var instance = this;","","			if (instance.isValidRole(roleName)) {","				(node || instance.get(ROLE_NODE)).set(ROLE, roleName);","","				return true;","			}","","			return false;","		},","","		setRoles: function(roles) {","			var instance = this;","","			A.Array.each(roles, function(role, index, roles) {","				instance.setRole(role.name, role.node);","			});","		},","","		_afterHostAttributeChange: function(event) {","			var instance = this;","","			instance._handleProcessAttribute(event);","		},","","		_afterRoleNameChange: function(event) {","			var instance = this;","","			instance._uiSetRoleName(event.newVal);","		},","","		_bindHostAttributes: function() {","			var instance = this;","			var attributes = instance.get(ATTRIBUTES);","","			A.each(attributes, function(aria, attrName) {","				var ariaAttr = instance._getAriaAttribute(aria, attrName);","","				instance._handleProcessAttribute({ aria: ariaAttr });","","				instance.afterHostEvent(attrName+CHANGE_PREFIX, function(event) {","					event.aria = ariaAttr;","					instance._afterHostAttributeChange(event);","				});","			});","		},","","		_defProcessFn: function(event) {","			var instance = this;","","			instance._setAttribute(event.aria);","		},","","		_getAriaAttribute: function(aria, attrName) {","			var instance = this;","			var attributeValueFormat = instance.get(ATTRIBUTE_VALUE_FORMAT);","			var prepared = {};","","			if (isString(aria)) {","				prepared = A.merge(prepared, {","					ariaName: aria,","					attrName: attrName,","					format: attributeValueFormat,","					node: null","				});","			}","			else if (isObject(aria)) {","				prepared = A.mix(aria, {","					ariaName: EMPTY_STR,","					attrName: attrName,","					format: attributeValueFormat,","					node: null","				});","			}","","			return prepared;","		},","","		_handleProcessAttribute: function(event) {","			var instance = this;","","			instance.fire(EV_PROCESS_ATTRIBUTE, { aria: event.aria });","		},","","		_setAttribute: function(ariaAttr) {","			var instance = this;","			var host = instance.get(HOST);","			var attrValue = host.get(ariaAttr.attrName);","			var attrNode = ariaAttr.node;","","			if (isFunction(attrNode)) {","				attrNode = attrNode.apply(instance, [ariaAttr]);","			}","","			instance.setAttribute(","				ariaAttr.ariaName,","				ariaAttr.format.apply(instance, [attrValue, ariaAttr]),","				attrNode","			);","		},","","		_uiSetRoleName: function(val) {","			var instance = this;","","			instance.setRole(val);","		}","	}","});","","A.Plugin.Aria = Aria;/*","* W3C - The Roles Model","* http://www.w3.org/TR/wai-aria/roles","*/","A.Plugin.Aria.W3C_ROLES = {","	'alert': 1,","	'alertdialog': 1,","	'application': 1,","	'article': 1,","	'banner': 1,","	'button': 1,","	'checkbox': 1,","	'columnheader': 1,","	'combobox': 1,","	'command': 1,","	'complementary': 1,","	'composite': 1,","	'contentinfo': 1,","	'definition': 1,","	'dialog': 1,","	'directory': 1,","	'document': 1,","	'form': 1,","	'grid': 1,","	'gridcell': 1,","	'group': 1,","	'heading': 1,","	'img': 1,","	'input': 1,","	'landmark': 1,","	'link': 1,","	'list': 1,","	'listbox': 1,","	'listitem': 1,","	'log': 1,","	'main': 1,","	'marquee': 1,","	'math': 1,","	'menu': 1,","	'menubar': 1,","	'menuitem': 1,","	'menuitemcheckbox': 1,","	'menuitemradio': 1,","	'navigation': 1,","	'note': 1,","	'option': 1,","	'presentation': 1,","	'progressbar': 1,","	'radio': 1,","	'radiogroup': 1,","	'range': 1,","	'region': 1,","	'roletype': 1,","	'row': 1,","	'rowheader': 1,","	'scrollbar': 1,","	'search': 1,","	'section': 1,","	'sectionhead': 1,","	'select': 1,","	'separator': 1,","	'slider': 1,","	'spinbutton': 1,","	'status': 1,","	'structure': 1,","	'tab': 1,","	'tablist': 1,","	'tabpanel': 1,","	'textbox': 1,","	'timer': 1,","	'toolbar': 1,","	'tooltip': 1,","	'tree': 1,","	'treegrid': 1,","	'treeitem': 1,","	'widget': 1,","	'window': 1","};","/*","* W3C - Supported States and Properties","* http://www.w3.org/TR/wai-aria/states_and_properties","*/","A.Plugin.Aria.W3C_ATTRIBUTES = {","	'activedescendant': 1,","	'atomic': 1,","	'autocomplete': 1,","	'busy': 1,","	'checked': 1,","	'controls': 1,","	'describedby': 1,","	'disabled': 1,","	'dropeffect': 1,","	'expanded': 1,","	'flowto': 1,","	'grabbed': 1,","	'haspopup': 1,","	'hidden': 1,","	'invalid': 1,","	'label': 1,","	'labelledby': 1,","	'level': 1,","	'live': 1,","	'multiline': 1,","	'multiselectable': 1,","	'orientation': 1,","	'owns': 1,","	'posinset': 1,","	'pressed': 1,","	'readonly': 1,","	'relevant': 1,","	'required': 1,","	'selected': 1,","	'setsize': 1,","	'sort': 1,","	'valuemax': 1,","	'valuemin': 1,","	'valuenow': 1,","	'valuetext': 1","};","","}, '2.0.0pr1', {\"requires\": [\"plugin\", \"aui-component\"]});"];
_yuitest_coverage["build/aui-aria/aui-aria.js"].lines = {"1":0,"3":0,"29":0,"30":0,"36":0,"49":0,"58":0,"64":0,"65":0,"66":0,"68":0,"77":0,"91":0,"93":0,"101":0,"105":0,"107":0,"111":0,"113":0,"117":0,"119":0,"123":0,"125":0,"126":0,"128":0,"131":0,"135":0,"137":0,"138":0,"143":0,"145":0,"146":0,"148":0,"151":0,"155":0,"157":0,"158":0,"163":0,"165":0,"169":0,"171":0,"175":0,"176":0,"178":0,"179":0,"181":0,"183":0,"184":0,"185":0,"191":0,"193":0,"197":0,"198":0,"199":0,"201":0,"202":0,"209":0,"210":0,"218":0,"222":0,"224":0,"228":0,"229":0,"230":0,"231":0,"233":0,"234":0,"237":0,"245":0,"247":0,"252":0,"256":0,"334":0};
_yuitest_coverage["build/aui-aria/aui-aria.js"].functions = {"(anonymous 3):29":0,"(anonymous 2):28":0,"value:48":0,"valueFn:57":0,"valueFn:63":0,"valueFn:76":0,"initializer:90":0,"isValidAttribute:110":0,"isValidRole:116":0,"setAttribute:122":0,"(anonymous 4):137":0,"setAttributes:134":0,"setRole:142":0,"(anonymous 5):157":0,"setRoles:154":0,"_afterHostAttributeChange:162":0,"_afterRoleNameChange:168":0,"(anonymous 7):183":0,"(anonymous 6):178":0,"_bindHostAttributes:174":0,"_defProcessFn:190":0,"_getAriaAttribute:196":0,"_handleProcessAttribute:221":0,"_setAttribute:227":0,"_uiSetRoleName:244":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-aria/aui-aria.js"].coveredLines = 73;
_yuitest_coverage["build/aui-aria/aui-aria.js"].coveredFunctions = 26;
_yuitest_coverline("build/aui-aria/aui-aria.js", 1);
YUI.add('aui-aria', function (A, NAME) {

_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-aria/aui-aria.js", 3);
var Lang = A.Lang,
	isBoolean = Lang.isBoolean,
	isFunction = Lang.isFunction,
	isObject = Lang.isObject,
	isString = Lang.isString,

	ATTRIBUTE_VALUE_FORMAT = 'attributeValueFormat',
	ATTRIBUTES = 'attributes',
	ARIA = 'aria',
	ARIA_PREFIX = 'aria-',
	ATTRIBUTE_NODE = 'attributeNode',
	BOUNDING_BOX = 'boundingBox',
	HOST = 'host',
	ROLE = 'role',
	ROLE_NAME = 'roleName',
	ROLE_NODE = 'roleNode',
	VALIDATE_W3C = 'validateW3C',
	CHANGE_PREFIX = 'Change',

	EMPTY_STR = '',
	STR_REGEX = /([^a-z])/ig,

	EV_PROCESS_ATTRIBUTE = 'aria:processAttribute',

	_toAriaRole = A.cached(
		function(str) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 2)", 28);
_yuitest_coverline("build/aui-aria/aui-aria.js", 29);
return str.replace(STR_REGEX, function() {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 3)", 29);
_yuitest_coverline("build/aui-aria/aui-aria.js", 30);
return EMPTY_STR;
			})
			.toLowerCase();
		}
	);

_yuitest_coverline("build/aui-aria/aui-aria.js", 36);
var Aria = A.Component.create({
	NAME: ARIA,

	NS: ARIA,

	ATTRS: {
		attributes: {
			value: {},
			validator: isObject
		},

		attributeValueFormat: {
			value: function(val) {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "value", 48);
_yuitest_coverline("build/aui-aria/aui-aria.js", 49);
return val;
			},
			validator: isFunction
		},

		attributeNode: {
			writeOnce: true,
			setter: A.one,
			valueFn: function() {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "valueFn", 57);
_yuitest_coverline("build/aui-aria/aui-aria.js", 58);
return this.get(HOST).get(BOUNDING_BOX);
			}
		},

		roleName: {
			valueFn: function() {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "valueFn", 63);
_yuitest_coverline("build/aui-aria/aui-aria.js", 64);
var instance = this;
				_yuitest_coverline("build/aui-aria/aui-aria.js", 65);
var host = instance.get(HOST);
				_yuitest_coverline("build/aui-aria/aui-aria.js", 66);
var roleName = _toAriaRole(host.constructor.NAME || EMPTY_STR);

				_yuitest_coverline("build/aui-aria/aui-aria.js", 68);
return (instance.isValidRole(roleName) ? roleName : EMPTY_STR);
			},
			validator: isString
		},

		roleNode: {
			writeOnce: true,
			setter: A.one,
			valueFn: function() {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "valueFn", 76);
_yuitest_coverline("build/aui-aria/aui-aria.js", 77);
return this.get(HOST).get(BOUNDING_BOX);
			}
		},

		validateW3C: {
			value: true,
			validator: isBoolean
		}
	},

	EXTENDS: A.Plugin.Base,

	prototype: {
		initializer: function() {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "initializer", 90);
_yuitest_coverline("build/aui-aria/aui-aria.js", 91);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 93);
instance.publish(EV_PROCESS_ATTRIBUTE, {
	            defaultFn: instance._defProcessFn,
	            queuable: false,
	            emitFacade: true,
	            bubbles: true,
	            prefix: ARIA
	        });

			_yuitest_coverline("build/aui-aria/aui-aria.js", 101);
instance._uiSetRoleName(
				instance.get(ROLE_NAME)
			);

			_yuitest_coverline("build/aui-aria/aui-aria.js", 105);
instance.after('roleNameChange', instance._afterRoleNameChange);

			_yuitest_coverline("build/aui-aria/aui-aria.js", 107);
instance._bindHostAttributes();
		},

		isValidAttribute: function(attrName) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "isValidAttribute", 110);
_yuitest_coverline("build/aui-aria/aui-aria.js", 111);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 113);
return (instance.get(VALIDATE_W3C) ? A.Plugin.Aria.W3C_ATTRIBUTES[attrName] : true);
		},

		isValidRole: function(roleName) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "isValidRole", 116);
_yuitest_coverline("build/aui-aria/aui-aria.js", 117);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 119);
return (instance.get(VALIDATE_W3C) ? A.Plugin.Aria.W3C_ROLES[roleName] : true);
		},

		setAttribute: function(attrName, attrValue, node) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "setAttribute", 122);
_yuitest_coverline("build/aui-aria/aui-aria.js", 123);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 125);
if (instance.isValidAttribute(attrName)) {
				_yuitest_coverline("build/aui-aria/aui-aria.js", 126);
(node || instance.get(ATTRIBUTE_NODE)).set(ARIA_PREFIX+attrName, attrValue);

				_yuitest_coverline("build/aui-aria/aui-aria.js", 128);
return true;
			}

			_yuitest_coverline("build/aui-aria/aui-aria.js", 131);
return false;
		},

		setAttributes: function(attributes) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "setAttributes", 134);
_yuitest_coverline("build/aui-aria/aui-aria.js", 135);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 137);
A.Array.each(attributes, function(attribute, index, attributes) {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 4)", 137);
_yuitest_coverline("build/aui-aria/aui-aria.js", 138);
instance.setAttribute(attribute.name, attribute.value, attribute.node);
			});
		},

		setRole: function(roleName, node) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "setRole", 142);
_yuitest_coverline("build/aui-aria/aui-aria.js", 143);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 145);
if (instance.isValidRole(roleName)) {
				_yuitest_coverline("build/aui-aria/aui-aria.js", 146);
(node || instance.get(ROLE_NODE)).set(ROLE, roleName);

				_yuitest_coverline("build/aui-aria/aui-aria.js", 148);
return true;
			}

			_yuitest_coverline("build/aui-aria/aui-aria.js", 151);
return false;
		},

		setRoles: function(roles) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "setRoles", 154);
_yuitest_coverline("build/aui-aria/aui-aria.js", 155);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 157);
A.Array.each(roles, function(role, index, roles) {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 5)", 157);
_yuitest_coverline("build/aui-aria/aui-aria.js", 158);
instance.setRole(role.name, role.node);
			});
		},

		_afterHostAttributeChange: function(event) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_afterHostAttributeChange", 162);
_yuitest_coverline("build/aui-aria/aui-aria.js", 163);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 165);
instance._handleProcessAttribute(event);
		},

		_afterRoleNameChange: function(event) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_afterRoleNameChange", 168);
_yuitest_coverline("build/aui-aria/aui-aria.js", 169);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 171);
instance._uiSetRoleName(event.newVal);
		},

		_bindHostAttributes: function() {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_bindHostAttributes", 174);
_yuitest_coverline("build/aui-aria/aui-aria.js", 175);
var instance = this;
			_yuitest_coverline("build/aui-aria/aui-aria.js", 176);
var attributes = instance.get(ATTRIBUTES);

			_yuitest_coverline("build/aui-aria/aui-aria.js", 178);
A.each(attributes, function(aria, attrName) {
				_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 6)", 178);
_yuitest_coverline("build/aui-aria/aui-aria.js", 179);
var ariaAttr = instance._getAriaAttribute(aria, attrName);

				_yuitest_coverline("build/aui-aria/aui-aria.js", 181);
instance._handleProcessAttribute({ aria: ariaAttr });

				_yuitest_coverline("build/aui-aria/aui-aria.js", 183);
instance.afterHostEvent(attrName+CHANGE_PREFIX, function(event) {
					_yuitest_coverfunc("build/aui-aria/aui-aria.js", "(anonymous 7)", 183);
_yuitest_coverline("build/aui-aria/aui-aria.js", 184);
event.aria = ariaAttr;
					_yuitest_coverline("build/aui-aria/aui-aria.js", 185);
instance._afterHostAttributeChange(event);
				});
			});
		},

		_defProcessFn: function(event) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_defProcessFn", 190);
_yuitest_coverline("build/aui-aria/aui-aria.js", 191);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 193);
instance._setAttribute(event.aria);
		},

		_getAriaAttribute: function(aria, attrName) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_getAriaAttribute", 196);
_yuitest_coverline("build/aui-aria/aui-aria.js", 197);
var instance = this;
			_yuitest_coverline("build/aui-aria/aui-aria.js", 198);
var attributeValueFormat = instance.get(ATTRIBUTE_VALUE_FORMAT);
			_yuitest_coverline("build/aui-aria/aui-aria.js", 199);
var prepared = {};

			_yuitest_coverline("build/aui-aria/aui-aria.js", 201);
if (isString(aria)) {
				_yuitest_coverline("build/aui-aria/aui-aria.js", 202);
prepared = A.merge(prepared, {
					ariaName: aria,
					attrName: attrName,
					format: attributeValueFormat,
					node: null
				});
			}
			else {_yuitest_coverline("build/aui-aria/aui-aria.js", 209);
if (isObject(aria)) {
				_yuitest_coverline("build/aui-aria/aui-aria.js", 210);
prepared = A.mix(aria, {
					ariaName: EMPTY_STR,
					attrName: attrName,
					format: attributeValueFormat,
					node: null
				});
			}}

			_yuitest_coverline("build/aui-aria/aui-aria.js", 218);
return prepared;
		},

		_handleProcessAttribute: function(event) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_handleProcessAttribute", 221);
_yuitest_coverline("build/aui-aria/aui-aria.js", 222);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 224);
instance.fire(EV_PROCESS_ATTRIBUTE, { aria: event.aria });
		},

		_setAttribute: function(ariaAttr) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_setAttribute", 227);
_yuitest_coverline("build/aui-aria/aui-aria.js", 228);
var instance = this;
			_yuitest_coverline("build/aui-aria/aui-aria.js", 229);
var host = instance.get(HOST);
			_yuitest_coverline("build/aui-aria/aui-aria.js", 230);
var attrValue = host.get(ariaAttr.attrName);
			_yuitest_coverline("build/aui-aria/aui-aria.js", 231);
var attrNode = ariaAttr.node;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 233);
if (isFunction(attrNode)) {
				_yuitest_coverline("build/aui-aria/aui-aria.js", 234);
attrNode = attrNode.apply(instance, [ariaAttr]);
			}

			_yuitest_coverline("build/aui-aria/aui-aria.js", 237);
instance.setAttribute(
				ariaAttr.ariaName,
				ariaAttr.format.apply(instance, [attrValue, ariaAttr]),
				attrNode
			);
		},

		_uiSetRoleName: function(val) {
			_yuitest_coverfunc("build/aui-aria/aui-aria.js", "_uiSetRoleName", 244);
_yuitest_coverline("build/aui-aria/aui-aria.js", 245);
var instance = this;

			_yuitest_coverline("build/aui-aria/aui-aria.js", 247);
instance.setRole(val);
		}
	}
});

_yuitest_coverline("build/aui-aria/aui-aria.js", 252);
A.Plugin.Aria = Aria;/*
* W3C - The Roles Model
* http://www.w3.org/TR/wai-aria/roles
*/
_yuitest_coverline("build/aui-aria/aui-aria.js", 256);
A.Plugin.Aria.W3C_ROLES = {
	'alert': 1,
	'alertdialog': 1,
	'application': 1,
	'article': 1,
	'banner': 1,
	'button': 1,
	'checkbox': 1,
	'columnheader': 1,
	'combobox': 1,
	'command': 1,
	'complementary': 1,
	'composite': 1,
	'contentinfo': 1,
	'definition': 1,
	'dialog': 1,
	'directory': 1,
	'document': 1,
	'form': 1,
	'grid': 1,
	'gridcell': 1,
	'group': 1,
	'heading': 1,
	'img': 1,
	'input': 1,
	'landmark': 1,
	'link': 1,
	'list': 1,
	'listbox': 1,
	'listitem': 1,
	'log': 1,
	'main': 1,
	'marquee': 1,
	'math': 1,
	'menu': 1,
	'menubar': 1,
	'menuitem': 1,
	'menuitemcheckbox': 1,
	'menuitemradio': 1,
	'navigation': 1,
	'note': 1,
	'option': 1,
	'presentation': 1,
	'progressbar': 1,
	'radio': 1,
	'radiogroup': 1,
	'range': 1,
	'region': 1,
	'roletype': 1,
	'row': 1,
	'rowheader': 1,
	'scrollbar': 1,
	'search': 1,
	'section': 1,
	'sectionhead': 1,
	'select': 1,
	'separator': 1,
	'slider': 1,
	'spinbutton': 1,
	'status': 1,
	'structure': 1,
	'tab': 1,
	'tablist': 1,
	'tabpanel': 1,
	'textbox': 1,
	'timer': 1,
	'toolbar': 1,
	'tooltip': 1,
	'tree': 1,
	'treegrid': 1,
	'treeitem': 1,
	'widget': 1,
	'window': 1
};
/*
* W3C - Supported States and Properties
* http://www.w3.org/TR/wai-aria/states_and_properties
*/
_yuitest_coverline("build/aui-aria/aui-aria.js", 334);
A.Plugin.Aria.W3C_ATTRIBUTES = {
	'activedescendant': 1,
	'atomic': 1,
	'autocomplete': 1,
	'busy': 1,
	'checked': 1,
	'controls': 1,
	'describedby': 1,
	'disabled': 1,
	'dropeffect': 1,
	'expanded': 1,
	'flowto': 1,
	'grabbed': 1,
	'haspopup': 1,
	'hidden': 1,
	'invalid': 1,
	'label': 1,
	'labelledby': 1,
	'level': 1,
	'live': 1,
	'multiline': 1,
	'multiselectable': 1,
	'orientation': 1,
	'owns': 1,
	'posinset': 1,
	'pressed': 1,
	'readonly': 1,
	'relevant': 1,
	'required': 1,
	'selected': 1,
	'setsize': 1,
	'sort': 1,
	'valuemax': 1,
	'valuemin': 1,
	'valuenow': 1,
	'valuetext': 1
};

}, '2.0.0pr1', {"requires": ["plugin", "aui-component"]});
