if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-char-counter/aui-char-counter.js",
    code: []
};
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"].code=["YUI.add('aui-char-counter', function (A, NAME) {","","/**"," * The CharCounter Utility"," *"," * @module aui-char-counter"," */","","var L = A.Lang,","	isNumber = L.isNumber,","","	CHAR_COUNTER = 'char-counter',","	COUNTER = 'counter',","	INPUT = 'input',","	MAX_LENGTH = 'maxLength',","	SCROLL_LEFT = 'scrollLeft',","	SCROLL_TOP = 'scrollTop';","","/**"," * <p><img src=\"assets/images/aui-char-counter/main.png\"/></p>"," *"," * A base class for CharCounter, providing:"," * <ul>"," *    <li>Limit the number of characters allowed in an input box</li>"," *    <li>Display the number of characters left</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var instance = new A.CharCounter({"," *  input: '#elementId',"," *  counter: '#counterDisplayId',"," *  maxLength: 10"," * });"," * </code></pre>"," *"," * Check the list of <a href=\"CharCounter.html#configattributes\">Configuration Attributes</a> available for"," * CharCounter."," *"," * @class CharCounter"," * @uses AUI~input~handle"," * @param config {Object} Object literal specifying widget configuration properties."," * @constructor"," * @extends Base"," */","var CharCounter = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property CharCounter.NAME","		 * @type String","		 * @static","		 */","		NAME: CHAR_COUNTER,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the CharCounter.","		 *","		 * @property CharCounter.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * Node or Selector to display the information of the counter.","			 *","			 * @attribute counter","			 * @default null","			 * @type {Node | String}","			 */","			counter: {","				setter: A.one","			},","","			/**","			 * Max number of characters the <a","	         * href=\"CharCounter.html#config_input\">input</a> can have.","			 *","			 * @attribute maxLength","			 * @default Infinity","			 * @type Number","			 */","			maxLength: {","				lazyAdd: false,","				setter: function(v) {","					return this._setMaxLength(v);","				},","				value: Infinity,","				validator: isNumber","			},","","			/**","			 * Node or Selector for the input field. Required.","			 *","			 * @attribute input","			 * @default null","			 * @type {Node | String}","			 */","			input: {","				setter: A.one","			}","		},","","		EXTENDS: A.Base,","","		prototype: {","			/**","			 * Event handler for the input <a","		     * href=\"module_aui-event.html\">aui-event</a> event.","			 *","			 * @property handler","			 * @type EventHandle","			 * @protected","			 */","			handler: null,","","			/**","			 * Construction logic executed during CharCounter instantiation. Lifecycle.","			 *","			 * @method initializer","			 * @protected","			 */","			initializer: function() {","				var instance = this;","","				instance.bindUI();","","				instance.checkLength();","			},","","			/**","			 * Bind the events on the CharCounter UI. Lifecycle.","			 *","			 * @method bindUI","			 * @protected","			 */","			bindUI: function() {","				var instance = this;","				var input = instance.get(INPUT);","","				instance.publish('maxLength');","","				instance.after('maxLengthChange', instance.checkLength);","","				if (input) {","					// use cross browser input-handler event","					instance.handler = input.on(INPUT, A.bind(instance._onInputChange, instance));","				}","			},","","			/**","			 * Sync the CharCounter UI. Lifecycle.","			 *","			 * @method syncUI","			 * @protected","			 */","			syncUI: function() {","				var instance = this;","				var counter = instance.get(COUNTER);","","				if (counter) {","					var value = instance.get(INPUT).val();","","					counter.html(","						instance.get(MAX_LENGTH) - value.length","					);","				}","			},","","			/**","			 * Descructor lifecycle implementation for the CharCounter class.","			 * Purges events attached to the node (and all child nodes).","			 *","			 * @method destroy","			 * @protected","			 */","			destroy: function() {","				var instance = this;","","				if (instance.handler) {","					instance.handler.detach();","				}","			},","","			/**","			 * Check the current value of the <a","		     * href=\"CharCounter.html#config_input\">input</a>, truncate the data if","		     * needed, and re-sync the UI. Fired from <a","		     *  href=\"CharCounter.html#method__onInputChange\">_onInputChange</a>.","			 *","			 * @method checkLength","			 */","			checkLength: function() {","				var instance = this;","				var input = instance.get(INPUT);","				var maxLength = instance.get(MAX_LENGTH);","","				if (!input) {","					return false; // NOTE: return","				}","","				var value = input.val();","				var scrollTop = input.get(SCROLL_TOP);","				var scrollLeft = input.get(SCROLL_LEFT);","","				if (value.length > maxLength) {","					input.val(","						value.substring(0, maxLength)","					);","				}","","				if (value.length == maxLength) {","					instance.fire('maxLength');","				}","","				input.set(SCROLL_TOP, scrollTop);","				input.set(SCROLL_LEFT, scrollLeft);","","				instance.syncUI();","			},","","			/**","			 * Fired on input value change.","			 *","			 * @method _onInputChange","			 * @param {EventFacade} event","			 * @protected","			 */","			_onInputChange: function(event) {","				var instance = this;","","				instance.checkLength();","			},","","			/**","			 * Setter for <a href=\"CharCounter.html#config_maxLength\">maxLength</a>.","			 *","			 * @method _setMaxLength","			 * @param {Number} v Value of the new <a","		     * href=\"CharCounter.html#config_maxLenght\">maxLenght</a>.","			 * @protected","			 * @return {Number}","			 */","			_setMaxLength: function(v) {","				var instance = this;","				var input = instance.get(INPUT);","","				if (input && (v < Infinity)) {","					input.set(MAX_LENGTH, v);","				}","","				return v;","			}","		}","	}",");","","A.CharCounter = CharCounter;","","}, '2.0.0pr1', {\"requires\": [\"aui-node\", \"aui-event-input\", \"aui-component\"]});"];
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"].lines = {"1":0,"9":0,"46":0,"88":0,"126":0,"128":0,"130":0,"140":0,"141":0,"143":0,"145":0,"147":0,"149":0,"160":0,"161":0,"163":0,"164":0,"166":0,"180":0,"182":0,"183":0,"196":0,"197":0,"198":0,"200":0,"201":0,"204":0,"205":0,"206":0,"208":0,"209":0,"214":0,"215":0,"218":0,"219":0,"221":0,"232":0,"234":0,"247":0,"248":0,"250":0,"251":0,"254":0,"260":0};
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"].functions = {"setter:87":0,"initializer:125":0,"bindUI:139":0,"syncUI:159":0,"destroy:179":0,"checkLength:195":0,"_onInputChange:231":0,"_setMaxLength:246":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"].coveredLines = 44;
_yuitest_coverage["build/aui-char-counter/aui-char-counter.js"].coveredFunctions = 9;
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 1);
YUI.add('aui-char-counter', function (A, NAME) {

/**
 * The CharCounter Utility
 *
 * @module aui-char-counter
 */

_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 9);
var L = A.Lang,
	isNumber = L.isNumber,

	CHAR_COUNTER = 'char-counter',
	COUNTER = 'counter',
	INPUT = 'input',
	MAX_LENGTH = 'maxLength',
	SCROLL_LEFT = 'scrollLeft',
	SCROLL_TOP = 'scrollTop';

/**
 * <p><img src="assets/images/aui-char-counter/main.png"/></p>
 *
 * A base class for CharCounter, providing:
 * <ul>
 *    <li>Limit the number of characters allowed in an input box</li>
 *    <li>Display the number of characters left</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var instance = new A.CharCounter({
 *  input: '#elementId',
 *  counter: '#counterDisplayId',
 *  maxLength: 10
 * });
 * </code></pre>
 *
 * Check the list of <a href="CharCounter.html#configattributes">Configuration Attributes</a> available for
 * CharCounter.
 *
 * @class CharCounter
 * @uses AUI~input~handle
 * @param config {Object} Object literal specifying widget configuration properties.
 * @constructor
 * @extends Base
 */
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 46);
var CharCounter = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property CharCounter.NAME
		 * @type String
		 * @static
		 */
		NAME: CHAR_COUNTER,

		/**
		 * Static property used to define the default attribute
		 * configuration for the CharCounter.
		 *
		 * @property CharCounter.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * Node or Selector to display the information of the counter.
			 *
			 * @attribute counter
			 * @default null
			 * @type {Node | String}
			 */
			counter: {
				setter: A.one
			},

			/**
			 * Max number of characters the <a
	         * href="CharCounter.html#config_input">input</a> can have.
			 *
			 * @attribute maxLength
			 * @default Infinity
			 * @type Number
			 */
			maxLength: {
				lazyAdd: false,
				setter: function(v) {
					_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "setter", 87);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 88);
return this._setMaxLength(v);
				},
				value: Infinity,
				validator: isNumber
			},

			/**
			 * Node or Selector for the input field. Required.
			 *
			 * @attribute input
			 * @default null
			 * @type {Node | String}
			 */
			input: {
				setter: A.one
			}
		},

		EXTENDS: A.Base,

		prototype: {
			/**
			 * Event handler for the input <a
		     * href="module_aui-event.html">aui-event</a> event.
			 *
			 * @property handler
			 * @type EventHandle
			 * @protected
			 */
			handler: null,

			/**
			 * Construction logic executed during CharCounter instantiation. Lifecycle.
			 *
			 * @method initializer
			 * @protected
			 */
			initializer: function() {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "initializer", 125);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 126);
var instance = this;

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 128);
instance.bindUI();

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 130);
instance.checkLength();
			},

			/**
			 * Bind the events on the CharCounter UI. Lifecycle.
			 *
			 * @method bindUI
			 * @protected
			 */
			bindUI: function() {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "bindUI", 139);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 140);
var instance = this;
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 141);
var input = instance.get(INPUT);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 143);
instance.publish('maxLength');

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 145);
instance.after('maxLengthChange', instance.checkLength);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 147);
if (input) {
					// use cross browser input-handler event
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 149);
instance.handler = input.on(INPUT, A.bind(instance._onInputChange, instance));
				}
			},

			/**
			 * Sync the CharCounter UI. Lifecycle.
			 *
			 * @method syncUI
			 * @protected
			 */
			syncUI: function() {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "syncUI", 159);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 160);
var instance = this;
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 161);
var counter = instance.get(COUNTER);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 163);
if (counter) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 164);
var value = instance.get(INPUT).val();

					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 166);
counter.html(
						instance.get(MAX_LENGTH) - value.length
					);
				}
			},

			/**
			 * Descructor lifecycle implementation for the CharCounter class.
			 * Purges events attached to the node (and all child nodes).
			 *
			 * @method destroy
			 * @protected
			 */
			destroy: function() {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "destroy", 179);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 180);
var instance = this;

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 182);
if (instance.handler) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 183);
instance.handler.detach();
				}
			},

			/**
			 * Check the current value of the <a
		     * href="CharCounter.html#config_input">input</a>, truncate the data if
		     * needed, and re-sync the UI. Fired from <a
		     *  href="CharCounter.html#method__onInputChange">_onInputChange</a>.
			 *
			 * @method checkLength
			 */
			checkLength: function() {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "checkLength", 195);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 196);
var instance = this;
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 197);
var input = instance.get(INPUT);
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 198);
var maxLength = instance.get(MAX_LENGTH);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 200);
if (!input) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 201);
return false; // NOTE: return
				}

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 204);
var value = input.val();
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 205);
var scrollTop = input.get(SCROLL_TOP);
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 206);
var scrollLeft = input.get(SCROLL_LEFT);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 208);
if (value.length > maxLength) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 209);
input.val(
						value.substring(0, maxLength)
					);
				}

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 214);
if (value.length == maxLength) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 215);
instance.fire('maxLength');
				}

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 218);
input.set(SCROLL_TOP, scrollTop);
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 219);
input.set(SCROLL_LEFT, scrollLeft);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 221);
instance.syncUI();
			},

			/**
			 * Fired on input value change.
			 *
			 * @method _onInputChange
			 * @param {EventFacade} event
			 * @protected
			 */
			_onInputChange: function(event) {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "_onInputChange", 231);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 232);
var instance = this;

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 234);
instance.checkLength();
			},

			/**
			 * Setter for <a href="CharCounter.html#config_maxLength">maxLength</a>.
			 *
			 * @method _setMaxLength
			 * @param {Number} v Value of the new <a
		     * href="CharCounter.html#config_maxLenght">maxLenght</a>.
			 * @protected
			 * @return {Number}
			 */
			_setMaxLength: function(v) {
				_yuitest_coverfunc("build/aui-char-counter/aui-char-counter.js", "_setMaxLength", 246);
_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 247);
var instance = this;
				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 248);
var input = instance.get(INPUT);

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 250);
if (input && (v < Infinity)) {
					_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 251);
input.set(MAX_LENGTH, v);
				}

				_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 254);
return v;
			}
		}
	}
);

_yuitest_coverline("build/aui-char-counter/aui-char-counter.js", 260);
A.CharCounter = CharCounter;

}, '2.0.0pr1', {"requires": ["aui-node", "aui-event-input", "aui-component"]});
