if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-node-base/aui-node-base.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-node-base/aui-node-base.js",
    code: []
};
_yuitest_coverage["build/aui-node-base/aui-node-base.js"].code=["YUI.add('aui-node-base', function (A, NAME) {","","/**"," * aui-node-base A set of utility methods to the Node."," *"," * @module aui-node"," * @submodule aui-node-base"," */","","var Lang = A.Lang,","	isArray = Lang.isArray,","	isFunction = Lang.isFunction,","	isObject = Lang.isObject,","	isString = Lang.isString,","	isUndefined = Lang.isUndefined,","	isValue = Lang.isValue,","","	AArray = A.Array,","	ANode = A.Node,","	ANodeList = A.NodeList,","","	getClassName = A.getClassName,","	getRegExp = A.DOM._getRegExp,","","	prefix = Lang.String.prefix,","","	CONFIG = A.config,","	DOC = CONFIG.doc,","	WIN = CONFIG.win,","","	NODE_PROTO = ANode.prototype,","	NODELIST_PROTO = ANodeList.prototype,","","	STR_EMPTY = '',","","	ARRAY_EMPTY_STRINGS = [STR_EMPTY, STR_EMPTY],","","	OFFSET = 'offset',","","	CSS_FORCE_OFFSET = getClassName('force', OFFSET),","	CSS_HIDE = getClassName('hide'),","	CSS_UNSELECTABLE = getClassName('unselectable'),","","	CHILD_NODES = 'childNodes',","	CREATE_DOCUMENT_FRAGMENT = 'createDocumentFragment',","	INNER = 'inner',","	INNER_HTML = 'innerHTML',","	NEXT_SIBLING = 'nextSibling',","	NONE = 'none',","	OUTER = 'outer',","	PARENT_NODE = 'parentNode',","	REGION = 'region',","	SCRIPT = 'script',","","	SUPPORT_CLONED_EVENTS = false,","","	VALUE = 'value',","","	MAP_BORDER = {","		b: 'borderBottomWidth',","		l: 'borderLeftWidth',","		r: 'borderRightWidth',","		t: 'borderTopWidth'","	},","	MAP_MARGIN = {","		b: 'marginBottom',","		l: 'marginLeft',","		r: 'marginRight',","		t: 'marginTop'","	},","	MAP_PADDING = {","		b: 'paddingBottom',","		l: 'paddingLeft',","		r: 'paddingRight',","		t: 'paddingTop'","	},","","	prefixSelector = function(ns, id) {","		return '#' + prefix(ns, id);","	},","","	formatSelectorNS = function(ns, selector) {","		return selector.replace(getRegExp('(#|\\\\[id=(\\\\\\\"|\\\\\\'))(?!' + ns + ')', 'g'), '$1' + ns);","	};","","	/*","		Parts of this file are used from jQuery (http://jquery.com)","		Dual-licensed under MIT/GPL","	*/","	var div = DOC.createElement('div');","","	div.style.display = 'none';","	div.innerHTML = '   <table></table>&nbsp;';","","	if (div.attachEvent && div.fireEvent) {","		div.attachEvent(","			'onclick',","			function(){","				SUPPORT_CLONED_EVENTS = true;","","				div.detachEvent('onclick', arguments.callee);","			}","		);","","		div.cloneNode(true).fireEvent('onclick');","	}","","	var SUPPORT_OPTIONAL_TBODY = !div.getElementsByTagName('tbody').length;","","	var REGEX_LEADING_WHITE_SPACE = /^\\s+/,","		REGEX_IE8_ACTION = /=([^=\\x27\\x22>\\s]+\\/)>/g,","		REGEX_TAGNAME = /<([\\w:]+)/;","","	div = null;","","	ANode.cssId = prefixSelector;","","	ANode.formatSelectorNS = formatSelectorNS;","","	var _setUnselectable = function(element, unselectable, noRecurse) {","		var descendants,","			value = unselectable ? 'on' : '';","","		element.setAttribute('unselectable', value);","","		if (!noRecurse) {","			descendants = element.getElementsByTagName('*');","","			for (var i = 0, descendant; descendant = descendants[i]; i++) {","				descendant.setAttribute('unselectable', value);","			}","		}","	};","","/**"," * Augment the <a href=\"Node.html\">YUI3 Node</a> with more util methods."," *"," * Check the list of <a href=\"Node.html#methods\">Methods</a> available for"," * AUI Node."," *"," * @class A.Node"," * @constructor"," * @uses Node"," */","A.mix(NODE_PROTO, {","	allNS: function(ns, selector) {","		var instance = this;","","		return instance.all(formatSelectorNS(ns, selector));","	},","","	/**","	 * <p>Returns the current ancestors of the node element. If a selector is","	 * specified, the ancestors are filtered to match the selector.</p>","	 *","	 * Example:","	 *","	 * <pre><code>","	 * A.one('#nodeId').ancestors('div');","	 * </code></pre>","	 *","	 * @method ancestors","	 * @param {String} selector A selector to filter the ancestor elements against.","	 * @return {NodeList}","	 */","	ancestors: function(selector) {","		var instance = this;","","		var ancestors = [];","		var currentEl = instance.getDOM();","","		while (currentEl && currentEl.nodeType !== 9) {","			if (currentEl.nodeType === 1) {","				ancestors.push(currentEl);","			}","","			currentEl = currentEl.parentNode;","		}","","		var nodeList = new A.all(ancestors);","","		if (selector) {","			nodeList = nodeList.filter(selector);","		}","","		return nodeList;","	},","","	/**","	 * <p>Returns the current ancestors of the node element filtered by a className.","	 * This is an optimized method for finding ancestors by a specific CSS class name.</p>","	 *","	 * Example:","	 *","	 * <pre><code>","	 * A.one('#nodeId').ancestorsByClassName('aui-hide');","	 * </code></pre>","	 *","	 * @method ancestors","	 * @param {String} selector A selector to filter the ancestor elements against.","	 * @return {NodeList}","	 */","	ancestorsByClassName: function(className) {","		var instance = this;","","		var ancestors = [];","		var cssRE = new RegExp('\\\\b' + className + '\\\\b');","		var currentEl = instance.getDOM();","","		while (currentEl && currentEl.nodeType !== 9) {","			if (currentEl.nodeType === 1 && cssRE.test(currentEl.className)) {","				ancestors.push(currentEl);","			}","","			currentEl = currentEl.parentNode;","		}","","		return A.all(ancestors);","	},","","	/**","	 * <p>Insert the node instance to the end of the <code>selector</code>","	 * element.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * // using another Node instance","	 * var body = A.one('body');","	 * node.appendTo(body);","	 * // using a CSS selector","	 * node.appendTo('#container');","	 * </code></pre>","	 *","	 * @method appendTo","	 * @chainable","	 * @param {Node | String} selector A selector, element, HTML string, Node","	 * @return {String}","	 */","	appendTo: function(selector) {","		var instance = this;","","		A.one(selector).append(instance);","","		return instance;","	},","","	/**","	 * <p>Get or Set the value of an attribute for the first element in the","	 * set of matched elements. If only the <code>name</code> is passed it","	 * works as a getter.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.attr('title', 'Setting a new title attribute');","	 * // Alert the value of the title attribute: 'Setting a new title attribute'","	 * alert( node.attr('title') );","	 * </code></pre>","	 *","	 * @method attr","	 * @param {String} name The name of the attribute","	 * @param {String} value The value of the attribute to be set. Optional.","	 * @return {String}","	 */","	attr: function(name, value) {","		var instance = this;","","		if (!isUndefined(value)) {","			var el = instance.getDOM();","","			if (name in el) {","				instance.set(name, value);","			}","			else {","				instance.setAttribute(name, value);","			}","","			return instance;","		}","		else {","			if (isObject(name)) {","				for (var i in name) {","					instance.attr(i, name[i]);","				}","","				return instance;","			}","","			var currentValue = instance.get(name);","","			if (!Lang.isValue(currentValue)) {","				currentValue = instance.getAttribute(name);","			}","","			return currentValue;","		}","	},","","	/**","	 * Normalizes the behavior of cloning a node, which by default should not clone","	 * the events that are attached to it.","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.clone().appendTo('body');","	 * </code></pre>","	 *","	 * @method clone","	 * @return {Node}","	 */","	clone: (function() {","		var clone;","","		if (SUPPORT_CLONED_EVENTS) {","			clone = function() {","				var el = this.getDOM();","				var clone;","","				if (el.nodeType != 3) {","					var outerHTML = this.outerHTML();","","					outerHTML = outerHTML.replace(REGEX_IE8_ACTION, '=\"$1\">').replace(REGEX_LEADING_WHITE_SPACE, STR_EMPTY);","","					clone = ANode.create(outerHTML);","				}","				else {","					clone = A.one(el.cloneNode());","				}","","				return clone;","			};","		}","		else {","			clone = function() {","				return this.cloneNode(true);","			};","		}","","		return clone;","	})(),","","	/**","	 * <p>Centralize the current Node instance with the passed","	 * <code>val</code> Array, Node, String, or Region, if not specified, the body will be","	 * used.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * // Center the <code>node</code> with the <code>#container</code>.","	 * node.center('#container');","	 * </code></pre>","	 *","	 * @method center","	 * @chainable","	 * @param {Array | Node | Region | String} val Array, Node, String, or Region to center with","	 */","	center: function(val) {","		var instance = this,","			nodeRegion = instance.get(REGION),","			x,","			y;","","		if (isArray(val)) {","			x = val[0];","			y = val[1];","		}","		else {","			var region;","","			if (isObject(val) && !A.instanceOf(val, ANode)) {","				region = val;","			}","			else {","				region = (A.one(val) || A.getBody()).get(REGION);","			}","","			x = region.left + (region.width / 2);","			y = region.top + (region.height / 2);","		}","","		instance.setXY([x - (nodeRegion.width / 2), y - (nodeRegion.height / 2)]);","	},","","	/**","	 * <p>This method removes not only child (and other descendant) elements,","	 * but also any text within the set of matched elements. This is because,","	 * according to the DOM specification, any string of text within an element","	 * is considered a child node of that element.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.empty();","	 * </code></pre>","	 *","	 * @method empty","	 * @chainable","	 */","	empty: function() {","		var instance = this;","","		instance.all('>*').remove().purge();","","		var el = ANode.getDOMNode(instance);","","		while (el.firstChild) {","			el.removeChild(el.firstChild);","		}","","		return instance;","	},","","	/**","	 * Retrieves the DOM node bound to a Node instance. See","	 * <a href=\"Node.html#method_getDOMNode\">getDOMNode</a>.","	 *","	 * @method getDOM","	 * @return {HTMLNode} The DOM node bound to the Node instance.","	 */","	getDOM: function() {","		var instance = this;","","		return ANode.getDOMNode(instance);","	},","","	/**","	 * Return the combined width of the border for the specified sides.","	 *","	 * @method getBorderWidth","	 * @param {string} sides Can be t, r, b, l or any combination of","	 * those to represent the top, right, bottom, or left sides.","	 * @return {number}","	 */","	getBorderWidth: function(sides) {","		var instance = this;","","		return instance._getBoxStyleAsNumber(sides, MAP_BORDER);","	},","","	/**","	 * Gets the current center position of the node in page coordinates.","	 * @method getCenterXY","	 * @for Node","	 * @return {Array} The XY position of the node","	*/","	getCenterXY: function() {","		var instance = this;","		var region = instance.get(REGION);","","		return [(region.left + region.width/2), (region.top + region.height/2)];","	},","","	/**","	 * Return the combined size of the margin for the specified sides.","	 *","	 * @method getMargin","	 * @param {string} sides Can be t, r, b, l or any combination of","	 * those to represent the top, right, bottom, or left sides.","	 * @return {number}","	 */","	getMargin: function(sides) {","		var instance = this;","","		return instance._getBoxStyleAsNumber(sides, MAP_MARGIN);","	},","","	/**","	 * Return the combined width of the border for the specified sides.","	 *","	 * @method getPadding","	 * @param {string} sides Can be t, r, b, l or any combination of","	 * those to represent the top, right, bottom, or left sides.","	 * @return {number}","	 */","	getPadding: function(sides) {","		var instance = this;","","		return instance._getBoxStyleAsNumber(sides, MAP_PADDING);","	},","","	/**","	 * Set the id of the Node instance if the object does not have one. The","	 * generated id is based on a guid created by the","	 * <a href=\"YUI.html#method_stamp\">stamp</a> method.","	 *","	 * @method guid","	 * @param {string} prefix optional guid prefix","	 * @return {String} The current id of the node","	 */","	guid: function(prefix) {","		var instance = this;","		var currentId = instance.get('id');","","		if (!currentId) {","			currentId = A.stamp(instance);","","			instance.set('id', currentId);","		}","","		return currentId;","	},","","	/**","	 * Create a hover interaction.","	 *","	 * @method hover","	 * @param {string} overFn","	 * @param {string} outFn","	 * @return {Node} The current Node instance","	 */","	hover: function(overFn, outFn) {","		var instance = this;","","		var hoverOptions;","		var defaultHoverOptions = instance._defaultHoverOptions;","","		if (isObject(overFn, true)) {","			hoverOptions = overFn;","","			hoverOptions = A.mix(hoverOptions, defaultHoverOptions);","","			overFn = hoverOptions.over;","			outFn = hoverOptions.out;","		}","		else {","			hoverOptions = A.mix(","				{","					over: overFn,","					out: outFn","				},","				defaultHoverOptions","			);","		}","","		instance._hoverOptions = hoverOptions;","","		hoverOptions.overTask = A.debounce(instance._hoverOverTaskFn, null, instance);","		hoverOptions.outTask = A.debounce(instance._hoverOutTaskFn, null, instance);","","		return new A.EventHandle(","			[","				instance.on(hoverOptions.overEventType, instance._hoverOverHandler, instance),","				instance.on(hoverOptions.outEventType, instance._hoverOutHandler, instance)","			]","		);","	},","","	/**","	 * <p>Get or Set the HTML contents of the node. If the <code>value</code>","	 * is passed it's set the content of the element, otherwise it works as a","	 * getter for the current content.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.html('Setting new HTML');","	 * // Alert the value of the current content","	 * alert( node.html() );","	 * </code></pre>","	 *","	 * @method html","	 * @param {string} value A string of html to set as the content of the node instance.","	 */","	html: function() {","		var args = arguments, length = args.length;","","		if (length) {","			this.set(INNER_HTML, args[0]);","		}","		else {","			return this.get(INNER_HTML);","		}","","		return this;","	},","","	oneNS: function(ns, selector) {","		var instance = this;","","		return instance.one(formatSelectorNS(ns, selector));","	},","","	/**","	 * Gets the outerHTML of a node, which islike innerHTML, except that it","	 * actually contains the HTML of the node itself.","	 *","	 * @return {string} The outerHTML of the given element.","	 */","	outerHTML: function() {","		var instance = this;","		var domEl = instance.getDOM();","","		// IE, Opera and WebKit all have outerHTML.","		if ('outerHTML' in domEl) {","			return domEl.outerHTML;","		}","","		var temp = ANode.create('<div></div>').append(","			this.clone()","		);","","		try {","			return temp.html();","		}","		catch(e) {}","		finally {","			temp = null;","		}","	},","","	/**","	 * <p>Inserts a <code>newNode</code> after the node instance (i.e., as the next","	 * sibling). If the reference node has no parent, then does nothing.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var titleNode = A.one('#titleNode');","	 * var descriptionNode = A.one('#descriptionNode');","	 * // the description is usually shown after the title","	 * titleNode.placeAfter(descriptionNode);","	 * </code></pre>","	 *","	 * @method placeAfter","	 * @chainable","	 * @param {Node} newNode Node to insert.","	 */","	placeAfter: function(newNode) {","		var instance = this;","","		return instance._place(newNode, instance.get(NEXT_SIBLING));","	},","","	/**","	 * <p>Inserts a <code>newNode</code> before the node instance (i.e., as the previous","	 * sibling). If the reference node has no parent, then does nothing.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var descriptionNode = A.one('#descriptionNode');","	 * var titleNode = A.one('#titleNode');","	 * // the title is usually shown before the description","	 * descriptionNode.placeBefore(titleNode);","	 * </code></pre>","	 *","	 * @method placeBefore","	 * @chainable","	 * @param {Node} newNode Node to insert.","	 */","	placeBefore: function(newNode) {","		var instance = this;","","		return instance._place(newNode, instance);","	},","","	/**","	 * <p>Inserts the node instance to the begining of the <code>selector</code>","	 * node (i.e., insert before the <code>firstChild</code> of the","	 * <code>selector</code>).</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.prependTo('body');","	 * </code></pre>","	 *","	 * @method prependTo","	 * @chainable","	 * @param {Node | String} selector A selector, element, HTML string, Node","	 */","	prependTo: function(selector) {","		var instance = this;","","		A.one(selector).prepend(instance);","","		return instance;","	},","","	/**","	 * Add one or more CSS classes to an element and remove the class(es)","	 * from the siblings of the element.","	 *","	 * @method radioClass","	 * @chainable","	 * @param {String} cssClass","	 */","	radioClass: function(cssClass) {","		var instance = this;","","		var siblings = instance.siblings();","","		if (isString(cssClass)) {","			siblings.removeClass(cssClass);","","			instance.addClass(cssClass);","		}","		else if (isArray(cssClass)) {","			var siblingNodes = siblings.getDOM();","","			var regex = getRegExp('(?:^|\\\\s+)(?:' + cssClass.join('|') + ')(?=\\\\s+|$)', 'g');","			var node;","","			for (var i = siblingNodes.length - 1; i >= 0; i--) {","				node = siblingNodes[i];","				node.className = node.className.replace(regex, '');","			}","","			instance.addClass(cssClass.join(' '));","		}","","		return instance;","	},","","	/**","	 * Generate an unique identifier and reset the id attribute of the node","	 * instance using the new value. Invokes the","	 * <a href=\"Node.html#method_guid\">guid</a>.","	 *","	 * @method resetId","	 * @chainable","	 * @param {String} prefix Optional prefix for the guid.","	 */","	resetId: function(prefix) {","		var instance = this;","","		instance.attr('id', A.guid(prefix));","","		return instance;","	},","","	/**","	 * Selects a substring of text inside of the input element.","	 *","	 * @method selectText","	 * @param {Number} start The index to start the selection range from","	 * @param {Number} end The index to end the selection range at","	 */","	selectText: function(start, end) {","		var instance = this;","","		var textField = instance.getDOM();","		var length = instance.val().length;","","		end = isValue(end) ? end : length;","		start = isValue(start) ? start : 0;","","		// Some form elements could throw a (NS_ERROR_FAILURE)","		// [nsIDOMNSHTMLInputElement.setSelectionRange] error when invoke the","		// setSelectionRange on firefox. Wrapping in a try/catch to prevent the error be thrown","		try {","			if (textField.setSelectionRange) {","				textField.setSelectionRange(start, end);","			}","			else if (textField.createTextRange) {","				var range = textField.createTextRange();","","				range.moveStart('character', start);","				range.moveEnd('character', end - length);","","				range.select();","			}","			else {","				textField.select();","			}","","			if (textField != DOC.activeElement) {","				textField.focus();","			}","		}","		catch(e) {}","","		return instance;","	},","","	/**","	 * Enables text selection for this element (normalized across browsers).","	 *","	 * @method selectable","	 * @chainable","	 */","	selectable: function(noRecurse) {","		var instance = this;","","		instance.removeClass(CSS_UNSELECTABLE);","","		if (A.UA.ie || A.UA.opera) {","			_setUnselectable(instance._node, false, noRecurse);","		}","","		return instance;","	},","","	/**","	 * <p>Stops the specified event(s) from bubbling and optionally prevents the","	 * default action.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var anchor = A.one('a#anchorId');","	 * anchor.swallowEvent('click');","	 * </code></pre>","	 *","	 * @method swallowEvent","	 * @chainable","	 * @param {String/Array} eventName an event or array of events to stop from bubbling","	 * @param {Boolean} preventDefault (optional) true to prevent the default action too","	 */","	swallowEvent: function(eventName, preventDefault) {","		var instance = this;","","		var fn = function(event) {","			event.stopPropagation();","","			if (preventDefault) {","				event.preventDefault();","","				event.halt();","			}","","			return false;","		};","","		if(isArray(eventName)) {","			AArray.each(","				eventName,","				function(name) {","					instance.on(name, fn);","				}","			);","","			return this;","		}","		else {","			instance.on(eventName, fn);","		}","","		return instance;","	},","","	/**","	 * <p>Get or Set the combined text contents of the node instance,","	 * including it's descendants. If the <code>text</code>","	 * is passed it's set the content of the element, otherwise it works as a","	 * getter for the current content.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var node = A.one('#nodeId');","	 * node.text('Setting new text content');","	 * // Alert the value of the current content","	 * alert( node.text() );","	 * </code></pre>","	 *","	 * @method text","	 * @param {String} text A string of text to set as the content of the node instance.","	 */","	text: function(text) {","		var instance = this;","		var el = instance.getDOM();","","		if (!isUndefined(text)) {","			text = A.DOM._getDoc(el).createTextNode(text);","","			return instance.empty().append(text);","		}","","		return instance._getText(el.childNodes);","	},","","	/**","	 * <p>Displays or hide the node instance.</p>","	 *","	 * <p><string>NOTE:</string> This method assume that your node were hidden","	 * because of the 'aui-hide' css class were being used. This won't","	 * manipulate the inline <code>style.display</code> property.</p>","	 *","	 * @method toggle","	 * @chainable","	 * @param {Boolean} on Whether to force the toggle. Optional.","	 * @param {Function} callback A function to run after the visibility change. Optional.","	 */","	toggle: function(on, callback) {","		var instance = this;","","		instance._toggleView.apply(instance, arguments);","","		return instance;","	},","","	/**","	 * Disables text selection for this element (normalized across browsers).","	 *","	 * @method unselectable","	 * @chainable","	 */","	unselectable: function(noRecurse) {","		var instance = this;","","		instance.addClass(CSS_UNSELECTABLE);","","		if (A.UA.ie || A.UA.opera) {","			_setUnselectable(instance._node, true, noRecurse);","		}","","		return instance;","	},","","	/**","	 * <p>Get or Set the value attribute of the node instance. If the","	 * <code>value</code> is passed it's set the value of the element,","	 * otherwise it works as a getter for the current value.</p>","	 *","	 * Example:","	 *","	 * <pre><code>var input = A.one('#inputId');","	 * input.val('Setting new input value');","	 * // Alert the value of the input","	 * alert( input.val() );","	 * </code></pre>","	 *","	 * @method val","	 * @param {string} value Value to be set. Optional.","	 */","	val: function(value) {","		var instance = this;","","		if (isUndefined(value)) {","			return instance.get(VALUE);","		}","		else {","			return instance.set(VALUE, value);","		}","	},","","	/**","	 * Return the combined size of the box style for the specified sides.","	 *","	 * @method _getBoxStyleAsNumber","	 * @param {string} sides Can be t, r, b, l or any combination of","	 * those to represent the top, right, bottom, or left sides.","	 * @param {string} map An object mapping mapping the \"sides\" param to the a CSS value to retrieve","	 * @return {number}","	 */","	_getBoxStyleAsNumber: function(sides, map) {","		var instance = this;","","		var sidesArray = sides.match(/\\w/g);","		var value = 0;","		var side;","		var sideKey;","","		for (var i = sidesArray.length - 1; i >= 0; i--) {","			sideKey = sidesArray[i];","			side = 0;","","			if (sideKey) {","				side = parseFloat(instance.getComputedStyle(map[sideKey]));","				side = Math.abs(side);","","				value += side || 0;","			}","		}","","		return value;","	},","","	/**","	 * Extract text content from the passed nodes.","	 *","	 * @method _getText","	 * @private","	 * @param {Native NodeList} childNodes","	 */","	_getText: function(childNodes) {","		var instance = this;","","		var length = childNodes.length;","		var childNode;","","		var str = [];","","		for (var i = 0; i < length; i++) {","			childNode = childNodes[i];","","			if (childNode && childNode.nodeType != 8) {","				if (childNode.nodeType != 1) {","					str.push(childNode.nodeValue);","				}","","				if (childNode.childNodes) {","					str.push(instance._getText(childNode.childNodes));","				}","			}","		}","","		return str.join(STR_EMPTY);","	},","","	/**","	 * The event handler for the \"out\" function that is fired for events attached via the hover method.","	 *","	 * @method _hoverOutHandler","	 * @private","	 * @param {EventFacade} event","	 */","	_hoverOutHandler: function(event) {","		var instance = this;","","		var hoverOptions = instance._hoverOptions;","","		hoverOptions.outTask.delay(hoverOptions.outDelay, event);","	},","","	/**","	 * The event handler for the \"over\" function that is fired for events attached via the hover method.","	 *","	 * @method _hoverOverHandler","	 * @private","	 * @param {EventFacade} event","	 */","	_hoverOverHandler: function(event) {","		var instance = this;","","		var hoverOptions = instance._hoverOptions;","","		hoverOptions.overTask.delay(hoverOptions.overDelay, event);","	},","","	/**","	 * Cancels the over task, and fires the users custom \"out\" function for the hover method","	 *","	 * @method _hoverOverHandler","	 * @private","	 * @param {EventFacade} event","	 */","	_hoverOutTaskFn: function(event) {","		var instance = this;","","		var hoverOptions = instance._hoverOptions;","","		hoverOptions.overTask.cancel();","","		hoverOptions.out.apply(hoverOptions.context || event.currentTarget, arguments);","	},","","	/**","	 * Cancels the out task, and fires the users custom \"over\" function for the hover method","	 *","	 * @method _hoverOverHandler","	 * @private","	 * @param {EventFacade} event","	 */","	_hoverOverTaskFn: function(event) {","		var instance = this;","","		var hoverOptions = instance._hoverOptions;","","		hoverOptions.outTask.cancel();","","		hoverOptions.over.apply(hoverOptions.context || event.currentTarget, arguments);","	},","","	/**","	 * Place a node or html string at a specific location","	 *","	 * @method _place","	 * @private","	 * @param {Node|String} newNode","	 * @param {Node} refNode","	 */","	_place: function(newNode, refNode) {","		var instance = this;","","		var parent = instance.get(PARENT_NODE);","","		if (parent) {","			if (isString(newNode)) {","				newNode = ANode.create(newNode);","			}","","			parent.insertBefore(newNode, refNode);","		}","","		return instance;","	},","","	_defaultHoverOptions: {","		overEventType: 'mouseenter',","		outEventType: 'mouseleave',","		overDelay: 0,","		outDelay: 0,","		over: Lang.emptyFn,","		out: Lang.emptyFn","	}","}, true);","","NODE_PROTO.__show = NODE_PROTO._show;","NODE_PROTO.__hide = NODE_PROTO._hide;","NODE_PROTO.__isHidden = NODE_PROTO._isHidden;","","NODE_PROTO._isHidden = function() {","	var instance = this;","","	return NODE_PROTO.__isHidden.call(instance) || instance.hasClass(instance._hideClass || CSS_HIDE);","};","/**"," * <p>Hide the node adding a css class on it. If <code>cssClass</code> is not"," * passed as argument, the className 'aui-hide' will be used by"," * default.</p>"," *"," * <p><string>NOTE:</string> This method assume that your node were visible"," * because the absence of 'aui-hide' css class. This won't"," * manipulate the inline <code>style.display</code> property.</p>"," *"," * @method hide"," * @chainable"," * @param {string} cssClass Class name to hide the element. Optional."," */","NODE_PROTO._hide = function() {","	var instance = this;","","	instance.addClass(instance._hideClass || CSS_HIDE);","","	return instance;","};","","/**"," * <p>Show the node removing a css class used to hide it. Use the same"," * className added using the <a href=\"A.Node.html#method_hide\">hide</a>"," * method. If <code>cssClass</code> is not passed as argument, the"," * className 'aui-hide' will be used by default.</p>"," *"," * <p><string>NOTE:</string> This method assume that your node were hidden"," * because of the 'aui-hide' css class were being used. This won't"," * manipulate the inline <code>style.display</code> property.</p>"," *"," * @method show"," * @chainable"," * @param {string} cssClass Class name to hide the element. Optional."," */","NODE_PROTO._show = function() {","	var instance = this;","","	instance.removeClass(instance._hideClass || CSS_HIDE);","","	return instance;","};","","/**"," * Returns the width of the content, not including"," * the padding, border or margin. If a width is passed,"," * the node's overall width is set to that size."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.width(); //returns content width"," * node.width(100); // sets box width"," * </code></pre>"," *"," * @method width"," * @return {number}"," */","","/**"," * Returns the height of the content, not including"," * the padding, border or margin. If a height is passed,"," * the node's overall height is set to that size."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.height(); //returns content height"," * node.height(100); // sets box height"," * </code></pre>"," *"," * @method height"," * @return {number}"," */","","/**"," * Returns the size of the box from inside of the border,"," * which is the offsetWidth plus the padding on the left and right."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.innerWidth();"," * </code></pre>"," *"," * @method innerWidth"," * @return {number}"," */","","/**"," * Returns the size of the box from inside of the border,"," * which is offsetHeight plus the padding on the top and bottom."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.innerHeight();"," * </code></pre>"," *"," * @method innerHeight"," * @return {number}"," */","","/**"," * Returns the outer width of the box including the border,"," * if true is passed as the first argument, the margin is included."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.outerWidth();"," * node.outerWidth(true); // includes margin"," * </code></pre>"," *"," * @method outerWidth"," * @return {number}"," */","","/**"," * Returns the outer height of the box including the border,"," * if true is passed as the first argument, the margin is included."," *"," * Example:"," *"," * <pre><code>var node = A.one('#nodeId');"," * node.outerHeight();"," * node.outerHeight(true); // includes margin"," * </code></pre>"," *"," * @method outerHeight"," * @return {number}"," */","","A.each(","	['Height', 'Width'],","	function(item, index, collection) {","		var sides = index ? 'lr' : 'tb';","","		var dimensionType = item.toLowerCase();","","		NODE_PROTO[dimensionType] = function(size) {","			var instance = this;","","			var returnValue = instance;","","			if (isUndefined(size)) {","				var node = instance._node;","				var dimension;","","				if (node) {","					if ((!node.tagName && node.nodeType === 9) || node.alert) {","						dimension = instance.get(REGION)[dimensionType];","					}","					else {","						dimension = instance.get(OFFSET + item);","","						var previous = {};","						var styleObj = node.style;","","						if (!dimension) {","							instance.addClass(CSS_FORCE_OFFSET);","","							dimension = instance.get(OFFSET + item);","","							instance.removeClass(CSS_FORCE_OFFSET);","						}","","						if (dimension) {","							dimension -= (instance.getPadding(sides) + instance.getBorderWidth(sides));","						}","					}","				}","","				returnValue = dimension;","			}","			else {","				instance.setStyle(dimensionType, size);","			}","","			return returnValue;","		};","","		NODE_PROTO[INNER + item] = function() {","			var instance = this;","","			return instance[dimensionType]() + instance.getPadding(sides);","		};","","		NODE_PROTO[OUTER + item] = function(margin) {","			var instance = this;","","			var innerSize = instance[INNER + item]();","			var borderSize = instance.getBorderWidth(sides);","","			var size = innerSize + borderSize;","","			if (margin) {","				size += instance.getMargin(sides);","			}","","			return size;","		};","	}",");","","if (!SUPPORT_OPTIONAL_TBODY) {","	A.DOM._ADD_HTML = A.DOM.addHTML;","","	A.DOM.addHTML = function(node, content, where) {","		var nodeName = (node.nodeName && node.nodeName.toLowerCase()) || STR_EMPTY;","","		var tagName = STR_EMPTY;","","		if (!isUndefined(content)) {","			if (isString(content)) {","				tagName = (REGEX_TAGNAME.exec(content) || ARRAY_EMPTY_STRINGS)[1];","			}","			else if (content.nodeType && content.nodeType == 11 && content.childNodes.length) { // a doc frag","				tagName = content.childNodes[0].nodeName;","			}","			else if (content.nodeName) { // a node","				tagName = content.nodeName;","			}","","			tagName = tagName && tagName.toLowerCase();","		}","","		if (nodeName == 'table' && tagName == 'tr') {","			node = node.getElementsByTagName('tbody')[0] || node.appendChild(node.ownerDocument.createElement('tbody'));","","			var whereNodeName = ((where && where.nodeName) || STR_EMPTY).toLowerCase();","","			// Assuming if the \"where\" is a tbody node,","			// we're trying to prepend to a table. Attempt to","			// grab the first child of the tbody.","			if (whereNodeName == 'tbody' && where.childNodes.length > 0) {","				where = where.firstChild;","			}","		}","","		return A.DOM._ADD_HTML(node, content, where);","	};","}","","/**"," * Augment the <a href=\"NodeList.html\">YUI3 NodeList</a> with more util methods."," *"," * Check the list of <a href=\"NodeList.html#methods\">Methods</a> available for"," * AUI NodeList."," *"," * @class A.NodeList"," * @constructor"," * @uses A.Node"," */"," ANodeList.importMethod(","	NODE_PROTO,","	[","		'after',","","		'appendTo',","","		'attr',","","		'before',","","		'empty',","","		'getX',","","		'getXY',","","		'getY',","","		'hover',","","		'html',","","		'innerHeight',","","		'innerWidth',","","		'outerHeight',","","		'outerHTML',","","		'outerWidth',","","		'prepend',","","		'prependTo',","","		'purge',","","		'selectText',","","		'selectable',","","		'setX',","","		'setXY',","","		'setY',","","		'text',","","		'toggle',","","		'unselectable',","","		'val'","	]",");","","A.mix(","	NODELIST_PROTO,","	{","		/**","		 * See <a href=\"Node.html#method_all\">Node all</a>.","		 *","		 * @method all","		 */","		all: function(selector) {","			var instance = this;","","			var newNodeList = [];","			var nodes = instance._nodes;","			var length = nodes.length;","","			var subList;","","			for (var i = 0; i < length; i++) {","				subList = A.Selector.query(selector, nodes[i]);","","				if (subList && subList.length) {","					newNodeList.push.apply(newNodeList, subList);","				}","			}","","			newNodeList = AArray.unique(newNodeList);","","			return A.all(newNodeList);","		},","","		allNS: function(ns, selector) {","			var instance = this;","","			return instance.all(formatSelectorNS(ns, selector));","		},","","		/**","		 * Returns the first element in the node list collection.","		 *","		 * @method first","		 * @return {Node}","		 */","		first: function() {","			var instance = this;","","			return instance.item(0);","		},","","		/**","		 * See <a href=\"Node.html#method_getDOM\">Node getDOM</a>.","		 *","		 * @method getDOM","		 */","		getDOM: function() {","			var instance = this;","","			return ANodeList.getDOMNodes(this);","		},","","		/**","		 * Returns the last element in the node list collection.","		 *","		 * @method last","		 * @return {Node}","		 */","		last: function() {","			var instance = this;","","			return instance.item(instance._nodes.length - 1);","		},","","		/**","		 * See <a href=\"Node.html#method_one\">Node one</a>.","		 *","		 * @method one","		 */","		one: function(selector) {","			var instance = this;","","			var newNode = null;","","			var nodes = instance._nodes;","			var length = nodes.length;","","			for (var i = 0; i < length; i++) {","				newNode = A.Selector.query(selector, nodes[i], true);","","				if (newNode) {","					newNode = A.one(newNode);","","					break;","				}","			}","","			return newNode;","		},","","		oneNS: function(ns, selector) {","			var instance = this;","","			return instance.one(formatSelectorNS(ns, selector));","		}","	}",");","","NODELIST_PROTO.__filter = NODELIST_PROTO.filter;","","NODELIST_PROTO.filter = function(value, context) {","	var instance = this;","","	var newNodeList;","","	if (isFunction(value)) {","		var nodes = [];","","		instance.each(","			function(item, index, collection) {","				if (value.call(context || item, item, index, collection)) {","					nodes.push(item._node);","				}","			}","		);","","		newNodeList = A.all(nodes);","	}","	else {","		newNodeList = NODELIST_PROTO.__filter.call(instance, value);","	}","","	return newNodeList;","};","","A.mix(","	ANodeList,","	{","		create: function(html) {","			var docFrag = A.getDoc().invoke(CREATE_DOCUMENT_FRAGMENT);","","			return docFrag.append(html).get(CHILD_NODES);","		}","	}",");","","A.mix(","	A,","	{","		/**","		 * Get the body node. Shortcut to <code>A.one('body')</code>.","		 *","		 * @method getBody","		 */","		getBody: function() {","			var instance = this;","","			if (!instance._bodyNode) {","				instance._bodyNode = A.one(DOC.body);","			}","","			return instance._bodyNode;","		},","","		/**","		 * Get the document node. Shortcut to <code>A.one(document)</code>.","		 *","		 * @method getDoc","		 */","		getDoc: function() {","			var instance = this;","","			if (!instance._documentNode) {","				instance._documentNode = A.one(DOC);","			}","","			return instance._documentNode;","		},","","		/**","		 * Get the window node. Shortcut to <code>A.one(window)</code>.","		 *","		 * @method getWin","		 */","		getWin: function() {","			var instance = this;","","			if (!instance._windowNode) {","				instance._windowNode = A.one(WIN);","			}","","			return instance._windowNode;","		}","	}",");","","A.queryNS = function(ns, selector, methodName) {","	return A[methodName || 'one'](formatSelectorNS(ns, selector));","};","","A.oneNS = A.queryNS;","","A.allNS = function(ns, selector) {","	return A.queryNS(ns, selector, 'all');","};","","A.byIdNS = function(ns, id) {","	return A.one(prefixSelector(ns, id));","};","","// Patch for http://yuilibrary.com/projects/yui3/ticket/2531537","","var addMethod = ANodeList.addMethod;","","AArray.each(","	['hide', 'show'],","	function(item, index, collection) {","		addMethod(","			item,","			function() {","				return this[item].apply(this, arguments);","			}","		);","	}",");","","}, '2.0.0pr1', {","    \"requires\": [","        \"node-base\",","        \"node-style\",","        \"array-extras\",","        \"aui-base-lang\",","        \"aui-classnamemanager\",","        \"aui-debounce\"","    ]","});"];
_yuitest_coverage["build/aui-node-base/aui-node-base.js"].lines = {"1":0,"10":0,"79":0,"83":0,"90":0,"92":0,"93":0,"95":0,"96":0,"99":0,"101":0,"105":0,"108":0,"110":0,"114":0,"116":0,"118":0,"120":0,"121":0,"124":0,"126":0,"127":0,"129":0,"130":0,"145":0,"147":0,"149":0,"167":0,"169":0,"170":0,"172":0,"173":0,"174":0,"177":0,"180":0,"182":0,"183":0,"186":0,"204":0,"206":0,"207":0,"208":0,"210":0,"211":0,"212":0,"215":0,"218":0,"241":0,"243":0,"245":0,"267":0,"269":0,"270":0,"272":0,"273":0,"276":0,"279":0,"282":0,"283":0,"284":0,"287":0,"290":0,"292":0,"293":0,"296":0,"314":0,"316":0,"317":0,"318":0,"319":0,"321":0,"322":0,"324":0,"326":0,"329":0,"332":0,"336":0,"337":0,"341":0,"361":0,"366":0,"367":0,"368":0,"371":0,"373":0,"374":0,"377":0,"380":0,"381":0,"384":0,"403":0,"405":0,"407":0,"409":0,"410":0,"413":0,"424":0,"426":0,"438":0,"440":0,"450":0,"451":0,"453":0,"465":0,"467":0,"479":0,"481":0,"494":0,"495":0,"497":0,"498":0,"500":0,"503":0,"515":0,"517":0,"518":0,"520":0,"521":0,"523":0,"525":0,"526":0,"529":0,"538":0,"540":0,"541":0,"543":0,"568":0,"570":0,"571":0,"574":0,"577":0,"581":0,"583":0,"593":0,"594":0,"597":0,"598":0,"601":0,"605":0,"606":0,"610":0,"631":0,"633":0,"653":0,"655":0,"674":0,"676":0,"678":0,"690":0,"692":0,"694":0,"695":0,"697":0,"699":0,"700":0,"702":0,"703":0,"705":0,"706":0,"707":0,"710":0,"713":0,"726":0,"728":0,"730":0,"741":0,"743":0,"744":0,"746":0,"747":0,"752":0,"753":0,"754":0,"756":0,"757":0,"759":0,"760":0,"762":0,"765":0,"768":0,"769":0,"774":0,"784":0,"786":0,"788":0,"789":0,"792":0,"811":0,"813":0,"814":0,"816":0,"817":0,"819":0,"822":0,"825":0,"826":0,"829":0,"833":0,"836":0,"839":0,"860":0,"861":0,"863":0,"864":0,"866":0,"869":0,"885":0,"887":0,"889":0,"899":0,"901":0,"903":0,"904":0,"907":0,"927":0,"929":0,"930":0,"933":0,"947":0,"949":0,"950":0,"951":0,"952":0,"954":0,"955":0,"956":0,"958":0,"959":0,"960":0,"962":0,"966":0,"977":0,"979":0,"980":0,"982":0,"984":0,"985":0,"987":0,"988":0,"989":0,"992":0,"993":0,"998":0,"1009":0,"1011":0,"1013":0,"1024":0,"1026":0,"1028":0,"1039":0,"1041":0,"1043":0,"1045":0,"1056":0,"1058":0,"1060":0,"1062":0,"1074":0,"1076":0,"1078":0,"1079":0,"1080":0,"1083":0,"1086":0,"1099":0,"1100":0,"1101":0,"1103":0,"1104":0,"1106":0,"1121":0,"1122":0,"1124":0,"1126":0,"1143":0,"1144":0,"1146":0,"1148":0,"1241":0,"1244":0,"1246":0,"1248":0,"1249":0,"1251":0,"1253":0,"1254":0,"1255":0,"1257":0,"1258":0,"1259":0,"1262":0,"1264":0,"1265":0,"1267":0,"1268":0,"1270":0,"1272":0,"1275":0,"1276":0,"1281":0,"1284":0,"1287":0,"1290":0,"1291":0,"1293":0,"1296":0,"1297":0,"1299":0,"1300":0,"1302":0,"1304":0,"1305":0,"1308":0,"1313":0,"1314":0,"1316":0,"1317":0,"1319":0,"1321":0,"1322":0,"1323":0,"1325":0,"1326":0,"1328":0,"1329":0,"1332":0,"1335":0,"1336":0,"1338":0,"1343":0,"1344":0,"1348":0,"1362":0,"1421":0,"1430":0,"1432":0,"1433":0,"1434":0,"1436":0,"1438":0,"1439":0,"1441":0,"1442":0,"1446":0,"1448":0,"1452":0,"1454":0,"1464":0,"1466":0,"1475":0,"1477":0,"1487":0,"1489":0,"1498":0,"1500":0,"1502":0,"1503":0,"1505":0,"1506":0,"1508":0,"1509":0,"1511":0,"1515":0,"1519":0,"1521":0,"1526":0,"1528":0,"1529":0,"1531":0,"1533":0,"1534":0,"1536":0,"1538":0,"1539":0,"1544":0,"1547":0,"1550":0,"1553":0,"1557":0,"1559":0,"1564":0,"1573":0,"1575":0,"1576":0,"1579":0,"1588":0,"1590":0,"1591":0,"1594":0,"1603":0,"1605":0,"1606":0,"1609":0,"1614":0,"1615":0,"1618":0,"1620":0,"1621":0,"1624":0,"1625":0,"1630":0,"1632":0,"1635":0,"1638":0};
_yuitest_coverage["build/aui-node-base/aui-node-base.js"].functions = {"prefixSelector:78":0,"formatSelectorNS:82":0,"(anonymous 2):98":0,"_setUnselectable:120":0,"allNS:146":0,"ancestors:166":0,"ancestorsByClassName:203":0,"appendTo:240":0,"attr:266":0,"clone:317":0,"clone:336":0,"(anonymous 3):313":0,"center:360":0,"empty:402":0,"getDOM:423":0,"getBorderWidth:437":0,"getCenterXY:449":0,"getMargin:464":0,"getPadding:478":0,"guid:493":0,"hover:514":0,"html:567":0,"oneNS:580":0,"outerHTML:592":0,"placeAfter:630":0,"placeBefore:652":0,"prependTo:673":0,"radioClass:689":0,"resetId:725":0,"selectText:740":0,"selectable:783":0,"fn:813":0,"(anonymous 4):828":0,"swallowEvent:810":0,"text:859":0,"toggle:884":0,"unselectable:898":0,"val:926":0,"_getBoxStyleAsNumber:946":0,"_getText:976":0,"_hoverOutHandler:1008":0,"_hoverOverHandler:1023":0,"_hoverOutTaskFn:1038":0,"_hoverOverTaskFn:1055":0,"_place:1073":0,"_isHidden:1103":0,"_hide:1121":0,"_show:1143":0,"]:1248":0,"]:1290":0,"]:1296":0,"(anonymous 5):1243":0,"addHTML:1316":0,"all:1429":0,"allNS:1451":0,"first:1463":0,"getDOM:1474":0,"last:1486":0,"one:1497":0,"oneNS:1518":0,"(anonymous 6):1537":0,"filter:1528":0,"create:1556":0,"getBody:1572":0,"getDoc:1587":0,"getWin:1602":0,"queryNS:1614":0,"allNS:1620":0,"byIdNS:1624":0,"(anonymous 8):1637":0,"(anonymous 7):1634":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-node-base/aui-node-base.js"].coveredLines = 404;
_yuitest_coverage["build/aui-node-base/aui-node-base.js"].coveredFunctions = 72;
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1);
YUI.add('aui-node-base', function (A, NAME) {

/**
 * aui-node-base A set of utility methods to the Node.
 *
 * @module aui-node
 * @submodule aui-node-base
 */

_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 10);
var Lang = A.Lang,
	isArray = Lang.isArray,
	isFunction = Lang.isFunction,
	isObject = Lang.isObject,
	isString = Lang.isString,
	isUndefined = Lang.isUndefined,
	isValue = Lang.isValue,

	AArray = A.Array,
	ANode = A.Node,
	ANodeList = A.NodeList,

	getClassName = A.getClassName,
	getRegExp = A.DOM._getRegExp,

	prefix = Lang.String.prefix,

	CONFIG = A.config,
	DOC = CONFIG.doc,
	WIN = CONFIG.win,

	NODE_PROTO = ANode.prototype,
	NODELIST_PROTO = ANodeList.prototype,

	STR_EMPTY = '',

	ARRAY_EMPTY_STRINGS = [STR_EMPTY, STR_EMPTY],

	OFFSET = 'offset',

	CSS_FORCE_OFFSET = getClassName('force', OFFSET),
	CSS_HIDE = getClassName('hide'),
	CSS_UNSELECTABLE = getClassName('unselectable'),

	CHILD_NODES = 'childNodes',
	CREATE_DOCUMENT_FRAGMENT = 'createDocumentFragment',
	INNER = 'inner',
	INNER_HTML = 'innerHTML',
	NEXT_SIBLING = 'nextSibling',
	NONE = 'none',
	OUTER = 'outer',
	PARENT_NODE = 'parentNode',
	REGION = 'region',
	SCRIPT = 'script',

	SUPPORT_CLONED_EVENTS = false,

	VALUE = 'value',

	MAP_BORDER = {
		b: 'borderBottomWidth',
		l: 'borderLeftWidth',
		r: 'borderRightWidth',
		t: 'borderTopWidth'
	},
	MAP_MARGIN = {
		b: 'marginBottom',
		l: 'marginLeft',
		r: 'marginRight',
		t: 'marginTop'
	},
	MAP_PADDING = {
		b: 'paddingBottom',
		l: 'paddingLeft',
		r: 'paddingRight',
		t: 'paddingTop'
	},

	prefixSelector = function(ns, id) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "prefixSelector", 78);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 79);
return '#' + prefix(ns, id);
	},

	formatSelectorNS = function(ns, selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "formatSelectorNS", 82);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 83);
return selector.replace(getRegExp('(#|\\[id=(\\\"|\\\'))(?!' + ns + ')', 'g'), '$1' + ns);
	};

	/*
		Parts of this file are used from jQuery (http://jquery.com)
		Dual-licensed under MIT/GPL
	*/
	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 90);
var div = DOC.createElement('div');

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 92);
div.style.display = 'none';
	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 93);
div.innerHTML = '   <table></table>&nbsp;';

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 95);
if (div.attachEvent && div.fireEvent) {
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 96);
div.attachEvent(
			'onclick',
			function(){
				_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 2)", 98);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 99);
SUPPORT_CLONED_EVENTS = true;

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 101);
div.detachEvent('onclick', arguments.callee);
			}
		);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 105);
div.cloneNode(true).fireEvent('onclick');
	}

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 108);
var SUPPORT_OPTIONAL_TBODY = !div.getElementsByTagName('tbody').length;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 110);
var REGEX_LEADING_WHITE_SPACE = /^\s+/,
		REGEX_IE8_ACTION = /=([^=\x27\x22>\s]+\/)>/g,
		REGEX_TAGNAME = /<([\w:]+)/;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 114);
div = null;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 116);
ANode.cssId = prefixSelector;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 118);
ANode.formatSelectorNS = formatSelectorNS;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 120);
var _setUnselectable = function(element, unselectable, noRecurse) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_setUnselectable", 120);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 121);
var descendants,
			value = unselectable ? 'on' : '';

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 124);
element.setAttribute('unselectable', value);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 126);
if (!noRecurse) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 127);
descendants = element.getElementsByTagName('*');

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 129);
for (var i = 0, descendant; descendant = descendants[i]; i++) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 130);
descendant.setAttribute('unselectable', value);
			}
		}
	};

/**
 * Augment the <a href="Node.html">YUI3 Node</a> with more util methods.
 *
 * Check the list of <a href="Node.html#methods">Methods</a> available for
 * AUI Node.
 *
 * @class A.Node
 * @constructor
 * @uses Node
 */
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 145);
A.mix(NODE_PROTO, {
	allNS: function(ns, selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "allNS", 146);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 147);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 149);
return instance.all(formatSelectorNS(ns, selector));
	},

	/**
	 * <p>Returns the current ancestors of the node element. If a selector is
	 * specified, the ancestors are filtered to match the selector.</p>
	 *
	 * Example:
	 *
	 * <pre><code>
	 * A.one('#nodeId').ancestors('div');
	 * </code></pre>
	 *
	 * @method ancestors
	 * @param {String} selector A selector to filter the ancestor elements against.
	 * @return {NodeList}
	 */
	ancestors: function(selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "ancestors", 166);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 167);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 169);
var ancestors = [];
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 170);
var currentEl = instance.getDOM();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 172);
while (currentEl && currentEl.nodeType !== 9) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 173);
if (currentEl.nodeType === 1) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 174);
ancestors.push(currentEl);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 177);
currentEl = currentEl.parentNode;
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 180);
var nodeList = new A.all(ancestors);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 182);
if (selector) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 183);
nodeList = nodeList.filter(selector);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 186);
return nodeList;
	},

	/**
	 * <p>Returns the current ancestors of the node element filtered by a className.
	 * This is an optimized method for finding ancestors by a specific CSS class name.</p>
	 *
	 * Example:
	 *
	 * <pre><code>
	 * A.one('#nodeId').ancestorsByClassName('aui-hide');
	 * </code></pre>
	 *
	 * @method ancestors
	 * @param {String} selector A selector to filter the ancestor elements against.
	 * @return {NodeList}
	 */
	ancestorsByClassName: function(className) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "ancestorsByClassName", 203);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 204);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 206);
var ancestors = [];
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 207);
var cssRE = new RegExp('\\b' + className + '\\b');
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 208);
var currentEl = instance.getDOM();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 210);
while (currentEl && currentEl.nodeType !== 9) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 211);
if (currentEl.nodeType === 1 && cssRE.test(currentEl.className)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 212);
ancestors.push(currentEl);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 215);
currentEl = currentEl.parentNode;
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 218);
return A.all(ancestors);
	},

	/**
	 * <p>Insert the node instance to the end of the <code>selector</code>
	 * element.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * // using another Node instance
	 * var body = A.one('body');
	 * node.appendTo(body);
	 * // using a CSS selector
	 * node.appendTo('#container');
	 * </code></pre>
	 *
	 * @method appendTo
	 * @chainable
	 * @param {Node | String} selector A selector, element, HTML string, Node
	 * @return {String}
	 */
	appendTo: function(selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "appendTo", 240);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 241);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 243);
A.one(selector).append(instance);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 245);
return instance;
	},

	/**
	 * <p>Get or Set the value of an attribute for the first element in the
	 * set of matched elements. If only the <code>name</code> is passed it
	 * works as a getter.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.attr('title', 'Setting a new title attribute');
	 * // Alert the value of the title attribute: 'Setting a new title attribute'
	 * alert( node.attr('title') );
	 * </code></pre>
	 *
	 * @method attr
	 * @param {String} name The name of the attribute
	 * @param {String} value The value of the attribute to be set. Optional.
	 * @return {String}
	 */
	attr: function(name, value) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "attr", 266);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 267);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 269);
if (!isUndefined(value)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 270);
var el = instance.getDOM();

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 272);
if (name in el) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 273);
instance.set(name, value);
			}
			else {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 276);
instance.setAttribute(name, value);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 279);
return instance;
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 282);
if (isObject(name)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 283);
for (var i in name) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 284);
instance.attr(i, name[i]);
				}

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 287);
return instance;
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 290);
var currentValue = instance.get(name);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 292);
if (!Lang.isValue(currentValue)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 293);
currentValue = instance.getAttribute(name);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 296);
return currentValue;
		}
	},

	/**
	 * Normalizes the behavior of cloning a node, which by default should not clone
	 * the events that are attached to it.
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.clone().appendTo('body');
	 * </code></pre>
	 *
	 * @method clone
	 * @return {Node}
	 */
	clone: (function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 3)", 313);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 314);
var clone;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 316);
if (SUPPORT_CLONED_EVENTS) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 317);
clone = function() {
				_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "clone", 317);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 318);
var el = this.getDOM();
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 319);
var clone;

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 321);
if (el.nodeType != 3) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 322);
var outerHTML = this.outerHTML();

					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 324);
outerHTML = outerHTML.replace(REGEX_IE8_ACTION, '="$1">').replace(REGEX_LEADING_WHITE_SPACE, STR_EMPTY);

					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 326);
clone = ANode.create(outerHTML);
				}
				else {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 329);
clone = A.one(el.cloneNode());
				}

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 332);
return clone;
			};
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 336);
clone = function() {
				_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "clone", 336);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 337);
return this.cloneNode(true);
			};
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 341);
return clone;
	})(),

	/**
	 * <p>Centralize the current Node instance with the passed
	 * <code>val</code> Array, Node, String, or Region, if not specified, the body will be
	 * used.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * // Center the <code>node</code> with the <code>#container</code>.
	 * node.center('#container');
	 * </code></pre>
	 *
	 * @method center
	 * @chainable
	 * @param {Array | Node | Region | String} val Array, Node, String, or Region to center with
	 */
	center: function(val) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "center", 360);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 361);
var instance = this,
			nodeRegion = instance.get(REGION),
			x,
			y;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 366);
if (isArray(val)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 367);
x = val[0];
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 368);
y = val[1];
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 371);
var region;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 373);
if (isObject(val) && !A.instanceOf(val, ANode)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 374);
region = val;
			}
			else {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 377);
region = (A.one(val) || A.getBody()).get(REGION);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 380);
x = region.left + (region.width / 2);
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 381);
y = region.top + (region.height / 2);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 384);
instance.setXY([x - (nodeRegion.width / 2), y - (nodeRegion.height / 2)]);
	},

	/**
	 * <p>This method removes not only child (and other descendant) elements,
	 * but also any text within the set of matched elements. This is because,
	 * according to the DOM specification, any string of text within an element
	 * is considered a child node of that element.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.empty();
	 * </code></pre>
	 *
	 * @method empty
	 * @chainable
	 */
	empty: function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "empty", 402);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 403);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 405);
instance.all('>*').remove().purge();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 407);
var el = ANode.getDOMNode(instance);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 409);
while (el.firstChild) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 410);
el.removeChild(el.firstChild);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 413);
return instance;
	},

	/**
	 * Retrieves the DOM node bound to a Node instance. See
	 * <a href="Node.html#method_getDOMNode">getDOMNode</a>.
	 *
	 * @method getDOM
	 * @return {HTMLNode} The DOM node bound to the Node instance.
	 */
	getDOM: function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getDOM", 423);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 424);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 426);
return ANode.getDOMNode(instance);
	},

	/**
	 * Return the combined width of the border for the specified sides.
	 *
	 * @method getBorderWidth
	 * @param {string} sides Can be t, r, b, l or any combination of
	 * those to represent the top, right, bottom, or left sides.
	 * @return {number}
	 */
	getBorderWidth: function(sides) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getBorderWidth", 437);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 438);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 440);
return instance._getBoxStyleAsNumber(sides, MAP_BORDER);
	},

	/**
	 * Gets the current center position of the node in page coordinates.
	 * @method getCenterXY
	 * @for Node
	 * @return {Array} The XY position of the node
	*/
	getCenterXY: function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getCenterXY", 449);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 450);
var instance = this;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 451);
var region = instance.get(REGION);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 453);
return [(region.left + region.width/2), (region.top + region.height/2)];
	},

	/**
	 * Return the combined size of the margin for the specified sides.
	 *
	 * @method getMargin
	 * @param {string} sides Can be t, r, b, l or any combination of
	 * those to represent the top, right, bottom, or left sides.
	 * @return {number}
	 */
	getMargin: function(sides) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getMargin", 464);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 465);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 467);
return instance._getBoxStyleAsNumber(sides, MAP_MARGIN);
	},

	/**
	 * Return the combined width of the border for the specified sides.
	 *
	 * @method getPadding
	 * @param {string} sides Can be t, r, b, l or any combination of
	 * those to represent the top, right, bottom, or left sides.
	 * @return {number}
	 */
	getPadding: function(sides) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getPadding", 478);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 479);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 481);
return instance._getBoxStyleAsNumber(sides, MAP_PADDING);
	},

	/**
	 * Set the id of the Node instance if the object does not have one. The
	 * generated id is based on a guid created by the
	 * <a href="YUI.html#method_stamp">stamp</a> method.
	 *
	 * @method guid
	 * @param {string} prefix optional guid prefix
	 * @return {String} The current id of the node
	 */
	guid: function(prefix) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "guid", 493);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 494);
var instance = this;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 495);
var currentId = instance.get('id');

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 497);
if (!currentId) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 498);
currentId = A.stamp(instance);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 500);
instance.set('id', currentId);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 503);
return currentId;
	},

	/**
	 * Create a hover interaction.
	 *
	 * @method hover
	 * @param {string} overFn
	 * @param {string} outFn
	 * @return {Node} The current Node instance
	 */
	hover: function(overFn, outFn) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "hover", 514);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 515);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 517);
var hoverOptions;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 518);
var defaultHoverOptions = instance._defaultHoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 520);
if (isObject(overFn, true)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 521);
hoverOptions = overFn;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 523);
hoverOptions = A.mix(hoverOptions, defaultHoverOptions);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 525);
overFn = hoverOptions.over;
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 526);
outFn = hoverOptions.out;
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 529);
hoverOptions = A.mix(
				{
					over: overFn,
					out: outFn
				},
				defaultHoverOptions
			);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 538);
instance._hoverOptions = hoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 540);
hoverOptions.overTask = A.debounce(instance._hoverOverTaskFn, null, instance);
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 541);
hoverOptions.outTask = A.debounce(instance._hoverOutTaskFn, null, instance);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 543);
return new A.EventHandle(
			[
				instance.on(hoverOptions.overEventType, instance._hoverOverHandler, instance),
				instance.on(hoverOptions.outEventType, instance._hoverOutHandler, instance)
			]
		);
	},

	/**
	 * <p>Get or Set the HTML contents of the node. If the <code>value</code>
	 * is passed it's set the content of the element, otherwise it works as a
	 * getter for the current content.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.html('Setting new HTML');
	 * // Alert the value of the current content
	 * alert( node.html() );
	 * </code></pre>
	 *
	 * @method html
	 * @param {string} value A string of html to set as the content of the node instance.
	 */
	html: function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "html", 567);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 568);
var args = arguments, length = args.length;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 570);
if (length) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 571);
this.set(INNER_HTML, args[0]);
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 574);
return this.get(INNER_HTML);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 577);
return this;
	},

	oneNS: function(ns, selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "oneNS", 580);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 581);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 583);
return instance.one(formatSelectorNS(ns, selector));
	},

	/**
	 * Gets the outerHTML of a node, which islike innerHTML, except that it
	 * actually contains the HTML of the node itself.
	 *
	 * @return {string} The outerHTML of the given element.
	 */
	outerHTML: function() {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "outerHTML", 592);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 593);
var instance = this;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 594);
var domEl = instance.getDOM();

		// IE, Opera and WebKit all have outerHTML.
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 597);
if ('outerHTML' in domEl) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 598);
return domEl.outerHTML;
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 601);
var temp = ANode.create('<div></div>').append(
			this.clone()
		);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 605);
try {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 606);
return temp.html();
		}
		catch(e) {}
		finally {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 610);
temp = null;
		}
	},

	/**
	 * <p>Inserts a <code>newNode</code> after the node instance (i.e., as the next
	 * sibling). If the reference node has no parent, then does nothing.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var titleNode = A.one('#titleNode');
	 * var descriptionNode = A.one('#descriptionNode');
	 * // the description is usually shown after the title
	 * titleNode.placeAfter(descriptionNode);
	 * </code></pre>
	 *
	 * @method placeAfter
	 * @chainable
	 * @param {Node} newNode Node to insert.
	 */
	placeAfter: function(newNode) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "placeAfter", 630);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 631);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 633);
return instance._place(newNode, instance.get(NEXT_SIBLING));
	},

	/**
	 * <p>Inserts a <code>newNode</code> before the node instance (i.e., as the previous
	 * sibling). If the reference node has no parent, then does nothing.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var descriptionNode = A.one('#descriptionNode');
	 * var titleNode = A.one('#titleNode');
	 * // the title is usually shown before the description
	 * descriptionNode.placeBefore(titleNode);
	 * </code></pre>
	 *
	 * @method placeBefore
	 * @chainable
	 * @param {Node} newNode Node to insert.
	 */
	placeBefore: function(newNode) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "placeBefore", 652);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 653);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 655);
return instance._place(newNode, instance);
	},

	/**
	 * <p>Inserts the node instance to the begining of the <code>selector</code>
	 * node (i.e., insert before the <code>firstChild</code> of the
	 * <code>selector</code>).</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.prependTo('body');
	 * </code></pre>
	 *
	 * @method prependTo
	 * @chainable
	 * @param {Node | String} selector A selector, element, HTML string, Node
	 */
	prependTo: function(selector) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "prependTo", 673);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 674);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 676);
A.one(selector).prepend(instance);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 678);
return instance;
	},

	/**
	 * Add one or more CSS classes to an element and remove the class(es)
	 * from the siblings of the element.
	 *
	 * @method radioClass
	 * @chainable
	 * @param {String} cssClass
	 */
	radioClass: function(cssClass) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "radioClass", 689);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 690);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 692);
var siblings = instance.siblings();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 694);
if (isString(cssClass)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 695);
siblings.removeClass(cssClass);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 697);
instance.addClass(cssClass);
		}
		else {_yuitest_coverline("build/aui-node-base/aui-node-base.js", 699);
if (isArray(cssClass)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 700);
var siblingNodes = siblings.getDOM();

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 702);
var regex = getRegExp('(?:^|\\s+)(?:' + cssClass.join('|') + ')(?=\\s+|$)', 'g');
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 703);
var node;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 705);
for (var i = siblingNodes.length - 1; i >= 0; i--) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 706);
node = siblingNodes[i];
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 707);
node.className = node.className.replace(regex, '');
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 710);
instance.addClass(cssClass.join(' '));
		}}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 713);
return instance;
	},

	/**
	 * Generate an unique identifier and reset the id attribute of the node
	 * instance using the new value. Invokes the
	 * <a href="Node.html#method_guid">guid</a>.
	 *
	 * @method resetId
	 * @chainable
	 * @param {String} prefix Optional prefix for the guid.
	 */
	resetId: function(prefix) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "resetId", 725);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 726);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 728);
instance.attr('id', A.guid(prefix));

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 730);
return instance;
	},

	/**
	 * Selects a substring of text inside of the input element.
	 *
	 * @method selectText
	 * @param {Number} start The index to start the selection range from
	 * @param {Number} end The index to end the selection range at
	 */
	selectText: function(start, end) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "selectText", 740);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 741);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 743);
var textField = instance.getDOM();
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 744);
var length = instance.val().length;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 746);
end = isValue(end) ? end : length;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 747);
start = isValue(start) ? start : 0;

		// Some form elements could throw a (NS_ERROR_FAILURE)
		// [nsIDOMNSHTMLInputElement.setSelectionRange] error when invoke the
		// setSelectionRange on firefox. Wrapping in a try/catch to prevent the error be thrown
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 752);
try {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 753);
if (textField.setSelectionRange) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 754);
textField.setSelectionRange(start, end);
			}
			else {_yuitest_coverline("build/aui-node-base/aui-node-base.js", 756);
if (textField.createTextRange) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 757);
var range = textField.createTextRange();

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 759);
range.moveStart('character', start);
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 760);
range.moveEnd('character', end - length);

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 762);
range.select();
			}
			else {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 765);
textField.select();
			}}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 768);
if (textField != DOC.activeElement) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 769);
textField.focus();
			}
		}
		catch(e) {}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 774);
return instance;
	},

	/**
	 * Enables text selection for this element (normalized across browsers).
	 *
	 * @method selectable
	 * @chainable
	 */
	selectable: function(noRecurse) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "selectable", 783);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 784);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 786);
instance.removeClass(CSS_UNSELECTABLE);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 788);
if (A.UA.ie || A.UA.opera) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 789);
_setUnselectable(instance._node, false, noRecurse);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 792);
return instance;
	},

	/**
	 * <p>Stops the specified event(s) from bubbling and optionally prevents the
	 * default action.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var anchor = A.one('a#anchorId');
	 * anchor.swallowEvent('click');
	 * </code></pre>
	 *
	 * @method swallowEvent
	 * @chainable
	 * @param {String/Array} eventName an event or array of events to stop from bubbling
	 * @param {Boolean} preventDefault (optional) true to prevent the default action too
	 */
	swallowEvent: function(eventName, preventDefault) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "swallowEvent", 810);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 811);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 813);
var fn = function(event) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "fn", 813);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 814);
event.stopPropagation();

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 816);
if (preventDefault) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 817);
event.preventDefault();

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 819);
event.halt();
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 822);
return false;
		};

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 825);
if(isArray(eventName)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 826);
AArray.each(
				eventName,
				function(name) {
					_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 4)", 828);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 829);
instance.on(name, fn);
				}
			);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 833);
return this;
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 836);
instance.on(eventName, fn);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 839);
return instance;
	},

	/**
	 * <p>Get or Set the combined text contents of the node instance,
	 * including it's descendants. If the <code>text</code>
	 * is passed it's set the content of the element, otherwise it works as a
	 * getter for the current content.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var node = A.one('#nodeId');
	 * node.text('Setting new text content');
	 * // Alert the value of the current content
	 * alert( node.text() );
	 * </code></pre>
	 *
	 * @method text
	 * @param {String} text A string of text to set as the content of the node instance.
	 */
	text: function(text) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "text", 859);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 860);
var instance = this;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 861);
var el = instance.getDOM();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 863);
if (!isUndefined(text)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 864);
text = A.DOM._getDoc(el).createTextNode(text);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 866);
return instance.empty().append(text);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 869);
return instance._getText(el.childNodes);
	},

	/**
	 * <p>Displays or hide the node instance.</p>
	 *
	 * <p><string>NOTE:</string> This method assume that your node were hidden
	 * because of the 'aui-hide' css class were being used. This won't
	 * manipulate the inline <code>style.display</code> property.</p>
	 *
	 * @method toggle
	 * @chainable
	 * @param {Boolean} on Whether to force the toggle. Optional.
	 * @param {Function} callback A function to run after the visibility change. Optional.
	 */
	toggle: function(on, callback) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "toggle", 884);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 885);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 887);
instance._toggleView.apply(instance, arguments);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 889);
return instance;
	},

	/**
	 * Disables text selection for this element (normalized across browsers).
	 *
	 * @method unselectable
	 * @chainable
	 */
	unselectable: function(noRecurse) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "unselectable", 898);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 899);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 901);
instance.addClass(CSS_UNSELECTABLE);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 903);
if (A.UA.ie || A.UA.opera) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 904);
_setUnselectable(instance._node, true, noRecurse);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 907);
return instance;
	},

	/**
	 * <p>Get or Set the value attribute of the node instance. If the
	 * <code>value</code> is passed it's set the value of the element,
	 * otherwise it works as a getter for the current value.</p>
	 *
	 * Example:
	 *
	 * <pre><code>var input = A.one('#inputId');
	 * input.val('Setting new input value');
	 * // Alert the value of the input
	 * alert( input.val() );
	 * </code></pre>
	 *
	 * @method val
	 * @param {string} value Value to be set. Optional.
	 */
	val: function(value) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "val", 926);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 927);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 929);
if (isUndefined(value)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 930);
return instance.get(VALUE);
		}
		else {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 933);
return instance.set(VALUE, value);
		}
	},

	/**
	 * Return the combined size of the box style for the specified sides.
	 *
	 * @method _getBoxStyleAsNumber
	 * @param {string} sides Can be t, r, b, l or any combination of
	 * those to represent the top, right, bottom, or left sides.
	 * @param {string} map An object mapping mapping the "sides" param to the a CSS value to retrieve
	 * @return {number}
	 */
	_getBoxStyleAsNumber: function(sides, map) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_getBoxStyleAsNumber", 946);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 947);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 949);
var sidesArray = sides.match(/\w/g);
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 950);
var value = 0;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 951);
var side;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 952);
var sideKey;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 954);
for (var i = sidesArray.length - 1; i >= 0; i--) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 955);
sideKey = sidesArray[i];
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 956);
side = 0;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 958);
if (sideKey) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 959);
side = parseFloat(instance.getComputedStyle(map[sideKey]));
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 960);
side = Math.abs(side);

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 962);
value += side || 0;
			}
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 966);
return value;
	},

	/**
	 * Extract text content from the passed nodes.
	 *
	 * @method _getText
	 * @private
	 * @param {Native NodeList} childNodes
	 */
	_getText: function(childNodes) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_getText", 976);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 977);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 979);
var length = childNodes.length;
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 980);
var childNode;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 982);
var str = [];

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 984);
for (var i = 0; i < length; i++) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 985);
childNode = childNodes[i];

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 987);
if (childNode && childNode.nodeType != 8) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 988);
if (childNode.nodeType != 1) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 989);
str.push(childNode.nodeValue);
				}

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 992);
if (childNode.childNodes) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 993);
str.push(instance._getText(childNode.childNodes));
				}
			}
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 998);
return str.join(STR_EMPTY);
	},

	/**
	 * The event handler for the "out" function that is fired for events attached via the hover method.
	 *
	 * @method _hoverOutHandler
	 * @private
	 * @param {EventFacade} event
	 */
	_hoverOutHandler: function(event) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_hoverOutHandler", 1008);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1009);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1011);
var hoverOptions = instance._hoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1013);
hoverOptions.outTask.delay(hoverOptions.outDelay, event);
	},

	/**
	 * The event handler for the "over" function that is fired for events attached via the hover method.
	 *
	 * @method _hoverOverHandler
	 * @private
	 * @param {EventFacade} event
	 */
	_hoverOverHandler: function(event) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_hoverOverHandler", 1023);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1024);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1026);
var hoverOptions = instance._hoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1028);
hoverOptions.overTask.delay(hoverOptions.overDelay, event);
	},

	/**
	 * Cancels the over task, and fires the users custom "out" function for the hover method
	 *
	 * @method _hoverOverHandler
	 * @private
	 * @param {EventFacade} event
	 */
	_hoverOutTaskFn: function(event) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_hoverOutTaskFn", 1038);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1039);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1041);
var hoverOptions = instance._hoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1043);
hoverOptions.overTask.cancel();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1045);
hoverOptions.out.apply(hoverOptions.context || event.currentTarget, arguments);
	},

	/**
	 * Cancels the out task, and fires the users custom "over" function for the hover method
	 *
	 * @method _hoverOverHandler
	 * @private
	 * @param {EventFacade} event
	 */
	_hoverOverTaskFn: function(event) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_hoverOverTaskFn", 1055);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1056);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1058);
var hoverOptions = instance._hoverOptions;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1060);
hoverOptions.outTask.cancel();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1062);
hoverOptions.over.apply(hoverOptions.context || event.currentTarget, arguments);
	},

	/**
	 * Place a node or html string at a specific location
	 *
	 * @method _place
	 * @private
	 * @param {Node|String} newNode
	 * @param {Node} refNode
	 */
	_place: function(newNode, refNode) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_place", 1073);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1074);
var instance = this;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1076);
var parent = instance.get(PARENT_NODE);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1078);
if (parent) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1079);
if (isString(newNode)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1080);
newNode = ANode.create(newNode);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1083);
parent.insertBefore(newNode, refNode);
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1086);
return instance;
	},

	_defaultHoverOptions: {
		overEventType: 'mouseenter',
		outEventType: 'mouseleave',
		overDelay: 0,
		outDelay: 0,
		over: Lang.emptyFn,
		out: Lang.emptyFn
	}
}, true);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1099);
NODE_PROTO.__show = NODE_PROTO._show;
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1100);
NODE_PROTO.__hide = NODE_PROTO._hide;
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1101);
NODE_PROTO.__isHidden = NODE_PROTO._isHidden;

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1103);
NODE_PROTO._isHidden = function() {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_isHidden", 1103);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1104);
var instance = this;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1106);
return NODE_PROTO.__isHidden.call(instance) || instance.hasClass(instance._hideClass || CSS_HIDE);
};
/**
 * <p>Hide the node adding a css class on it. If <code>cssClass</code> is not
 * passed as argument, the className 'aui-hide' will be used by
 * default.</p>
 *
 * <p><string>NOTE:</string> This method assume that your node were visible
 * because the absence of 'aui-hide' css class. This won't
 * manipulate the inline <code>style.display</code> property.</p>
 *
 * @method hide
 * @chainable
 * @param {string} cssClass Class name to hide the element. Optional.
 */
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1121);
NODE_PROTO._hide = function() {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_hide", 1121);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1122);
var instance = this;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1124);
instance.addClass(instance._hideClass || CSS_HIDE);

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1126);
return instance;
};

/**
 * <p>Show the node removing a css class used to hide it. Use the same
 * className added using the <a href="A.Node.html#method_hide">hide</a>
 * method. If <code>cssClass</code> is not passed as argument, the
 * className 'aui-hide' will be used by default.</p>
 *
 * <p><string>NOTE:</string> This method assume that your node were hidden
 * because of the 'aui-hide' css class were being used. This won't
 * manipulate the inline <code>style.display</code> property.</p>
 *
 * @method show
 * @chainable
 * @param {string} cssClass Class name to hide the element. Optional.
 */
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1143);
NODE_PROTO._show = function() {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "_show", 1143);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1144);
var instance = this;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1146);
instance.removeClass(instance._hideClass || CSS_HIDE);

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1148);
return instance;
};

/**
 * Returns the width of the content, not including
 * the padding, border or margin. If a width is passed,
 * the node's overall width is set to that size.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.width(); //returns content width
 * node.width(100); // sets box width
 * </code></pre>
 *
 * @method width
 * @return {number}
 */

/**
 * Returns the height of the content, not including
 * the padding, border or margin. If a height is passed,
 * the node's overall height is set to that size.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.height(); //returns content height
 * node.height(100); // sets box height
 * </code></pre>
 *
 * @method height
 * @return {number}
 */

/**
 * Returns the size of the box from inside of the border,
 * which is the offsetWidth plus the padding on the left and right.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.innerWidth();
 * </code></pre>
 *
 * @method innerWidth
 * @return {number}
 */

/**
 * Returns the size of the box from inside of the border,
 * which is offsetHeight plus the padding on the top and bottom.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.innerHeight();
 * </code></pre>
 *
 * @method innerHeight
 * @return {number}
 */

/**
 * Returns the outer width of the box including the border,
 * if true is passed as the first argument, the margin is included.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.outerWidth();
 * node.outerWidth(true); // includes margin
 * </code></pre>
 *
 * @method outerWidth
 * @return {number}
 */

/**
 * Returns the outer height of the box including the border,
 * if true is passed as the first argument, the margin is included.
 *
 * Example:
 *
 * <pre><code>var node = A.one('#nodeId');
 * node.outerHeight();
 * node.outerHeight(true); // includes margin
 * </code></pre>
 *
 * @method outerHeight
 * @return {number}
 */

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1241);
A.each(
	['Height', 'Width'],
	function(item, index, collection) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 5)", 1243);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1244);
var sides = index ? 'lr' : 'tb';

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1246);
var dimensionType = item.toLowerCase();

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1248);
NODE_PROTO[dimensionType] = function(size) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "]", 1248);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1249);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1251);
var returnValue = instance;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1253);
if (isUndefined(size)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1254);
var node = instance._node;
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1255);
var dimension;

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1257);
if (node) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1258);
if ((!node.tagName && node.nodeType === 9) || node.alert) {
						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1259);
dimension = instance.get(REGION)[dimensionType];
					}
					else {
						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1262);
dimension = instance.get(OFFSET + item);

						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1264);
var previous = {};
						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1265);
var styleObj = node.style;

						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1267);
if (!dimension) {
							_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1268);
instance.addClass(CSS_FORCE_OFFSET);

							_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1270);
dimension = instance.get(OFFSET + item);

							_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1272);
instance.removeClass(CSS_FORCE_OFFSET);
						}

						_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1275);
if (dimension) {
							_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1276);
dimension -= (instance.getPadding(sides) + instance.getBorderWidth(sides));
						}
					}
				}

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1281);
returnValue = dimension;
			}
			else {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1284);
instance.setStyle(dimensionType, size);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1287);
return returnValue;
		};

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1290);
NODE_PROTO[INNER + item] = function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "]", 1290);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1291);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1293);
return instance[dimensionType]() + instance.getPadding(sides);
		};

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1296);
NODE_PROTO[OUTER + item] = function(margin) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "]", 1296);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1297);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1299);
var innerSize = instance[INNER + item]();
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1300);
var borderSize = instance.getBorderWidth(sides);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1302);
var size = innerSize + borderSize;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1304);
if (margin) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1305);
size += instance.getMargin(sides);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1308);
return size;
		};
	}
);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1313);
if (!SUPPORT_OPTIONAL_TBODY) {
	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1314);
A.DOM._ADD_HTML = A.DOM.addHTML;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1316);
A.DOM.addHTML = function(node, content, where) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "addHTML", 1316);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1317);
var nodeName = (node.nodeName && node.nodeName.toLowerCase()) || STR_EMPTY;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1319);
var tagName = STR_EMPTY;

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1321);
if (!isUndefined(content)) {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1322);
if (isString(content)) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1323);
tagName = (REGEX_TAGNAME.exec(content) || ARRAY_EMPTY_STRINGS)[1];
			}
			else {_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1325);
if (content.nodeType && content.nodeType == 11 && content.childNodes.length) { // a doc frag
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1326);
tagName = content.childNodes[0].nodeName;
			}
			else {_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1328);
if (content.nodeName) { // a node
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1329);
tagName = content.nodeName;
			}}}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1332);
tagName = tagName && tagName.toLowerCase();
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1335);
if (nodeName == 'table' && tagName == 'tr') {
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1336);
node = node.getElementsByTagName('tbody')[0] || node.appendChild(node.ownerDocument.createElement('tbody'));

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1338);
var whereNodeName = ((where && where.nodeName) || STR_EMPTY).toLowerCase();

			// Assuming if the "where" is a tbody node,
			// we're trying to prepend to a table. Attempt to
			// grab the first child of the tbody.
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1343);
if (whereNodeName == 'tbody' && where.childNodes.length > 0) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1344);
where = where.firstChild;
			}
		}

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1348);
return A.DOM._ADD_HTML(node, content, where);
	};
}

/**
 * Augment the <a href="NodeList.html">YUI3 NodeList</a> with more util methods.
 *
 * Check the list of <a href="NodeList.html#methods">Methods</a> available for
 * AUI NodeList.
 *
 * @class A.NodeList
 * @constructor
 * @uses A.Node
 */
 _yuitest_coverline("build/aui-node-base/aui-node-base.js", 1362);
ANodeList.importMethod(
	NODE_PROTO,
	[
		'after',

		'appendTo',

		'attr',

		'before',

		'empty',

		'getX',

		'getXY',

		'getY',

		'hover',

		'html',

		'innerHeight',

		'innerWidth',

		'outerHeight',

		'outerHTML',

		'outerWidth',

		'prepend',

		'prependTo',

		'purge',

		'selectText',

		'selectable',

		'setX',

		'setXY',

		'setY',

		'text',

		'toggle',

		'unselectable',

		'val'
	]
);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1421);
A.mix(
	NODELIST_PROTO,
	{
		/**
		 * See <a href="Node.html#method_all">Node all</a>.
		 *
		 * @method all
		 */
		all: function(selector) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "all", 1429);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1430);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1432);
var newNodeList = [];
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1433);
var nodes = instance._nodes;
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1434);
var length = nodes.length;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1436);
var subList;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1438);
for (var i = 0; i < length; i++) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1439);
subList = A.Selector.query(selector, nodes[i]);

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1441);
if (subList && subList.length) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1442);
newNodeList.push.apply(newNodeList, subList);
				}
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1446);
newNodeList = AArray.unique(newNodeList);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1448);
return A.all(newNodeList);
		},

		allNS: function(ns, selector) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "allNS", 1451);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1452);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1454);
return instance.all(formatSelectorNS(ns, selector));
		},

		/**
		 * Returns the first element in the node list collection.
		 *
		 * @method first
		 * @return {Node}
		 */
		first: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "first", 1463);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1464);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1466);
return instance.item(0);
		},

		/**
		 * See <a href="Node.html#method_getDOM">Node getDOM</a>.
		 *
		 * @method getDOM
		 */
		getDOM: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getDOM", 1474);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1475);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1477);
return ANodeList.getDOMNodes(this);
		},

		/**
		 * Returns the last element in the node list collection.
		 *
		 * @method last
		 * @return {Node}
		 */
		last: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "last", 1486);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1487);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1489);
return instance.item(instance._nodes.length - 1);
		},

		/**
		 * See <a href="Node.html#method_one">Node one</a>.
		 *
		 * @method one
		 */
		one: function(selector) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "one", 1497);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1498);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1500);
var newNode = null;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1502);
var nodes = instance._nodes;
			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1503);
var length = nodes.length;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1505);
for (var i = 0; i < length; i++) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1506);
newNode = A.Selector.query(selector, nodes[i], true);

				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1508);
if (newNode) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1509);
newNode = A.one(newNode);

					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1511);
break;
				}
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1515);
return newNode;
		},

		oneNS: function(ns, selector) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "oneNS", 1518);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1519);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1521);
return instance.one(formatSelectorNS(ns, selector));
		}
	}
);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1526);
NODELIST_PROTO.__filter = NODELIST_PROTO.filter;

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1528);
NODELIST_PROTO.filter = function(value, context) {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "filter", 1528);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1529);
var instance = this;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1531);
var newNodeList;

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1533);
if (isFunction(value)) {
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1534);
var nodes = [];

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1536);
instance.each(
			function(item, index, collection) {
				_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 6)", 1537);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1538);
if (value.call(context || item, item, index, collection)) {
					_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1539);
nodes.push(item._node);
				}
			}
		);

		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1544);
newNodeList = A.all(nodes);
	}
	else {
		_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1547);
newNodeList = NODELIST_PROTO.__filter.call(instance, value);
	}

	_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1550);
return newNodeList;
};

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1553);
A.mix(
	ANodeList,
	{
		create: function(html) {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "create", 1556);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1557);
var docFrag = A.getDoc().invoke(CREATE_DOCUMENT_FRAGMENT);

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1559);
return docFrag.append(html).get(CHILD_NODES);
		}
	}
);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1564);
A.mix(
	A,
	{
		/**
		 * Get the body node. Shortcut to <code>A.one('body')</code>.
		 *
		 * @method getBody
		 */
		getBody: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getBody", 1572);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1573);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1575);
if (!instance._bodyNode) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1576);
instance._bodyNode = A.one(DOC.body);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1579);
return instance._bodyNode;
		},

		/**
		 * Get the document node. Shortcut to <code>A.one(document)</code>.
		 *
		 * @method getDoc
		 */
		getDoc: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getDoc", 1587);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1588);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1590);
if (!instance._documentNode) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1591);
instance._documentNode = A.one(DOC);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1594);
return instance._documentNode;
		},

		/**
		 * Get the window node. Shortcut to <code>A.one(window)</code>.
		 *
		 * @method getWin
		 */
		getWin: function() {
			_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "getWin", 1602);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1603);
var instance = this;

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1605);
if (!instance._windowNode) {
				_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1606);
instance._windowNode = A.one(WIN);
			}

			_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1609);
return instance._windowNode;
		}
	}
);

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1614);
A.queryNS = function(ns, selector, methodName) {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "queryNS", 1614);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1615);
return A[methodName || 'one'](formatSelectorNS(ns, selector));
};

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1618);
A.oneNS = A.queryNS;

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1620);
A.allNS = function(ns, selector) {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "allNS", 1620);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1621);
return A.queryNS(ns, selector, 'all');
};

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1624);
A.byIdNS = function(ns, id) {
	_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "byIdNS", 1624);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1625);
return A.one(prefixSelector(ns, id));
};

// Patch for http://yuilibrary.com/projects/yui3/ticket/2531537

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1630);
var addMethod = ANodeList.addMethod;

_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1632);
AArray.each(
	['hide', 'show'],
	function(item, index, collection) {
		_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 7)", 1634);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1635);
addMethod(
			item,
			function() {
				_yuitest_coverfunc("build/aui-node-base/aui-node-base.js", "(anonymous 8)", 1637);
_yuitest_coverline("build/aui-node-base/aui-node-base.js", 1638);
return this[item].apply(this, arguments);
			}
		);
	}
);

}, '2.0.0pr1', {
    "requires": [
        "node-base",
        "node-style",
        "array-extras",
        "aui-base-lang",
        "aui-classnamemanager",
        "aui-debounce"
    ]
});
