if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-progressbar/aui-progressbar.js",
    code: []
};
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"].code=["YUI.add('aui-progressbar', function (A, NAME) {","","/**"," * The ProgressBar Utility provides a visual means of showing progress of an"," * ongoing operation. The ProgressBar can be enhanced via CSS styles to provide"," * different colors, shapes and textures. The bar can move horizontally or"," * vertically. The movement can be enhanced by using the Animation utility."," *"," * @module aui-progressbar"," */","","var L = A.Lang,","    isNumber = L.isNumber,","    isString = L.isString,","    isUndefined = L.isUndefined,","","    BLANK = '',","    DOT = '.',","    SPACE = ' ',","","    AUTO = 'auto',","    BAR = 'bar',","    BOUNDING_BOX = 'boundingBox',","    COMPLETE = 'complete',","    CONTENT_BOX = 'contentBox',","    HEIGHT = 'height',","    HORIZONTAL = 'horizontal',","    LABEL = 'label',","    LINE_HEIGHT = 'lineHeight',","    MAX = 'max',","    MIN = 'min',","    OFFSET_HEIGHT = 'offsetHeight',","    ORIENTATION = 'orientation',","    P = 'p',","    PROGRESS = 'progress',","    PX = 'px',","    RATIO = 'ratio',","    STEP = 'step',","    TEXT = 'text',","    TEXT_NODE = 'textNode',","    USE_ARIA = 'useARIA',","    VALUE = 'value',","    VALUEMAX = 'valuemax',","    VALUEMIN = 'valuemin',","    VALUENOW = 'valuenow',","    VERTICAL = 'vertical',","    WIDTH = 'width',","","    toNumber = function(v) {","        return parseFloat(v) || 0;","    },","","    getCN = A.getClassName,","","    CSS_BAR = getCN(BAR),","    CSS_HORIZONTAL = getCN(HORIZONTAL),","    CSS_VERTICAL = getCN(VERTICAL),","","    TPL_TEXT = '<p></p>';","","/**"," * <p><img src=\"assets/images/aui-progressbar/main.png\"/></p>"," *"," * A base class for Progressbar, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li>A visual means of showing progress of an ongoing operation</li>"," *    <li>Can be enhanced via CSS styles to provide different colors, shapes and textures</li>"," *    <li>The bar can move horizontally or vertically</li>"," *    <li>The movement can be enhanced by using the Animation utility</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var progress = new A.ProgressBar({"," *  boundingBox: '#boudingBox',"," *  orientation: 'horizontal',"," *  width: 300"," * })"," * .render();"," * </code></pre>"," *"," * Check the list of <a href=\"ProgressBar.html#configattributes\">Configuration Attributes</a> available for"," * ProgressBar."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class ProgressBar"," * @constructor"," * @extends Component"," */","var ProgressBar = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property ProgressBar.NAME","         * @type String","         * @static","         */","        NAME: PROGRESS,","","        /**","         * Static property used to define the default attribute","         * configuration for the ProgressBar.","         *","         * @property ProgressBar.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            useARIA: {","                value: true","            },","","            /**","             * Display height of the progressbar.","             *","             * @attribute height","             * @default 25","             * @type int | String","             */","            height: {","                valueFn: function() {","                    return this.get(BOUNDING_BOX).get(OFFSET_HEIGHT) || 25;","                }","            },","","            /**","             * Display label of the progressbar. If not specified try to query","             * using HTML_PARSER an element inside boundingBox which matches","             * <code>aui-progressbar-text</code> and get its innerHTML to be","             * used as label.","             *","             * @attribute label","             * @default ''","             * @type String","             */","            label: {","            },","","            /**","             * Represents the top value for the bar. The bar will be fully","             * extended when reaching this value. Values higher than this will","             * be ignored.","             *","             * @attribute max","             * @default 100","             * @type int","             */","            max: {","                validator: isNumber,","                value: 100","            },","","            /**","             * Represents the lowest value for the bar. The bar will be","             * totally collapsed when reaching this value. Values lower than","             * this will be ignored.","             *","             * @attribute min","             * @default 0","             * @type int","             */","            min: {","                validator: isNumber,","                value: 0","            },","","            /**","             * Display orientation of the progressbar (i.e. vertical or","             * horizontal).","             *","             * @attribute orientation","             * @default HORIZONTAL","             * @type String","             */","            orientation: {","                value: HORIZONTAL,","                validator: function(val) {","                    return isString(val) && (val === HORIZONTAL || val === VERTICAL);","                }","            },","","            /**","             * Calculate the ratio based on <code>max</code> and","             * <code>min</code> values.","             *","             * @attribute ratio","             * @readOnly","             * @type number","             */","            ratio: {","                getter: '_getRatio',","                readOnly: true","            },","","            /**","             * Calculate the progressbar step based on <code>ratio</code>","             * value.","             *","             * @attribute step","             * @readOnly","             * @type number","             */","            step: {","                getter: '_getStep',","                readOnly: true","            },","","            /**","             * DOM Node to display the text of the progressbar. If not","             * specified try to query using HTML_PARSER an element inside","             * contentBox which matches <code>aui-progressbar-text</code>.","             *","             * @attribute textNode","             * @default Generated div element.","             * @type String","             */","            textNode: {","                valueFn: function() {","                    return A.Node.create(TPL_TEXT);","                }","            },","","            /**","             * The value for the bar. Valid values are in between the minValue","             * and maxValue attributes.","             *","             * @attribute value","             * @default 0","             * @type int | String","             */","            value: {","                setter: toNumber,","                validator: function(val) {","                    return isNumber(toNumber(val)) && ((val >= this.get(MIN)) && (val <= this.get(MAX)));","                },","                value: 0","            }","        },","","        /**","         * Object hash, defining how attribute values are to be parsed from","         * markup contained in the widget's bounding box.","         *","         * @property ProgressBar.HTML_PARSER","         * @type Object","         * @static","         */","        HTML_PARSER: {","            label: function(boundingBox) {","                var textNode = boundingBox.one(P);","","                if (textNode) {","                    return textNode.html();","                }","            },","","            textNode: P","        },","","        UI_ATTRS: [LABEL, ORIENTATION, VALUE],","","        prototype: {","            /**","             * Create the DOM structure for the ProgressBar. Lifecycle.","             *","             * @method renderUI","             * @protected","             */","            renderUI: function() {","                var instance = this;","","                instance.get(CONTENT_BOX).addClass(CSS_BAR);","","                instance._renderTextNodeIfLabelSet();","            },","","            syncUI: function() {","                var instance = this;","","                if (instance.get(USE_ARIA)) {","                    instance.plug(A.Plugin.Aria, {","                        attributes: {","                            value: VALUENOW,","                            max: VALUEMAX,","                            min: VALUEMIN,","                            orientation: ORIENTATION,","                            label: LABEL","                        }","                    });","                }","            },","","            /**","             * Calculate the boundingBox size based on the","             * <code>orientation</code> of the progressbar. If the orientation","             * is HORIZONTAL get the width, if the orientation is VERTICAL get","             * the height.","             *","             * @method _getBoundingBoxSize","             * @protected","             * @return {number}","             */","            _getBoundingBoxSize: function() {","                var instance = this;","                var boundingBox = instance.get(BOUNDING_BOX);","","                return toNumber(","                    boundingBox.getStyle(","                        this.get(ORIENTATION) === HORIZONTAL ? WIDTH : HEIGHT","                    )","                );","            },","","            /**","             * Calculate the number of pixels to set the <code>contentBox</code> bar.","             *","             * @method _getPixelStep","             * @protected","             * @return {number}","             */","            _getPixelStep: function() {","                var instance = this;","","                return instance._getBoundingBoxSize() * instance.get(RATIO);","            },","","            /**","             * Calculate the ratio based on <code>max</code> and","             * <code>min</code> values.","             *","             * @method _getRatio","             * @protected","             * @return {number}","             */","            _getRatio: function() {","                var instance = this;","                var min = instance.get(MIN);","                var ratio = (instance.get(VALUE) - min) / (instance.get(MAX) - min);","","                return Math.max(ratio, 0);","            },","","            /**","             * Calculate the progressbar step based on <code>ratio</code>","             * value.","             *","             * @method _getStep","             * @protected","             * @return {number}","             */","            _getStep: function() {","                return this.get(RATIO) * 100;","            },","","            /**","             * Render the <code>textNode</code> of the progressbar if label is set.","             *","             * @method _renderTextNodeIfLabelSet","             * @protected","             */","            _renderTextNodeIfLabelSet: function() {","                var instance = this;","","                if (!isUndefined(instance.get(LABEL))) {","                    instance.get(CONTENT_BOX).append(instance.get(TEXT_NODE));","                }","            },","","            /**","             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the","             * <code>label</code> attribute.","             *","             * @method _uiSetLabel","             * @param {String} val Display label","             * @protected","             */","            _uiSetLabel: function(val) {","                var instance = this,","                    textNode = instance.get(TEXT_NODE);","","                if (!textNode.inDoc()) {","                    instance._renderTextNodeIfLabelSet();","                }","","                textNode.html(val);","            },","","            /**","             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the","             * <code>orientation</code> attribute.","             *","             * @method _uiSetOrientation","             * @param {String} val Orientation","             * @protected","             */","            _uiSetOrientation: function(val) {","                var instance = this;","                var boundingBox = instance.get(BOUNDING_BOX);","                var horizontal = (val === HORIZONTAL);","","                boundingBox.toggleClass(CSS_HORIZONTAL, horizontal);","                boundingBox.toggleClass(CSS_VERTICAL, !horizontal);","","                instance._uiSetValue(instance.get(VALUE));","                instance._uiSizeTextNode();","            },","","            /**","             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the","             * <code>value</code> attribute.","             *","             * @method _uiSetValue","             * @param {String} val Progress value","             * @protected","             */","            _uiSetValue: function(val) {","                var instance = this;","                var pixelStep = instance._getPixelStep();","","                var styles = {};","","                if (instance.get(ORIENTATION) === HORIZONTAL) {","                    styles = {","                        height: '100%',","                        top: AUTO,","                        width: pixelStep+PX","                    };","                }","                else {","                     styles = {","                        height: pixelStep+PX,","                        top: toNumber(instance._getBoundingBoxSize() - pixelStep)+PX,","                        width: '100%'","                    };","                }","","                if (instance.get(STEP) >= 100) {","                    instance.fire(COMPLETE);","                }","","                instance.get(CONTENT_BOX).setStyles(styles);","            },","","            /**","             * Sync the size of the ProgressBar when some UI attribute change.","             *","             * @method _uiSizeTextNode","             * @protected","             */","            _uiSizeTextNode: function() {","                var instance = this;","                var boundingBox = instance.get(BOUNDING_BOX);","                var textNode = instance.get(TEXT_NODE);","","                textNode.setStyle(","                    LINE_HEIGHT,","                    boundingBox.getStyle(HEIGHT)","                );","            }","        }","    }",");","","A.ProgressBar = ProgressBar;","","}, '2.0.0pr1', {\"requires\": [\"aui-node\", \"aui-component\", \"aui-aria\"]});"];
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"].lines = {"1":0,"12":0,"50":0,"92":0,"125":0,"181":0,"222":0,"237":0,"253":0,"255":0,"256":0,"273":0,"275":0,"277":0,"281":0,"283":0,"284":0,"307":0,"308":0,"310":0,"325":0,"327":0,"339":0,"340":0,"341":0,"343":0,"355":0,"365":0,"367":0,"368":0,"381":0,"384":0,"385":0,"388":0,"400":0,"401":0,"402":0,"404":0,"405":0,"407":0,"408":0,"420":0,"421":0,"423":0,"425":0,"426":0,"433":0,"440":0,"441":0,"444":0,"454":0,"455":0,"456":0,"458":0,"467":0};
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"].functions = {"toNumber:49":0,"valueFn:124":0,"validator:180":0,"valueFn:221":0,"validator:236":0,"label:252":0,"renderUI:272":0,"syncUI:280":0,"_getBoundingBoxSize:306":0,"_getPixelStep:324":0,"_getRatio:338":0,"_getStep:354":0,"_renderTextNodeIfLabelSet:364":0,"_uiSetLabel:380":0,"_uiSetOrientation:399":0,"_uiSetValue:419":0,"_uiSizeTextNode:453":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"].coveredLines = 55;
_yuitest_coverage["build/aui-progressbar/aui-progressbar.js"].coveredFunctions = 18;
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 1);
YUI.add('aui-progressbar', function (A, NAME) {

/**
 * The ProgressBar Utility provides a visual means of showing progress of an
 * ongoing operation. The ProgressBar can be enhanced via CSS styles to provide
 * different colors, shapes and textures. The bar can move horizontally or
 * vertically. The movement can be enhanced by using the Animation utility.
 *
 * @module aui-progressbar
 */

_yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 12);
var L = A.Lang,
    isNumber = L.isNumber,
    isString = L.isString,
    isUndefined = L.isUndefined,

    BLANK = '',
    DOT = '.',
    SPACE = ' ',

    AUTO = 'auto',
    BAR = 'bar',
    BOUNDING_BOX = 'boundingBox',
    COMPLETE = 'complete',
    CONTENT_BOX = 'contentBox',
    HEIGHT = 'height',
    HORIZONTAL = 'horizontal',
    LABEL = 'label',
    LINE_HEIGHT = 'lineHeight',
    MAX = 'max',
    MIN = 'min',
    OFFSET_HEIGHT = 'offsetHeight',
    ORIENTATION = 'orientation',
    P = 'p',
    PROGRESS = 'progress',
    PX = 'px',
    RATIO = 'ratio',
    STEP = 'step',
    TEXT = 'text',
    TEXT_NODE = 'textNode',
    USE_ARIA = 'useARIA',
    VALUE = 'value',
    VALUEMAX = 'valuemax',
    VALUEMIN = 'valuemin',
    VALUENOW = 'valuenow',
    VERTICAL = 'vertical',
    WIDTH = 'width',

    toNumber = function(v) {
        _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "toNumber", 49);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 50);
return parseFloat(v) || 0;
    },

    getCN = A.getClassName,

    CSS_BAR = getCN(BAR),
    CSS_HORIZONTAL = getCN(HORIZONTAL),
    CSS_VERTICAL = getCN(VERTICAL),

    TPL_TEXT = '<p></p>';

/**
 * <p><img src="assets/images/aui-progressbar/main.png"/></p>
 *
 * A base class for Progressbar, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li>A visual means of showing progress of an ongoing operation</li>
 *    <li>Can be enhanced via CSS styles to provide different colors, shapes and textures</li>
 *    <li>The bar can move horizontally or vertically</li>
 *    <li>The movement can be enhanced by using the Animation utility</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var progress = new A.ProgressBar({
 *  boundingBox: '#boudingBox',
 *  orientation: 'horizontal',
 *  width: 300
 * })
 * .render();
 * </code></pre>
 *
 * Check the list of <a href="ProgressBar.html#configattributes">Configuration Attributes</a> available for
 * ProgressBar.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class ProgressBar
 * @constructor
 * @extends Component
 */
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 92);
var ProgressBar = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property ProgressBar.NAME
         * @type String
         * @static
         */
        NAME: PROGRESS,

        /**
         * Static property used to define the default attribute
         * configuration for the ProgressBar.
         *
         * @property ProgressBar.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            useARIA: {
                value: true
            },

            /**
             * Display height of the progressbar.
             *
             * @attribute height
             * @default 25
             * @type int | String
             */
            height: {
                valueFn: function() {
                    _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "valueFn", 124);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 125);
return this.get(BOUNDING_BOX).get(OFFSET_HEIGHT) || 25;
                }
            },

            /**
             * Display label of the progressbar. If not specified try to query
             * using HTML_PARSER an element inside boundingBox which matches
             * <code>aui-progressbar-text</code> and get its innerHTML to be
             * used as label.
             *
             * @attribute label
             * @default ''
             * @type String
             */
            label: {
            },

            /**
             * Represents the top value for the bar. The bar will be fully
             * extended when reaching this value. Values higher than this will
             * be ignored.
             *
             * @attribute max
             * @default 100
             * @type int
             */
            max: {
                validator: isNumber,
                value: 100
            },

            /**
             * Represents the lowest value for the bar. The bar will be
             * totally collapsed when reaching this value. Values lower than
             * this will be ignored.
             *
             * @attribute min
             * @default 0
             * @type int
             */
            min: {
                validator: isNumber,
                value: 0
            },

            /**
             * Display orientation of the progressbar (i.e. vertical or
             * horizontal).
             *
             * @attribute orientation
             * @default HORIZONTAL
             * @type String
             */
            orientation: {
                value: HORIZONTAL,
                validator: function(val) {
                    _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "validator", 180);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 181);
return isString(val) && (val === HORIZONTAL || val === VERTICAL);
                }
            },

            /**
             * Calculate the ratio based on <code>max</code> and
             * <code>min</code> values.
             *
             * @attribute ratio
             * @readOnly
             * @type number
             */
            ratio: {
                getter: '_getRatio',
                readOnly: true
            },

            /**
             * Calculate the progressbar step based on <code>ratio</code>
             * value.
             *
             * @attribute step
             * @readOnly
             * @type number
             */
            step: {
                getter: '_getStep',
                readOnly: true
            },

            /**
             * DOM Node to display the text of the progressbar. If not
             * specified try to query using HTML_PARSER an element inside
             * contentBox which matches <code>aui-progressbar-text</code>.
             *
             * @attribute textNode
             * @default Generated div element.
             * @type String
             */
            textNode: {
                valueFn: function() {
                    _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "valueFn", 221);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 222);
return A.Node.create(TPL_TEXT);
                }
            },

            /**
             * The value for the bar. Valid values are in between the minValue
             * and maxValue attributes.
             *
             * @attribute value
             * @default 0
             * @type int | String
             */
            value: {
                setter: toNumber,
                validator: function(val) {
                    _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "validator", 236);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 237);
return isNumber(toNumber(val)) && ((val >= this.get(MIN)) && (val <= this.get(MAX)));
                },
                value: 0
            }
        },

        /**
         * Object hash, defining how attribute values are to be parsed from
         * markup contained in the widget's bounding box.
         *
         * @property ProgressBar.HTML_PARSER
         * @type Object
         * @static
         */
        HTML_PARSER: {
            label: function(boundingBox) {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "label", 252);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 253);
var textNode = boundingBox.one(P);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 255);
if (textNode) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 256);
return textNode.html();
                }
            },

            textNode: P
        },

        UI_ATTRS: [LABEL, ORIENTATION, VALUE],

        prototype: {
            /**
             * Create the DOM structure for the ProgressBar. Lifecycle.
             *
             * @method renderUI
             * @protected
             */
            renderUI: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "renderUI", 272);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 273);
var instance = this;

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 275);
instance.get(CONTENT_BOX).addClass(CSS_BAR);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 277);
instance._renderTextNodeIfLabelSet();
            },

            syncUI: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "syncUI", 280);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 281);
var instance = this;

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 283);
if (instance.get(USE_ARIA)) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 284);
instance.plug(A.Plugin.Aria, {
                        attributes: {
                            value: VALUENOW,
                            max: VALUEMAX,
                            min: VALUEMIN,
                            orientation: ORIENTATION,
                            label: LABEL
                        }
                    });
                }
            },

            /**
             * Calculate the boundingBox size based on the
             * <code>orientation</code> of the progressbar. If the orientation
             * is HORIZONTAL get the width, if the orientation is VERTICAL get
             * the height.
             *
             * @method _getBoundingBoxSize
             * @protected
             * @return {number}
             */
            _getBoundingBoxSize: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_getBoundingBoxSize", 306);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 307);
var instance = this;
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 308);
var boundingBox = instance.get(BOUNDING_BOX);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 310);
return toNumber(
                    boundingBox.getStyle(
                        this.get(ORIENTATION) === HORIZONTAL ? WIDTH : HEIGHT
                    )
                );
            },

            /**
             * Calculate the number of pixels to set the <code>contentBox</code> bar.
             *
             * @method _getPixelStep
             * @protected
             * @return {number}
             */
            _getPixelStep: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_getPixelStep", 324);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 325);
var instance = this;

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 327);
return instance._getBoundingBoxSize() * instance.get(RATIO);
            },

            /**
             * Calculate the ratio based on <code>max</code> and
             * <code>min</code> values.
             *
             * @method _getRatio
             * @protected
             * @return {number}
             */
            _getRatio: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_getRatio", 338);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 339);
var instance = this;
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 340);
var min = instance.get(MIN);
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 341);
var ratio = (instance.get(VALUE) - min) / (instance.get(MAX) - min);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 343);
return Math.max(ratio, 0);
            },

            /**
             * Calculate the progressbar step based on <code>ratio</code>
             * value.
             *
             * @method _getStep
             * @protected
             * @return {number}
             */
            _getStep: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_getStep", 354);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 355);
return this.get(RATIO) * 100;
            },

            /**
             * Render the <code>textNode</code> of the progressbar if label is set.
             *
             * @method _renderTextNodeIfLabelSet
             * @protected
             */
            _renderTextNodeIfLabelSet: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_renderTextNodeIfLabelSet", 364);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 365);
var instance = this;

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 367);
if (!isUndefined(instance.get(LABEL))) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 368);
instance.get(CONTENT_BOX).append(instance.get(TEXT_NODE));
                }
            },

            /**
             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the
             * <code>label</code> attribute.
             *
             * @method _uiSetLabel
             * @param {String} val Display label
             * @protected
             */
            _uiSetLabel: function(val) {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_uiSetLabel", 380);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 381);
var instance = this,
                    textNode = instance.get(TEXT_NODE);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 384);
if (!textNode.inDoc()) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 385);
instance._renderTextNodeIfLabelSet();
                }

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 388);
textNode.html(val);
            },

            /**
             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the
             * <code>orientation</code> attribute.
             *
             * @method _uiSetOrientation
             * @param {String} val Orientation
             * @protected
             */
            _uiSetOrientation: function(val) {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_uiSetOrientation", 399);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 400);
var instance = this;
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 401);
var boundingBox = instance.get(BOUNDING_BOX);
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 402);
var horizontal = (val === HORIZONTAL);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 404);
boundingBox.toggleClass(CSS_HORIZONTAL, horizontal);
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 405);
boundingBox.toggleClass(CSS_VERTICAL, !horizontal);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 407);
instance._uiSetValue(instance.get(VALUE));
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 408);
instance._uiSizeTextNode();
            },

            /**
             * Invoked automatically by the UI_ATTRS Widget API when bind or sync the
             * <code>value</code> attribute.
             *
             * @method _uiSetValue
             * @param {String} val Progress value
             * @protected
             */
            _uiSetValue: function(val) {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_uiSetValue", 419);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 420);
var instance = this;
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 421);
var pixelStep = instance._getPixelStep();

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 423);
var styles = {};

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 425);
if (instance.get(ORIENTATION) === HORIZONTAL) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 426);
styles = {
                        height: '100%',
                        top: AUTO,
                        width: pixelStep+PX
                    };
                }
                else {
                     _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 433);
styles = {
                        height: pixelStep+PX,
                        top: toNumber(instance._getBoundingBoxSize() - pixelStep)+PX,
                        width: '100%'
                    };
                }

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 440);
if (instance.get(STEP) >= 100) {
                    _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 441);
instance.fire(COMPLETE);
                }

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 444);
instance.get(CONTENT_BOX).setStyles(styles);
            },

            /**
             * Sync the size of the ProgressBar when some UI attribute change.
             *
             * @method _uiSizeTextNode
             * @protected
             */
            _uiSizeTextNode: function() {
                _yuitest_coverfunc("build/aui-progressbar/aui-progressbar.js", "_uiSizeTextNode", 453);
_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 454);
var instance = this;
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 455);
var boundingBox = instance.get(BOUNDING_BOX);
                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 456);
var textNode = instance.get(TEXT_NODE);

                _yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 458);
textNode.setStyle(
                    LINE_HEIGHT,
                    boundingBox.getStyle(HEIGHT)
                );
            }
        }
    }
);

_yuitest_coverline("build/aui-progressbar/aui-progressbar.js", 467);
A.ProgressBar = ProgressBar;

}, '2.0.0pr1', {"requires": ["aui-node", "aui-component", "aui-aria"]});
