if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-rating-base/aui-rating-base.js",
    code: []
};
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"].code=["YUI.add('aui-rating-base', function (A, NAME) {","","/**"," * The Rating Utility - The Star Rating creates a non-obstrusive star rating"," * control, could be based on a set of radio input boxes."," *"," * @module aui-rating"," */","","var Lang = A.Lang,","    isBoolean = Lang.isBoolean,","    isNumber = Lang.isNumber,","    isString = Lang.isString,","","    isNodeList = function(v) {","        return (v instanceof A.NodeList);","    },","","    isNode = function(v) {","        return (v instanceof A.Node);","    },","","    ANCHOR = 'a',","    BOUNDING_BOX = 'boundingBox',","    CAN_RESET = 'canReset',","    CLEARFIX = 'clearfix',","    CONTENT_BOX = 'contentBox',","    DEFAULT_SELECTED = 'defaultSelected',","    DISABLED = 'disabled',","    DOT = '.',","    ELEMENT = 'element',","    ELEMENTS = 'elements',","    HELPER = 'helper',","    HOVER = 'hover',","    HREF = 'href',","    ID = 'id',","    INPUT = 'input',","    INPUT_NAME = 'inputName',","    LABEL = 'label',","    LABEL_NODE = 'labelNode',","    NAME = 'name',","    NODE_NAME = 'nodeName',","    OFF = 'off',","    ON = 'on',","    RATING = 'rating',","    SELECTED_INDEX = 'selectedIndex',","    SHOW_TITLE = 'showTitle',","    SIZE = 'size',","    STR_EMPTY = '',","    TITLE = 'title',","    VALUE = 'value',","","    EV_RATING_ITEM_CLICK = 'itemClick',","    EV_RATING_ITEM_OUT = 'itemOut',","    EV_RATING_ITEM_OVER = 'itemOver',","    EV_RATING_ITEM_SELECT = 'itemSelect',","","    getCN = A.getClassName,","","    CSS_STAR = getCN('icon', 'star'),","    CSS_HIDE_TEXT = getCN('hide', 'text'),","    CSS_STAR_EMPTY = getCN('icon', 'star', 'empty'),","    CSS_RATING_LABEL = getCN(RATING, LABEL),","","    TPL_ELEMENT = '<a class=\"{cssClasses}\"></a>',","    TPL_LABEL = '<span class=\"' + CSS_RATING_LABEL + '\"></span>';","","/**"," * <p><img src=\"assets/images/aui-rating/main.png\"/></p>"," *"," * A base class for Rating, providing:"," * <ul>"," *    <li>A non-obstrusive star rating control</li>"," *    <li>Could be based on a set of radio input boxes</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var instance = new A.Rating({"," *   boundingBox: '#rating',"," *   defaultSelected: 3,"," *   disabled: false,"," *   label: 'Label'"," * }).render();"," * </code></pre>"," *"," * Check the list of <a href=\"Rating.html#configattributes\">Configuration Attributes</a> available for"," * Rating."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class Rating"," * @constructor"," * @extends Component"," */","var Rating = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property Rating.NAME","         * @type String","         * @static","         */","        NAME: 'rating',","","        /**","         * Static property used to define the default attribute","         * configuration for the Rating.","         *","         * @property Rating.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            /**","             * Whether the Rating is disabled or not. Disabled Ratings don't allow","             * hover or click, just display selected stars.","             *","             * @attribute disabled","             * @default false","             * @type boolean","             */","            disabled: {","                value: false,","                validator: isBoolean","            },","","            /**","             * If <code>true</code> could be reseted (i.e., have no values","             * selected).","             *","             * @attribute canReset","             * @default true","             * @type boolean","             */","            canReset: {","                value: true,","                validator: isBoolean","            },","","            cssClasses: {","                value: {","                    element: CSS_STAR_EMPTY,","                    hover: CSS_STAR,","                    off: CSS_STAR_EMPTY,","                    on: CSS_STAR","                }","            },","","            /**","             * The number of selected starts when the Rating render.","             *","             * @attribute defaultSelected","             * @default 0","             * @writeOnce","             * @type Number","             */","            defaultSelected: {","                value: 0,","                writeOnce: true,","                validator: isNumber","            },","","            /**","             * <a href=\"NodeList.html\">NodeList</a> of elements used on the","             * Rating. Each element is one Star.","             *","             * @attribute elements","             * @writeOnce","             * @readOnly","             * @type NodeList","             */","            elements: {","                validator: isNodeList","            },","","            /**","             * Hidden input to handle the selected value. This hidden input","             * replace the radio elements and keep the same name.","             *","             * @attribute hiddenInput","             * @type Node","             */","            hiddenInput: {","                validator: isNode","            },","","            /**","             * Name of the <a","             * href=\"Rating.html#config_hiddenInput\">hiddenInput</a> element. If","             * not specified will use the name of the replaced radio.","             *","             * @attribute inputName","             * @default ''","             * @type String","             */","            inputName: {","                value: STR_EMPTY,","                validator: isString","            },","","            /**","             * Label to be displayed with the Rating elements.","             *","             * @attribute label","             * @default ''","             * @type String","             */","            label: {","                value: STR_EMPTY,","                validator: isString","            },","","            /**","             * DOM Node to display the text of the StarRating. If not","             * specified try to query using HTML_PARSER an element inside","             * boundingBox which matches <code>aui-rating-label-element</code>.","             *","             * @attribute labelNode","             * @default Generated div element.","             * @type String","             */","            labelNode: {","                valueFn: function() {","                    return A.Node.create(TPL_LABEL);","                },","                validator: isNode","            },","","            /**","             * Stores the index of the selected element.","             *","             * @attribute selectedIndex","             * @default -1","             * @type Number","             */","            selectedIndex: {","                value: -1,","                validator: isNumber","            },","","            /**","             * If <code>true</code> will extract the value of the","             * <code>title</code> attribute on the radio, and use it on the","             * generated Rating elements.","             *","             * @attribute showTitle","             * @default true","             * @type boolean","             */","            showTitle: {","                value: true,","                validator: isBoolean","            },","","            /**","             * Number of Rating elements to be displayed.","             *","             * @attribute size","             * @default 5","             * @type Number","             */","            size: {","                value: 5,","                validator: function(v) {","                    return isNumber(v) && (v > 0);","                }","            },","","            /**","             * If set, will be used when there is no DOM <code>title</code> on the","             * radio elements.","             *","             * @attribute title","             * @default null","             * @type String","             */","            title: null,","","            /**","             * Stores the value of the current selected Rating element.","             *","             * @attribute value","             * @default null","             * @type String","             */","            value: null","        },","","        /**","         * Object hash, defining how attribute values are to be parsed from","         * markup contained in the widget's content box.","         *","         * @property StarRating.HTML_PARSER","         * @type Object","         * @static","         */","        HTML_PARSER: {","            elements: function(srcNode) {","                return srcNode.all('a');","            },","","            label: function(srcNode) {","                var labelNode = srcNode.one(DOT + CSS_RATING_LABEL);","","                if (labelNode) {","                    return labelNode.html();","                }","            },","","            labelNode: DOT + CSS_RATING_LABEL","        },","","        prototype: {","            BOUNDING_TEMPLATE: '<span></span>',","            CONTENT_TEMPLATE: '<span></span>',","","            /**","             * Construction logic executed during Rating instantiation. Lifecycle.","             *","             * @method initializer","             * @protected","             */","            initializer: function() {","                var instance = this;","","                instance.inputElementsData = {};","","                instance.get(BOUNDING_BOX).addClass(CSS_HIDE_TEXT);","","                instance.after('labelChange', this._afterSetLabel);","            },","","            /**","             * Create the DOM structure for the Rating. Lifecycle.","             *","             * @method renderUI","             * @protected","             */","            renderUI: function() {","                var instance = this,","                    contentBox = instance.get(CONTENT_BOX);","","                instance._parseInputElements();","                instance._renderLabel();","                instance._renderElements();","            },","","            /**","             * Bind the events on the Rating UI. Lifecycle.","             *","             * @method bindUI","             * @protected","             */","            bindUI: function() {","                var instance = this;","","                instance._createEvents();","","                instance.on({","                    click: instance._handleClickEvent,","                    mouseover: instance._handleMouseOverEvent,","                    mouseout: instance._handleMouseOutEvent","                });","            },","","            /**","             * Sync the Rating UI. Lifecycle.","             *","             * @method syncUI","             * @protected","             */","            syncUI: function() {","                var instance = this;","","                instance._syncElements();","                instance._syncLabelUI();","            },","","            /**","             * Clear all selected starts to the default state.","             *","             * @method clearSelection","             */","            clearSelection: function() {","                var instance = this,","                    cssClasses = instance.get('cssClasses');","","                instance.get(ELEMENTS).each(function(node) {","                    node.removeClass(cssClasses.on);","                    node.removeClass(cssClasses.hover);","                    node.addClass(cssClasses.element);","                });","            },","","            /**","             * Selects the <code>index</code> Rating element.","             *","             * @method select","             * @param {Number} index Index to be selected","             */","            select: function(index) {","                var instance = this,","                    oldIndex = instance.get(SELECTED_INDEX),","                    canReset = instance.get(CAN_RESET);","","                // clear selection when the selected element is clicked","                if (canReset && (oldIndex == index)) {","                    index = -1;","                }","","                instance.set(SELECTED_INDEX, index);","","                var selectedIndex = instance.get(SELECTED_INDEX),","                    data = instance._getInputData(selectedIndex),","                    title = (TITLE in data) ? data.title : STR_EMPTY,","                    value = (VALUE in data) ? data.value : selectedIndex;","","                instance.fillTo(selectedIndex);","","                instance.set(TITLE, title);","                instance.set(VALUE, value);","","                var hiddenInput = instance.get('hiddenInput');","","                hiddenInput.setAttribute(TITLE, title);","                hiddenInput.setAttribute(VALUE, value);","            },","","            /**","             * Add the <code>className</code> on the the <code>index</code> element","             * and all the previous Rating elements.","             *","             * @method fillTo","             * @param {Number} index Index to be selected","             * @param {String} className Class name to be applied when fill the Rating elements","             */","            fillTo: function(index, className) {","                var instance = this,","                    cssClasses = instance.get('cssClasses');","","                instance.clearSelection();","","                if (index >= 0) {","                    instance.get(ELEMENTS).some(function(node, i) {","                        node.addClass(className || cssClasses.on);","                        node.removeClass(cssClasses.element);","                        return (i == Math.floor(index));","                    });","                }","            },","","            /**","             * Finds the index of the <code>elem</code>.","             *","             * @method indexOf","             * @param {Node} elem Rating element","             * @return {Number}","             */","            indexOf: function(elem) {","                var instance = this;","","                return instance.get(ELEMENTS).indexOf(elem);","            },","","            /**","             * Check if the Rating element can fire the custom events. Disabled","             * elements won't fire nothing.","             *","             * @method _canFireCustomEvent","             * @param {EventFacade} event","             * @protected","             * @return {Boolean}","             */","            _canFireCustomEvent: function(event) {","                var instance = this,","                    domTarget = event.domEvent.target;","","                // checks if the widget is not disabled and if the dom event is firing with a item as target","                // do not fire custom events for other elements into the boundingBox","                return !instance.get(DISABLED) && domTarget.test('a');","            },","","            /**","             * Create rating elements based on the <code>size</code>","             * attribute. It's only invoked when the HTML_PARSER does not find","             * nothing.","             *","             * @method _createElements","             * @protected","             * @return {NodeList}","             */","            _createElements: function() {","                var instance = this,","                    cssClasses = instance.get('cssClasses'),","                    size = this.get(SIZE),","                    elements = [];","","                for (var i = 0; i < size; i++) {","                    elements.push(","                        Lang.sub(TPL_ELEMENT, {","                            cssClasses: cssClasses.element","                        })","                    );","                }","","                return A.NodeList.create(elements.join(STR_EMPTY));","            },","","            /**","             * Create the custom events.","             *","             * @method _createEvents","             * @protected","             */","            _createEvents: function() {","                var instance = this;","","                // create publish function for kweight optimization","                var publish = function(name, fn) {","                    instance.publish(name, {","                        defaultFn: fn,","                        queuable: false,","                        emitFacade: true,","                        bubbles: true","                    });","                };","","                /**","                 * Handles the itemClick event.","                 *","                 * @event itemClick","                 * @preventable _defRatingItemClickFn","                 * @param {Event.Facade} event The itemClick event.","                 * @type {Event.Custom}","                 */","                publish(","                    EV_RATING_ITEM_CLICK,","                    this._defRatingItemClickFn","                );","","                /**","                 * Handles the itemSelect event.","                 *","                 * @event itemSelect","                 * @preventable _defRatingItemSelectFn","                 * @param {Event.Facade} event The itemSelect event.","                 * @type {Event.Custom}","                 */","                publish(","                    EV_RATING_ITEM_SELECT,","                    this._defRatingItemSelectFn","                );","","                /**","                 * Handles the itemOver event.","                 *","                 * @event itemSelect","                 * @preventable _defRatingItemOverFn","                 * @param {Event.Facade} event The itemOver event.","                 * @type {Event.Custom}","                 */","                publish(","                    EV_RATING_ITEM_OVER,","                    this._defRatingItemOverFn","                );","","                /**","                 * Handles the itemOut event.","                 *","                 * @event itemOut","                 * @preventable _defRatingItemOutFn","                 * @param {Event.Facade} event The itemOut event.","                 * @type {Event.Custom}","                 */","                publish(","                    EV_RATING_ITEM_OUT,","                    this._defRatingItemOutFn","                );","            },","","            /**","             * Fires the itemClick event.","             *","             * @method _defRatingItemClickFn","             * @param {EventFacade} event itemClick event facade","             * @protected","             */","            _defRatingItemClickFn: function(event) {","                var instance = this,","                    domEvent = event.domEvent;","","                instance.fire(EV_RATING_ITEM_SELECT, {","                    delegateEvent: event,","                    domEvent: domEvent,","                    ratingItem: domEvent.target","                });","            },","","            /**","             * Fires the itemSelect event.","             *","             * @method _defRatingItemSelectFn","             * @param {EventFacade} event itemSelect event facade","             * @protected","             */","            _defRatingItemSelectFn: function(event) {","                var instance = this,","                    domTarget = event.domEvent.target;","","                instance.select(","                    instance.indexOf(domTarget)","                );","            },","","            /**","             * Fires the itemOut event.","             *","             * @method _defRatingItemOutFn","             * @param {EventFacade} event itemOut event facade","             * @protected","             */","            _defRatingItemOutFn: function(event) {","                var instance = this;","","                instance.fillTo(instance.get(SELECTED_INDEX));","            },","","            /**","             * Fires the itemOver event.","             *","             * @method _defRatingItemOverFn","             * @param {EventFacade} event itemOver event facade","             * @protected","             */","            _defRatingItemOverFn: function(event) {","                var instance = this,","                    cssClasses = instance.get('cssClasses'),","                    index = instance.indexOf(event.domEvent.target);","","                instance.fillTo(index, cssClasses.hover);","            },","","            /**","             * Parse the HTML radio elements from the markup to be Rating elements.","             *","             * @method _parseInputElements","             * @protected","             */","            _parseInputElements: function() {","                var instance = this,","                    boundingBox = instance.get(BOUNDING_BOX),","                    inputs = boundingBox.all(INPUT),","                    size = inputs.size(),","                    inputName = instance.get(INPUT_NAME),","                    hiddenInput = A.Node.create('<input type=\"hidden\" />');","","                if (size > 0) {","                    inputName = inputName || inputs.item(0).getAttribute(NAME);","","                    instance.set(SIZE, size);","","                    var labels = boundingBox.getElementsByTagName('label');","","                    inputs.each(function(node, index) {","                        var id = node.get(ID);","                        var label = STR_EMPTY;","","                        if (id) {","                            // for a11y parse the <label> elments information","                            // checking if the node has a <label>","                            var labelEl = labels.filter('[for=\"' + id + '\"]');","","                            if (labelEl.size()) {","                                // if there is, extract the content of the label to use as content of the anchors...","                                label = labelEl.item(0).html();","                            }","                        }","","                        instance.inputElementsData[index] = {","                            content: label,","                            value: node.getAttribute(VALUE) || index,","                            title: node.getAttribute(TITLE)","                        };","                    });","","                    labels.remove(true);","                    inputs.remove(true);","                }","","                if (inputName) {","                    hiddenInput.setAttribute(NAME, inputName);","                    boundingBox.appendChild(hiddenInput);","                }","","                instance.set('hiddenInput', hiddenInput);","            },","","            /**","             * Render the Rating label.","             *","             * @method _renderLabel","             * @protected","             */","            _renderLabel: function() {","                var instance = this;","","                instance.get(CONTENT_BOX).setContent(","                    instance.get(LABEL_NODE)","                );","            },","","            /**","             * Render the Rating elements.","             *","             * @method _renderElements","             * @protected","             */","            _renderElements: function() {","                var instance = this,","                    contentBox = instance.get(CONTENT_BOX),","                    elements = instance.get(ELEMENTS);","","                // if there are no elements in the markup, create them based on the size attribute","                if (!elements || !elements.size()) {","                    elements = instance._createElements();","","                    instance.set(ELEMENTS, elements);","                }","","                elements.each(","                    function(element, i) {","                        var data = instance._getInputData(i),","                            content = data.content,","                            // try to use the pulled title data from the dom, otherwise use the TITLE attr, in the last case use the content","                            title = data.title || instance.get(TITLE) || content;","","                        // setting the content","                        if (content || title) {","                            // if there is no content use the title as content","                            element.html(content || title);","                        }","                        // setting the title","                        if (title && instance.get(SHOW_TITLE)) {","                            element.setAttribute(TITLE, title);","                        }","                        if (!element.attr(HREF) && (element.get(NODE_NAME).toLowerCase() == ANCHOR)) {","                            element.setAttribute('onclick', 'return false;');","                        }","                    }","                );","                contentBox.append(elements.getDOM());","            },","","            /**","             * Sync the Rating elements.","             *","             * @method _syncElements","             * @protected","             */","            _syncElements: function() {","                var instance = this,","                    selectedIndex = instance.get(DEFAULT_SELECTED) - 1;","","                instance.set(SELECTED_INDEX, selectedIndex);","                instance.select();","            },","","            /**","             * Sync the Rating label UI.","             *","             * @method _syncLabelUI","             * @protected","             */","            _syncLabelUI: function() {","                var instance = this,","                    labelText = instance.get(LABEL);","","                instance.get(LABEL_NODE).html(labelText);","            },","","            /**","             * Get the <code>index</code> element input data stored on <a","             * href=\"Rating.html#property_inputElementsData\">inputElementsData</a>.","             *","             * @method _getInputData","             * @protected","             */","            _getInputData: function(index) {","                var instance = this;","","                return instance.inputElementsData[index] || {};","            },","","            /**","             * Fires the click event.","             *","             * @method _handleClickEvent","             * @param {EventFacade} event click event facade","             * @protected","             */","            _handleClickEvent: function(event) {","                var instance = this,","                    domEvent = event.domEvent;","","                if (instance._canFireCustomEvent(event)) {","                    instance.fire(EV_RATING_ITEM_CLICK, {","                        delegateEvent: event,","                        domEvent: domEvent","                    });","                }","                else {","                    domEvent.preventDefault();","                }","            },","","            /**","             * Fires the mouseOut event.","             *","             * @method _handleMouseOutEvent","             * @param {EventFacade} event mouseOut event facade","             * @protected","             */","            _handleMouseOutEvent: function(event) {","                var instance = this;","","                if (instance._canFireCustomEvent(event)) {","                    instance.fire(EV_RATING_ITEM_OUT, {","                        delegateEvent: event,","                        domEvent: event.domEvent","                    });","                }","            },","","            /**","             * Fires the mouseOver event.","             *","             * @method _handleMouseOverEvent","             * @param {EventFacade} event mouseOver event facade","             * @protected","             */","            _handleMouseOverEvent: function(event) {","                var instance = this;","","                if (instance._canFireCustomEvent(event)) {","                    instance.fire(EV_RATING_ITEM_OVER, {","                        delegateEvent: event,","                        domEvent: event.domEvent","                    });","                }","            },","","            /**","             * Fires after the value of the","             * <a href=\"Rating.html#config_label\">label</a> attribute change.","             *","             * @method _afterSetLabel","             * @param {EventFacade} event","             * @protected","             */","            _afterSetLabel: function(event) {","                this._syncLabelUI();","            }","        }","    }",");","","A.Rating = Rating;","A.StarRating = Rating;","","}, '2.0.0pr1', {","    \"requires\": [","        \"widget-htmlparser\",","        \"widget-uievents\",","        \"aui-component\",","        \"aui-node-base\"","    ],","    \"skinnable\": true","});"];
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"].lines = {"1":0,"10":0,"16":0,"20":0,"96":0,"226":0,"267":0,"301":0,"305":0,"307":0,"308":0,"326":0,"328":0,"330":0,"332":0,"342":0,"345":0,"346":0,"347":0,"357":0,"359":0,"361":0,"375":0,"377":0,"378":0,"387":0,"390":0,"391":0,"392":0,"393":0,"404":0,"409":0,"410":0,"413":0,"415":0,"420":0,"422":0,"423":0,"425":0,"427":0,"428":0,"440":0,"443":0,"445":0,"446":0,"447":0,"448":0,"449":0,"462":0,"464":0,"477":0,"482":0,"495":0,"500":0,"501":0,"508":0,"518":0,"521":0,"522":0,"538":0,"551":0,"564":0,"577":0,"591":0,"594":0,"609":0,"612":0,"625":0,"627":0,"638":0,"642":0,"652":0,"659":0,"660":0,"662":0,"664":0,"666":0,"667":0,"668":0,"670":0,"673":0,"675":0,"677":0,"681":0,"688":0,"689":0,"692":0,"693":0,"694":0,"697":0,"707":0,"709":0,"721":0,"726":0,"727":0,"729":0,"732":0,"734":0,"740":0,"742":0,"745":0,"746":0,"748":0,"749":0,"753":0,"763":0,"766":0,"767":0,"777":0,"780":0,"791":0,"793":0,"804":0,"807":0,"808":0,"814":0,"826":0,"828":0,"829":0,"844":0,"846":0,"847":0,"863":0,"869":0,"870":0};
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"].functions = {"isNodeList:15":0,"isNode:19":0,"valueFn:225":0,"validator:266":0,"elements:300":0,"label:304":0,"initializer:325":0,"renderUI:341":0,"bindUI:356":0,"syncUI:374":0,"(anonymous 2):390":0,"clearSelection:386":0,"select:403":0,"(anonymous 3):446":0,"fillTo:439":0,"indexOf:461":0,"_canFireCustomEvent:476":0,"_createElements:494":0,"publish:521":0,"_createEvents:517":0,"_defRatingItemClickFn:590":0,"_defRatingItemSelectFn:608":0,"_defRatingItemOutFn:624":0,"_defRatingItemOverFn:637":0,"(anonymous 4):666":0,"_parseInputElements:651":0,"_renderLabel:706":0,"(anonymous 5):733":0,"_renderElements:720":0,"_syncElements:762":0,"_syncLabelUI:776":0,"_getInputData:790":0,"_handleClickEvent:803":0,"_handleMouseOutEvent:825":0,"_handleMouseOverEvent:843":0,"_afterSetLabel:862":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"].coveredLines = 125;
_yuitest_coverage["build/aui-rating-base/aui-rating-base.js"].coveredFunctions = 37;
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 1);
YUI.add('aui-rating-base', function (A, NAME) {

/**
 * The Rating Utility - The Star Rating creates a non-obstrusive star rating
 * control, could be based on a set of radio input boxes.
 *
 * @module aui-rating
 */

_yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 10);
var Lang = A.Lang,
    isBoolean = Lang.isBoolean,
    isNumber = Lang.isNumber,
    isString = Lang.isString,

    isNodeList = function(v) {
        _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "isNodeList", 15);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 16);
return (v instanceof A.NodeList);
    },

    isNode = function(v) {
        _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "isNode", 19);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 20);
return (v instanceof A.Node);
    },

    ANCHOR = 'a',
    BOUNDING_BOX = 'boundingBox',
    CAN_RESET = 'canReset',
    CLEARFIX = 'clearfix',
    CONTENT_BOX = 'contentBox',
    DEFAULT_SELECTED = 'defaultSelected',
    DISABLED = 'disabled',
    DOT = '.',
    ELEMENT = 'element',
    ELEMENTS = 'elements',
    HELPER = 'helper',
    HOVER = 'hover',
    HREF = 'href',
    ID = 'id',
    INPUT = 'input',
    INPUT_NAME = 'inputName',
    LABEL = 'label',
    LABEL_NODE = 'labelNode',
    NAME = 'name',
    NODE_NAME = 'nodeName',
    OFF = 'off',
    ON = 'on',
    RATING = 'rating',
    SELECTED_INDEX = 'selectedIndex',
    SHOW_TITLE = 'showTitle',
    SIZE = 'size',
    STR_EMPTY = '',
    TITLE = 'title',
    VALUE = 'value',

    EV_RATING_ITEM_CLICK = 'itemClick',
    EV_RATING_ITEM_OUT = 'itemOut',
    EV_RATING_ITEM_OVER = 'itemOver',
    EV_RATING_ITEM_SELECT = 'itemSelect',

    getCN = A.getClassName,

    CSS_STAR = getCN('icon', 'star'),
    CSS_HIDE_TEXT = getCN('hide', 'text'),
    CSS_STAR_EMPTY = getCN('icon', 'star', 'empty'),
    CSS_RATING_LABEL = getCN(RATING, LABEL),

    TPL_ELEMENT = '<a class="{cssClasses}"></a>',
    TPL_LABEL = '<span class="' + CSS_RATING_LABEL + '"></span>';

/**
 * <p><img src="assets/images/aui-rating/main.png"/></p>
 *
 * A base class for Rating, providing:
 * <ul>
 *    <li>A non-obstrusive star rating control</li>
 *    <li>Could be based on a set of radio input boxes</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var instance = new A.Rating({
 *   boundingBox: '#rating',
 *   defaultSelected: 3,
 *   disabled: false,
 *   label: 'Label'
 * }).render();
 * </code></pre>
 *
 * Check the list of <a href="Rating.html#configattributes">Configuration Attributes</a> available for
 * Rating.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class Rating
 * @constructor
 * @extends Component
 */
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 96);
var Rating = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property Rating.NAME
         * @type String
         * @static
         */
        NAME: 'rating',

        /**
         * Static property used to define the default attribute
         * configuration for the Rating.
         *
         * @property Rating.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            /**
             * Whether the Rating is disabled or not. Disabled Ratings don't allow
             * hover or click, just display selected stars.
             *
             * @attribute disabled
             * @default false
             * @type boolean
             */
            disabled: {
                value: false,
                validator: isBoolean
            },

            /**
             * If <code>true</code> could be reseted (i.e., have no values
             * selected).
             *
             * @attribute canReset
             * @default true
             * @type boolean
             */
            canReset: {
                value: true,
                validator: isBoolean
            },

            cssClasses: {
                value: {
                    element: CSS_STAR_EMPTY,
                    hover: CSS_STAR,
                    off: CSS_STAR_EMPTY,
                    on: CSS_STAR
                }
            },

            /**
             * The number of selected starts when the Rating render.
             *
             * @attribute defaultSelected
             * @default 0
             * @writeOnce
             * @type Number
             */
            defaultSelected: {
                value: 0,
                writeOnce: true,
                validator: isNumber
            },

            /**
             * <a href="NodeList.html">NodeList</a> of elements used on the
             * Rating. Each element is one Star.
             *
             * @attribute elements
             * @writeOnce
             * @readOnly
             * @type NodeList
             */
            elements: {
                validator: isNodeList
            },

            /**
             * Hidden input to handle the selected value. This hidden input
             * replace the radio elements and keep the same name.
             *
             * @attribute hiddenInput
             * @type Node
             */
            hiddenInput: {
                validator: isNode
            },

            /**
             * Name of the <a
             * href="Rating.html#config_hiddenInput">hiddenInput</a> element. If
             * not specified will use the name of the replaced radio.
             *
             * @attribute inputName
             * @default ''
             * @type String
             */
            inputName: {
                value: STR_EMPTY,
                validator: isString
            },

            /**
             * Label to be displayed with the Rating elements.
             *
             * @attribute label
             * @default ''
             * @type String
             */
            label: {
                value: STR_EMPTY,
                validator: isString
            },

            /**
             * DOM Node to display the text of the StarRating. If not
             * specified try to query using HTML_PARSER an element inside
             * boundingBox which matches <code>aui-rating-label-element</code>.
             *
             * @attribute labelNode
             * @default Generated div element.
             * @type String
             */
            labelNode: {
                valueFn: function() {
                    _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "valueFn", 225);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 226);
return A.Node.create(TPL_LABEL);
                },
                validator: isNode
            },

            /**
             * Stores the index of the selected element.
             *
             * @attribute selectedIndex
             * @default -1
             * @type Number
             */
            selectedIndex: {
                value: -1,
                validator: isNumber
            },

            /**
             * If <code>true</code> will extract the value of the
             * <code>title</code> attribute on the radio, and use it on the
             * generated Rating elements.
             *
             * @attribute showTitle
             * @default true
             * @type boolean
             */
            showTitle: {
                value: true,
                validator: isBoolean
            },

            /**
             * Number of Rating elements to be displayed.
             *
             * @attribute size
             * @default 5
             * @type Number
             */
            size: {
                value: 5,
                validator: function(v) {
                    _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "validator", 266);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 267);
return isNumber(v) && (v > 0);
                }
            },

            /**
             * If set, will be used when there is no DOM <code>title</code> on the
             * radio elements.
             *
             * @attribute title
             * @default null
             * @type String
             */
            title: null,

            /**
             * Stores the value of the current selected Rating element.
             *
             * @attribute value
             * @default null
             * @type String
             */
            value: null
        },

        /**
         * Object hash, defining how attribute values are to be parsed from
         * markup contained in the widget's content box.
         *
         * @property StarRating.HTML_PARSER
         * @type Object
         * @static
         */
        HTML_PARSER: {
            elements: function(srcNode) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "elements", 300);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 301);
return srcNode.all('a');
            },

            label: function(srcNode) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "label", 304);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 305);
var labelNode = srcNode.one(DOT + CSS_RATING_LABEL);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 307);
if (labelNode) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 308);
return labelNode.html();
                }
            },

            labelNode: DOT + CSS_RATING_LABEL
        },

        prototype: {
            BOUNDING_TEMPLATE: '<span></span>',
            CONTENT_TEMPLATE: '<span></span>',

            /**
             * Construction logic executed during Rating instantiation. Lifecycle.
             *
             * @method initializer
             * @protected
             */
            initializer: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "initializer", 325);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 326);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 328);
instance.inputElementsData = {};

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 330);
instance.get(BOUNDING_BOX).addClass(CSS_HIDE_TEXT);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 332);
instance.after('labelChange', this._afterSetLabel);
            },

            /**
             * Create the DOM structure for the Rating. Lifecycle.
             *
             * @method renderUI
             * @protected
             */
            renderUI: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "renderUI", 341);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 342);
var instance = this,
                    contentBox = instance.get(CONTENT_BOX);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 345);
instance._parseInputElements();
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 346);
instance._renderLabel();
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 347);
instance._renderElements();
            },

            /**
             * Bind the events on the Rating UI. Lifecycle.
             *
             * @method bindUI
             * @protected
             */
            bindUI: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "bindUI", 356);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 357);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 359);
instance._createEvents();

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 361);
instance.on({
                    click: instance._handleClickEvent,
                    mouseover: instance._handleMouseOverEvent,
                    mouseout: instance._handleMouseOutEvent
                });
            },

            /**
             * Sync the Rating UI. Lifecycle.
             *
             * @method syncUI
             * @protected
             */
            syncUI: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "syncUI", 374);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 375);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 377);
instance._syncElements();
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 378);
instance._syncLabelUI();
            },

            /**
             * Clear all selected starts to the default state.
             *
             * @method clearSelection
             */
            clearSelection: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "clearSelection", 386);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 387);
var instance = this,
                    cssClasses = instance.get('cssClasses');

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 390);
instance.get(ELEMENTS).each(function(node) {
                    _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "(anonymous 2)", 390);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 391);
node.removeClass(cssClasses.on);
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 392);
node.removeClass(cssClasses.hover);
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 393);
node.addClass(cssClasses.element);
                });
            },

            /**
             * Selects the <code>index</code> Rating element.
             *
             * @method select
             * @param {Number} index Index to be selected
             */
            select: function(index) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "select", 403);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 404);
var instance = this,
                    oldIndex = instance.get(SELECTED_INDEX),
                    canReset = instance.get(CAN_RESET);

                // clear selection when the selected element is clicked
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 409);
if (canReset && (oldIndex == index)) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 410);
index = -1;
                }

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 413);
instance.set(SELECTED_INDEX, index);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 415);
var selectedIndex = instance.get(SELECTED_INDEX),
                    data = instance._getInputData(selectedIndex),
                    title = (TITLE in data) ? data.title : STR_EMPTY,
                    value = (VALUE in data) ? data.value : selectedIndex;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 420);
instance.fillTo(selectedIndex);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 422);
instance.set(TITLE, title);
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 423);
instance.set(VALUE, value);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 425);
var hiddenInput = instance.get('hiddenInput');

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 427);
hiddenInput.setAttribute(TITLE, title);
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 428);
hiddenInput.setAttribute(VALUE, value);
            },

            /**
             * Add the <code>className</code> on the the <code>index</code> element
             * and all the previous Rating elements.
             *
             * @method fillTo
             * @param {Number} index Index to be selected
             * @param {String} className Class name to be applied when fill the Rating elements
             */
            fillTo: function(index, className) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "fillTo", 439);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 440);
var instance = this,
                    cssClasses = instance.get('cssClasses');

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 443);
instance.clearSelection();

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 445);
if (index >= 0) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 446);
instance.get(ELEMENTS).some(function(node, i) {
                        _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "(anonymous 3)", 446);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 447);
node.addClass(className || cssClasses.on);
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 448);
node.removeClass(cssClasses.element);
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 449);
return (i == Math.floor(index));
                    });
                }
            },

            /**
             * Finds the index of the <code>elem</code>.
             *
             * @method indexOf
             * @param {Node} elem Rating element
             * @return {Number}
             */
            indexOf: function(elem) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "indexOf", 461);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 462);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 464);
return instance.get(ELEMENTS).indexOf(elem);
            },

            /**
             * Check if the Rating element can fire the custom events. Disabled
             * elements won't fire nothing.
             *
             * @method _canFireCustomEvent
             * @param {EventFacade} event
             * @protected
             * @return {Boolean}
             */
            _canFireCustomEvent: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_canFireCustomEvent", 476);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 477);
var instance = this,
                    domTarget = event.domEvent.target;

                // checks if the widget is not disabled and if the dom event is firing with a item as target
                // do not fire custom events for other elements into the boundingBox
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 482);
return !instance.get(DISABLED) && domTarget.test('a');
            },

            /**
             * Create rating elements based on the <code>size</code>
             * attribute. It's only invoked when the HTML_PARSER does not find
             * nothing.
             *
             * @method _createElements
             * @protected
             * @return {NodeList}
             */
            _createElements: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_createElements", 494);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 495);
var instance = this,
                    cssClasses = instance.get('cssClasses'),
                    size = this.get(SIZE),
                    elements = [];

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 500);
for (var i = 0; i < size; i++) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 501);
elements.push(
                        Lang.sub(TPL_ELEMENT, {
                            cssClasses: cssClasses.element
                        })
                    );
                }

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 508);
return A.NodeList.create(elements.join(STR_EMPTY));
            },

            /**
             * Create the custom events.
             *
             * @method _createEvents
             * @protected
             */
            _createEvents: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_createEvents", 517);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 518);
var instance = this;

                // create publish function for kweight optimization
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 521);
var publish = function(name, fn) {
                    _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "publish", 521);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 522);
instance.publish(name, {
                        defaultFn: fn,
                        queuable: false,
                        emitFacade: true,
                        bubbles: true
                    });
                };

                /**
                 * Handles the itemClick event.
                 *
                 * @event itemClick
                 * @preventable _defRatingItemClickFn
                 * @param {Event.Facade} event The itemClick event.
                 * @type {Event.Custom}
                 */
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 538);
publish(
                    EV_RATING_ITEM_CLICK,
                    this._defRatingItemClickFn
                );

                /**
                 * Handles the itemSelect event.
                 *
                 * @event itemSelect
                 * @preventable _defRatingItemSelectFn
                 * @param {Event.Facade} event The itemSelect event.
                 * @type {Event.Custom}
                 */
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 551);
publish(
                    EV_RATING_ITEM_SELECT,
                    this._defRatingItemSelectFn
                );

                /**
                 * Handles the itemOver event.
                 *
                 * @event itemSelect
                 * @preventable _defRatingItemOverFn
                 * @param {Event.Facade} event The itemOver event.
                 * @type {Event.Custom}
                 */
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 564);
publish(
                    EV_RATING_ITEM_OVER,
                    this._defRatingItemOverFn
                );

                /**
                 * Handles the itemOut event.
                 *
                 * @event itemOut
                 * @preventable _defRatingItemOutFn
                 * @param {Event.Facade} event The itemOut event.
                 * @type {Event.Custom}
                 */
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 577);
publish(
                    EV_RATING_ITEM_OUT,
                    this._defRatingItemOutFn
                );
            },

            /**
             * Fires the itemClick event.
             *
             * @method _defRatingItemClickFn
             * @param {EventFacade} event itemClick event facade
             * @protected
             */
            _defRatingItemClickFn: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_defRatingItemClickFn", 590);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 591);
var instance = this,
                    domEvent = event.domEvent;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 594);
instance.fire(EV_RATING_ITEM_SELECT, {
                    delegateEvent: event,
                    domEvent: domEvent,
                    ratingItem: domEvent.target
                });
            },

            /**
             * Fires the itemSelect event.
             *
             * @method _defRatingItemSelectFn
             * @param {EventFacade} event itemSelect event facade
             * @protected
             */
            _defRatingItemSelectFn: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_defRatingItemSelectFn", 608);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 609);
var instance = this,
                    domTarget = event.domEvent.target;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 612);
instance.select(
                    instance.indexOf(domTarget)
                );
            },

            /**
             * Fires the itemOut event.
             *
             * @method _defRatingItemOutFn
             * @param {EventFacade} event itemOut event facade
             * @protected
             */
            _defRatingItemOutFn: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_defRatingItemOutFn", 624);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 625);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 627);
instance.fillTo(instance.get(SELECTED_INDEX));
            },

            /**
             * Fires the itemOver event.
             *
             * @method _defRatingItemOverFn
             * @param {EventFacade} event itemOver event facade
             * @protected
             */
            _defRatingItemOverFn: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_defRatingItemOverFn", 637);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 638);
var instance = this,
                    cssClasses = instance.get('cssClasses'),
                    index = instance.indexOf(event.domEvent.target);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 642);
instance.fillTo(index, cssClasses.hover);
            },

            /**
             * Parse the HTML radio elements from the markup to be Rating elements.
             *
             * @method _parseInputElements
             * @protected
             */
            _parseInputElements: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_parseInputElements", 651);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 652);
var instance = this,
                    boundingBox = instance.get(BOUNDING_BOX),
                    inputs = boundingBox.all(INPUT),
                    size = inputs.size(),
                    inputName = instance.get(INPUT_NAME),
                    hiddenInput = A.Node.create('<input type="hidden" />');

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 659);
if (size > 0) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 660);
inputName = inputName || inputs.item(0).getAttribute(NAME);

                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 662);
instance.set(SIZE, size);

                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 664);
var labels = boundingBox.getElementsByTagName('label');

                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 666);
inputs.each(function(node, index) {
                        _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "(anonymous 4)", 666);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 667);
var id = node.get(ID);
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 668);
var label = STR_EMPTY;

                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 670);
if (id) {
                            // for a11y parse the <label> elments information
                            // checking if the node has a <label>
                            _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 673);
var labelEl = labels.filter('[for="' + id + '"]');

                            _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 675);
if (labelEl.size()) {
                                // if there is, extract the content of the label to use as content of the anchors...
                                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 677);
label = labelEl.item(0).html();
                            }
                        }

                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 681);
instance.inputElementsData[index] = {
                            content: label,
                            value: node.getAttribute(VALUE) || index,
                            title: node.getAttribute(TITLE)
                        };
                    });

                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 688);
labels.remove(true);
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 689);
inputs.remove(true);
                }

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 692);
if (inputName) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 693);
hiddenInput.setAttribute(NAME, inputName);
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 694);
boundingBox.appendChild(hiddenInput);
                }

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 697);
instance.set('hiddenInput', hiddenInput);
            },

            /**
             * Render the Rating label.
             *
             * @method _renderLabel
             * @protected
             */
            _renderLabel: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_renderLabel", 706);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 707);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 709);
instance.get(CONTENT_BOX).setContent(
                    instance.get(LABEL_NODE)
                );
            },

            /**
             * Render the Rating elements.
             *
             * @method _renderElements
             * @protected
             */
            _renderElements: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_renderElements", 720);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 721);
var instance = this,
                    contentBox = instance.get(CONTENT_BOX),
                    elements = instance.get(ELEMENTS);

                // if there are no elements in the markup, create them based on the size attribute
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 726);
if (!elements || !elements.size()) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 727);
elements = instance._createElements();

                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 729);
instance.set(ELEMENTS, elements);
                }

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 732);
elements.each(
                    function(element, i) {
                        _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "(anonymous 5)", 733);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 734);
var data = instance._getInputData(i),
                            content = data.content,
                            // try to use the pulled title data from the dom, otherwise use the TITLE attr, in the last case use the content
                            title = data.title || instance.get(TITLE) || content;

                        // setting the content
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 740);
if (content || title) {
                            // if there is no content use the title as content
                            _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 742);
element.html(content || title);
                        }
                        // setting the title
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 745);
if (title && instance.get(SHOW_TITLE)) {
                            _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 746);
element.setAttribute(TITLE, title);
                        }
                        _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 748);
if (!element.attr(HREF) && (element.get(NODE_NAME).toLowerCase() == ANCHOR)) {
                            _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 749);
element.setAttribute('onclick', 'return false;');
                        }
                    }
                );
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 753);
contentBox.append(elements.getDOM());
            },

            /**
             * Sync the Rating elements.
             *
             * @method _syncElements
             * @protected
             */
            _syncElements: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_syncElements", 762);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 763);
var instance = this,
                    selectedIndex = instance.get(DEFAULT_SELECTED) - 1;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 766);
instance.set(SELECTED_INDEX, selectedIndex);
                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 767);
instance.select();
            },

            /**
             * Sync the Rating label UI.
             *
             * @method _syncLabelUI
             * @protected
             */
            _syncLabelUI: function() {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_syncLabelUI", 776);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 777);
var instance = this,
                    labelText = instance.get(LABEL);

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 780);
instance.get(LABEL_NODE).html(labelText);
            },

            /**
             * Get the <code>index</code> element input data stored on <a
             * href="Rating.html#property_inputElementsData">inputElementsData</a>.
             *
             * @method _getInputData
             * @protected
             */
            _getInputData: function(index) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_getInputData", 790);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 791);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 793);
return instance.inputElementsData[index] || {};
            },

            /**
             * Fires the click event.
             *
             * @method _handleClickEvent
             * @param {EventFacade} event click event facade
             * @protected
             */
            _handleClickEvent: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_handleClickEvent", 803);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 804);
var instance = this,
                    domEvent = event.domEvent;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 807);
if (instance._canFireCustomEvent(event)) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 808);
instance.fire(EV_RATING_ITEM_CLICK, {
                        delegateEvent: event,
                        domEvent: domEvent
                    });
                }
                else {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 814);
domEvent.preventDefault();
                }
            },

            /**
             * Fires the mouseOut event.
             *
             * @method _handleMouseOutEvent
             * @param {EventFacade} event mouseOut event facade
             * @protected
             */
            _handleMouseOutEvent: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_handleMouseOutEvent", 825);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 826);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 828);
if (instance._canFireCustomEvent(event)) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 829);
instance.fire(EV_RATING_ITEM_OUT, {
                        delegateEvent: event,
                        domEvent: event.domEvent
                    });
                }
            },

            /**
             * Fires the mouseOver event.
             *
             * @method _handleMouseOverEvent
             * @param {EventFacade} event mouseOver event facade
             * @protected
             */
            _handleMouseOverEvent: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_handleMouseOverEvent", 843);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 844);
var instance = this;

                _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 846);
if (instance._canFireCustomEvent(event)) {
                    _yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 847);
instance.fire(EV_RATING_ITEM_OVER, {
                        delegateEvent: event,
                        domEvent: event.domEvent
                    });
                }
            },

            /**
             * Fires after the value of the
             * <a href="Rating.html#config_label">label</a> attribute change.
             *
             * @method _afterSetLabel
             * @param {EventFacade} event
             * @protected
             */
            _afterSetLabel: function(event) {
                _yuitest_coverfunc("build/aui-rating-base/aui-rating-base.js", "_afterSetLabel", 862);
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 863);
this._syncLabelUI();
            }
        }
    }
);

_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 869);
A.Rating = Rating;
_yuitest_coverline("build/aui-rating-base/aui-rating-base.js", 870);
A.StarRating = Rating;

}, '2.0.0pr1', {
    "requires": [
        "widget-htmlparser",
        "widget-uievents",
        "aui-component",
        "aui-node-base"
    ],
    "skinnable": true
});
