if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-sortable-layout/aui-sortable-layout.js",
    code: []
};
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"].code=["YUI.add('aui-sortable-layout', function (A, NAME) {","","/**"," * The SortableLayout Utility - Full documentation coming soon."," *"," * @module aui-sortable-layout"," */","","var Lang = A.Lang,","    isBoolean = Lang.isBoolean,","    isFunction = Lang.isFunction,","    isObject = Lang.isObject,","    isString = Lang.isString,","    isValue = Lang.isValue,","","    toInt = Lang.toInt,","","    ceil = Math.ceil,","","    DDM = A.DD.DDM,","","    APPEND = 'append',","    CIRCLE = 'circle',","    DELEGATE_CONFIG = 'delegateConfig',","    DOWN = 'down',","    DRAG = 'drag',","    DRAG_NODE = 'dragNode',","    DRAG_NODES = 'dragNodes',","    DROP_CONTAINER = 'dropContainer',","    DROP_NODES = 'dropNodes',","    GROUPS = 'groups',","    ICON = 'icon',","    INDICATOR = 'indicator',","    L = 'l',","    LAZY_START = 'lazyStart',","    LEFT = 'left',","    MARGIN_BOTTOM = 'marginBottom',","    MARGIN_TOP = 'marginTop',","    NODE = 'node',","    OFFSET_HEIGHT = 'offsetHeight',","    OFFSET_WIDTH = 'offsetWidth',","    PLACE_AFTER = 'placeAfter',","    PLACE_BEFORE = 'placeBefore',","    PLACEHOLDER = 'placeholder',","    PREPEND = 'prepend',","    PROXY = 'proxy',","    PROXY_NODE = 'proxyNode',","    R = 'r',","    REGION = 'region',","    RIGHT = 'right',","    SORTABLE_LAYOUT = 'sortable-layout',","    SPACE = ' ',","    TARGET = 'target',","    TRIANGLE = 'triangle',","    UP = 'up',","","    EV_PLACEHOLDER_ALIGN = 'placeholderAlign',","    EV_QUADRANT_ENTER = 'quadrantEnter',","    EV_QUADRANT_EXIT = 'quadrantExit',","    EV_QUADRANT_OVER = 'quadrantOver',","","    // caching these values for performance","    PLACEHOLDER_MARGIN_BOTTOM = 0,","    PLACEHOLDER_MARGIN_TOP = 0,","    PLACEHOLDER_TARGET_MARGIN_BOTTOM = 0,","    PLACEHOLDER_TARGET_MARGIN_TOP = 0,","","    isNodeList = function(v) {","        return (v instanceof A.NodeList);","    },","","    concat = function() {","        return Array.prototype.slice.call(arguments).join(SPACE);","    },","","    nodeListSetter = function(val) {","        return isNodeList(val) ? val : A.all(val);","    },","","    getNumStyle = function(elem, styleName) {","        return toInt(elem.getStyle(styleName));","    },","","    getCN = A.getClassName,","","    CSS_DRAG_INDICATOR = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR),","    CSS_DRAG_INDICATOR_ICON = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON),","    CSS_DRAG_INDICATOR_ICON_LEFT = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON, LEFT),","    CSS_DRAG_INDICATOR_ICON_RIGHT = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON, RIGHT),","    CSS_DRAG_TARGET_INDICATOR = getCN(SORTABLE_LAYOUT, DRAG, TARGET, INDICATOR),","    CSS_ICON = getCN(ICON),","    CSS_ICON_CIRCLE_TRIANGLE_L = getCN(ICON, CIRCLE, TRIANGLE, L),","    CSS_ICON_CIRCLE_TRIANGLE_R = getCN(ICON, CIRCLE, TRIANGLE, R),","","    TPL_PLACEHOLDER = '<div class=\"'+CSS_DRAG_INDICATOR+'\">' +","                            '<div class=\"'+concat(CSS_DRAG_INDICATOR_ICON, CSS_DRAG_INDICATOR_ICON_LEFT, CSS_ICON, CSS_ICON_CIRCLE_TRIANGLE_R)+'\"></div>' +","                            '<div class=\"'+concat(CSS_DRAG_INDICATOR_ICON, CSS_DRAG_INDICATOR_ICON_RIGHT, CSS_ICON, CSS_ICON_CIRCLE_TRIANGLE_L)+'\"></div>' +","                        '<div>';","","/**"," * A base class for SortableLayout, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li>DragDrop utility for drag lists, portal layouts (portlets)</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var SortableLayout = new A.SortableLayout({"," *      dragNodes: '.portlet',"," *      dropNodes: '.column',"," *      proxyNode: A.Node.create('<div class=\"aui-sortable-layout-proxy\"></div>'),"," *      lazyStart: true"," * </code></pre>"," *"," * Check the list of <a href=\"SortableLayout.html#configattributes\">Configuration Attributes</a> available for"," * SortableLayout."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class SortableLayout"," * @constructor"," * @extends Base"," */","var SortableLayout = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property SortableLayout.NAME","         * @type String","         * @static","         */","        NAME: SORTABLE_LAYOUT,","","        /**","         * Static property used to define the default attribute","         * configuration for the SortableLayout.","         *","         * @property SortableLayout.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            delegateConfig: {","                value: null,","                setter: function(val) {","                    var instance = this;","","                    var config = A.merge(","                        {","                            bubbleTargets: instance,","                            dragConfig: {},","                            nodes: instance.get(DRAG_NODES),","                            target: true","                        },","                        val","                    );","","                    A.mix(config.dragConfig, {","                        groups: instance.get(GROUPS),","                        startCentered: true","                    });","","                    return config;","                },","                validator: isObject","            },","","            proxyNode: {","                setter: function(val) {","                    return isString(val) ? A.Node.create(val) : val;","                }","            },","","            dragNodes: {","                validator: isString","            },","","            dropContainer: {","                value: function(dropNode) {","                    return dropNode;","                },","                validator: isFunction","            },","","            dropNodes: {","                setter: '_setDropNodes'","            },","","            groups: {","                value: [SORTABLE_LAYOUT]","            },","","            lazyStart: {","                value: false,","                validator: isBoolean","            },","","            placeholder: {","                value: TPL_PLACEHOLDER,","                setter: function(val) {","                    var placeholder = isString(val) ? A.Node.create(val) : val;","","                    if (!placeholder.inDoc()) {","                        A.getBody().prepend(","                            placeholder.hide()","                        );","                    }","","                    PLACEHOLDER_MARGIN_BOTTOM = getNumStyle(placeholder, MARGIN_BOTTOM);","                    PLACEHOLDER_MARGIN_TOP = getNumStyle(placeholder, MARGIN_TOP);","","                    placeholder.addClass(CSS_DRAG_TARGET_INDICATOR);","","                    PLACEHOLDER_TARGET_MARGIN_BOTTOM = getNumStyle(placeholder, MARGIN_BOTTOM);","                    PLACEHOLDER_TARGET_MARGIN_TOP = getNumStyle(placeholder, MARGIN_TOP);","","                    return placeholder;","                }","            },","","            proxy: {","                value: null,","                setter: function(val) {","                    var instance = this;","","                    var defaults = {","                        moveOnEnd: false,","                        positionProxy: false","                    };","","                    // if proxyNode is set remove the border from the default proxy","                    if (instance.get(PROXY_NODE)) {","                        defaults.borderStyle = null;","                    }","","                    return A.merge(defaults, val || {});","                }","            }","        },","","        EXTENDS: A.Base,","","        prototype: {","            /**","             * Construction logic executed during SortableLayout instantiation. Lifecycle.","             *","             * @method initializer","             * @protected","             */","            initializer: function() {","                var instance = this;","","                instance.bindUI();","            },","","            bindUI: function() {","                var instance = this;","","                // publishing placeholderAlign event","                instance.publish(EV_PLACEHOLDER_ALIGN, {","                    defaultFn: instance._defPlaceholderAlign,","                    queuable: false,","                    emitFacade: true,","                    bubbles: true","                });","","                instance._bindDDEvents();","                instance._bindDropZones();","            },","","            /*","            * Methods","            */","            addDropNode: function(node, config) {","                var instance = this;","","                node = A.one(node);","","                if (!DDM.getDrop(node)) {","                    instance.addDropTarget(","                        // Do not use DropPlugin to create the DropZones on","                        // this component, the \".drop\" namespace is used to check","                        // for the DD.Delegate target nodes","                        new A.DD.Drop(","                            A.merge(","                                {","                                    bubbleTargets: instance,","                                    groups: instance.get(GROUPS),","                                    node: node","                                },","                                config","                            )","                        )","                    );","                }","            },","","            addDropTarget: function(drop) {","                var instance = this;","","                drop.addToGroup(","                    instance.get(GROUPS)","                );","            },","","            alignPlaceholder: function(region, isTarget) {","                var instance = this;","                var placeholder = instance.get(PLACEHOLDER);","","                if (!instance.lazyEvents) {","                    placeholder.show();","                }","","                // sync placeholder size","                instance._syncPlaceholderSize();","","                placeholder.setXY(","                    instance.getPlaceholderXY(region, isTarget)","                );","            },","","            calculateDirections: function(drag) {","                var instance = this;","                var lastY = instance.lastY;","                var lastX = instance.lastX;","","                var x = drag.lastXY[0];","                var y = drag.lastXY[1];","","                // if the x change","                if (x != lastX) {","                    // set the drag direction","                    instance.XDirection = (x < lastX) ? LEFT : RIGHT;","                }","","                // if the y change","                if (y != lastY) {","                    // set the drag direction","                    instance.YDirection = (y < lastY) ? UP : DOWN;","                }","","                instance.lastX = x;","                instance.lastY = y;","            },","","            calculateQuadrant: function(drag, drop) {","                var instance = this;","                var quadrant = 1;","                var region = drop.get(NODE).get(REGION);","                var mouseXY = drag.mouseXY;","                var mouseX = mouseXY[0];","                var mouseY = mouseXY[1];","","                var top = region.top;","                var left = region.left;","","                // (region.bottom - top) finds the height of the region","                var vCenter = top + (region.bottom - top)/2;","                // (region.right - left) finds the width of the region","                var hCenter = left + (region.right - left)/2;","","                if (mouseY < vCenter) {","                    quadrant = (mouseX > hCenter) ? 1 : 2;","                }","                else {","                    quadrant = (mouseX < hCenter) ? 3 : 4;","                }","","                instance.quadrant = quadrant;","","                return quadrant;","            },","","            getPlaceholderXY: function(region, isTarget) {","                var instance = this;","                var placeholder = instance.get(PLACEHOLDER);","                var marginBottom = PLACEHOLDER_MARGIN_BOTTOM;","                var marginTop = PLACEHOLDER_MARGIN_TOP;","","                if (isTarget) {","                    // update the margin values in case of the target placeholder has a different margin","                    marginBottom = PLACEHOLDER_TARGET_MARGIN_BOTTOM;","                    marginTop = PLACEHOLDER_TARGET_MARGIN_TOP;","                }","","                // update the className of the placeholder when interact with target (drag/drop) elements","                placeholder.toggleClass(CSS_DRAG_TARGET_INDICATOR, isTarget);","","                var regionBottom = ceil(region.bottom);","                var regionLeft = ceil(region.left);","                var regionTop = ceil(region.top);","","                var x = regionLeft;","","                // 1 and 2 quadrants are the top quadrants, so align to the region.top when quadrant < 3","                var y = (instance.quadrant < 3) ?","                            (regionTop - (placeholder.get(OFFSET_HEIGHT) + marginBottom)) : (regionBottom + marginTop);","","                return [ x, y ];","            },","","            removeDropTarget: function(drop) {","                var instance = this;","","                drop.removeFromGroup(","                    instance.get(GROUPS)","                );","            },","","            _alignCondition: function() {","                var instance = this;","                var activeDrag = DDM.activeDrag;","                var activeDrop = instance.activeDrop;","","                if (activeDrag && activeDrop) {","                    var dragNode = activeDrag.get(NODE);","                    var dropNode = activeDrop.get(NODE);","","                    return !dragNode.contains(dropNode);","                }","","                return true;","            },","","            _bindDDEvents: function() {","                var instance = this;","                var delegateConfig = instance.get(DELEGATE_CONFIG);","                var proxy = instance.get(PROXY);","","                // creating DD.Delegate instance","                instance.delegate = new A.DD.Delegate(delegateConfig);","","                // plugging the DDProxy","                instance.delegate.dd.plug(A.Plugin.DDProxy, proxy);","","                instance.on('drag:end', A.bind(instance._onDragEnd, instance));","                instance.on('drag:enter', A.bind(instance._onDragEnter, instance));","                instance.on('drag:exit', A.bind(instance._onDragExit, instance));","                instance.on('drag:over', A.bind(instance._onDragOver, instance));","                instance.on('drag:start', A.bind(instance._onDragStart, instance));","                instance.after('drag:start', A.bind(instance._afterDragStart, instance));","","                instance.on(EV_QUADRANT_ENTER, instance._syncPlaceholderUI);","                instance.on(EV_QUADRANT_EXIT, instance._syncPlaceholderUI);","            },","","            _bindDropZones: function() {","                var instance = this;","                var dropNodes = instance.get(DROP_NODES);","","                if (dropNodes) {","                    dropNodes.each(function(node, i) {","                        instance.addDropNode(node);","                    });","                }","            },","","            _defPlaceholderAlign: function(event) {","                var instance = this;","                var activeDrop = instance.activeDrop;","                var placeholder = instance.get(PLACEHOLDER);","","                if (activeDrop && placeholder) {","                    var node = activeDrop.get('node');","                    // DD.Delegate use the Drop Plugin on its \"target\" items. Using Drop Plugin a \"node.drop\" namespace is created.","                    // Using the .drop namespace to detect when the node is also a \"target\" DD.Delegate node","                    var isTarget = !!node.drop;","","                    instance.lastAlignDrop = activeDrop;","","                    instance.alignPlaceholder(","                        activeDrop.get(NODE).get(REGION),","                        isTarget","                    );","                }","            },","","            _evOutput: function() {","                var instance = this;","","                return {","                    drag: DDM.activeDrag,","                    drop: instance.activeDrop,","                    quadrant: instance.quadrant,","                    XDirection: instance.XDirection,","                    YDirection: instance.YDirection","                };","            },","","            _fireQuadrantEvents: function() {","                var instance = this;","                var evOutput = instance._evOutput();","                var lastQuadrant = instance.lastQuadrant;","                var quadrant = instance.quadrant;","","                if (quadrant != lastQuadrant) {","                    // only trigger exit if it has previously entered in any quadrant","                    if (lastQuadrant) {","                        // merging event with the \"last\" information","                        instance.fire(","                            EV_QUADRANT_EXIT,","                            A.merge(","                                {","                                    lastDrag: instance.lastDrag,","                                    lastDrop: instance.lastDrop,","                                    lastQuadrant: instance.lastQuadrant,","                                    lastXDirection: instance.lastXDirection,","                                    lastYDirection: instance.lastYDirection","                                },","                                evOutput","                            )","                        );","                    }","","                    // firing EV_QUADRANT_ENTER event","                    instance.fire(EV_QUADRANT_ENTER, evOutput);","                }","","                // firing EV_QUADRANT_OVER, align event fires like the drag over without bubbling for performance reasons","                instance.fire(EV_QUADRANT_OVER, evOutput);","","                // updating \"last\" information","                instance.lastDrag = DDM.activeDrag;","                instance.lastDrop = instance.activeDrop;","                instance.lastQuadrant = quadrant;","                instance.lastXDirection = instance.XDirection;","                instance.lastYDirection = instance.YDirection;","            },","","            _getAppendNode: function() {","                return DDM.activeDrag.get(NODE);","            },","","            _positionNode: function(event) {","                var instance = this;","                var activeDrop = instance.lastAlignDrop || instance.activeDrop;","","                if (activeDrop) {","                    var dragNode = instance._getAppendNode();","                    var dropNode = activeDrop.get(NODE);","","                    // detects if the activeDrop is a dd target (portlet) or a drop area only (column)","                    // DD.Delegate use the Drop Plugin on its \"target\" items. Using Drop Plugin a \"node.drop\" namespace is created.","                    // Using the .drop namespace to detect when the node is also a \"target\" DD.Delegate node","                    var isTarget = isValue(dropNode.drop);","                    var topQuadrants = (instance.quadrant < 3);","","                    if (instance._alignCondition()) {","                        if (isTarget) {","                            dropNode[ topQuadrants ? PLACE_BEFORE : PLACE_AFTER ](dragNode);","                        }","                        // interacting with the columns (drop areas only)","                        else {","                            // find the dropContainer of the dropNode, the default DROP_CONTAINER function returns the dropNode","                            var dropContainer = instance.get(DROP_CONTAINER).apply(instance, [dropNode]);","","                            dropContainer[ topQuadrants ? PREPEND : APPEND ](dragNode);","                        }","                    }","                }","            },","","            _syncPlaceholderUI: function(event) {","                var instance = this;","","                if (instance._alignCondition()) {","                    // firing placeholderAlign event","                    instance.fire(EV_PLACEHOLDER_ALIGN, {","                        drop: instance.activeDrop,","                        originalEvent: event","                    });","                }","            },","","            _syncPlaceholderSize: function() {","                var instance = this;","                var node = instance.activeDrop.get(NODE);","","                var placeholder = instance.get(PLACEHOLDER);","","                if (placeholder) {","                    placeholder.set(","                        OFFSET_WIDTH,","                        node.get(OFFSET_WIDTH)","                    );","                }","            },","","            _syncProxyNodeUI: function(event) {","                var instance = this;","                var dragNode = DDM.activeDrag.get(DRAG_NODE);","                var proxyNode = instance.get(PROXY_NODE);","","                if (proxyNode && !proxyNode.compareTo(dragNode)) {","                    dragNode.append(proxyNode);","","                    instance._syncProxyNodeSize();","                }","            },","","            _syncProxyNodeSize: function() {","                var instance = this;","                var node = DDM.activeDrag.get(NODE);","                var proxyNode = instance.get(PROXY_NODE);","","                if (node && proxyNode) {","                    proxyNode.set(","                        OFFSET_HEIGHT,","                        node.get(OFFSET_HEIGHT)","                    );","","                    proxyNode.set(","                        OFFSET_WIDTH,","                        node.get(OFFSET_WIDTH)","                    );","                }","            },","","            /*","            * Listeners","            */","            _afterDragStart: function(event) {","                var instance = this;","","                if (instance.get(PROXY)) {","                    instance._syncProxyNodeUI(event);","                }","            },","","            _onDragEnd: function(event) {","                var instance = this;","                var placeholder = instance.get(PLACEHOLDER);","                var proxyNode = instance.get(PROXY_NODE);","","                if (!instance.lazyEvents) {","                    instance._positionNode(event);","                }","","                if (proxyNode) {","                    proxyNode.remove();","                }","","                if (placeholder) {","                    placeholder.hide();","                }","","                // reset the last information","                instance.lastQuadrant = null;","                instance.lastXDirection = null;","                instance.lastYDirection = null;","            },","","            // fires after drag:start","            _onDragEnter: function(event) {","                var instance = this;","","                instance.activeDrop = DDM.activeDrop;","","                // check if lazyEvents is true and if there is a lastActiveDrop","                // the checking for lastActiveDrop prevents fire the _syncPlaceholderUI when quadrant* events fires","                if (instance.lazyEvents && instance.lastActiveDrop) {","                    instance.lazyEvents = false;","","                    instance._syncPlaceholderUI(event);","                }","","                // lastActiveDrop is always updated by the drag exit,","                // but if there is no lastActiveDrop update it on drag enter update it","                if (!instance.lastActiveDrop) {","                    instance.lastActiveDrop = DDM.activeDrop;","                }","            },","","            _onDragExit: function(event) {","                var instance = this;","","                instance._syncPlaceholderUI(event);","","                instance.activeDrop = DDM.activeDrop;","","                instance.lastActiveDrop = DDM.activeDrop;","            },","","            _onDragOver: function(event) {","                var instance = this;","                var drag = event.drag;","","                // prevent drag over bubbling, filtering the top most element","                if (instance.activeDrop == DDM.activeDrop) {","                    instance.calculateDirections(drag);","","                    instance.calculateQuadrant(drag, instance.activeDrop);","","                    instance._fireQuadrantEvents();","                }","            },","","            // fires before drag:enter","            _onDragStart: function(event) {","                var instance = this;","","                if (instance.get(LAZY_START)) {","                    instance.lazyEvents = true;","                }","","                instance.lastActiveDrop = null;","","                instance.activeDrop = DDM.activeDrop;","            },","","            _setDropNodes: function(val) {","                var instance = this;","","                if (isFunction(val)) {","                    val = val.call(instance);","                }","","                return nodeListSetter(val);","            }","        }","    }",");","","A.SortableLayout = SortableLayout;","","}, '2.0.0pr1', {","    \"requires\": [","        \"dd-delegate\",","        \"dd-drag\",","        \"dd-drop\",","        \"dd-proxy\",","        \"aui-node\",","        \"aui-component\"","    ],","    \"skinnable\": true","});"];
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"].lines = {"1":0,"9":0,"69":0,"73":0,"77":0,"81":0,"125":0,"148":0,"150":0,"160":0,"165":0,"172":0,"182":0,"203":0,"205":0,"206":0,"211":0,"212":0,"214":0,"216":0,"217":0,"219":0,"226":0,"228":0,"234":0,"235":0,"238":0,"253":0,"255":0,"259":0,"262":0,"269":0,"270":0,"277":0,"279":0,"281":0,"282":0,"301":0,"303":0,"309":0,"310":0,"312":0,"313":0,"317":0,"319":0,"325":0,"326":0,"327":0,"329":0,"330":0,"333":0,"335":0,"339":0,"341":0,"344":0,"345":0,"349":0,"350":0,"351":0,"352":0,"353":0,"354":0,"356":0,"357":0,"360":0,"362":0,"364":0,"365":0,"368":0,"371":0,"373":0,"377":0,"378":0,"379":0,"380":0,"382":0,"384":0,"385":0,"389":0,"391":0,"392":0,"393":0,"395":0,"398":0,"401":0,"405":0,"407":0,"413":0,"414":0,"415":0,"417":0,"418":0,"419":0,"421":0,"424":0,"428":0,"429":0,"430":0,"433":0,"436":0,"438":0,"439":0,"440":0,"441":0,"442":0,"443":0,"445":0,"446":0,"450":0,"451":0,"453":0,"454":0,"455":0,"461":0,"462":0,"463":0,"465":0,"466":0,"469":0,"471":0,"473":0,"481":0,"483":0,"493":0,"494":0,"495":0,"496":0,"498":0,"500":0,"502":0,"518":0,"522":0,"525":0,"526":0,"527":0,"528":0,"529":0,"533":0,"537":0,"538":0,"540":0,"541":0,"542":0,"547":0,"548":0,"550":0,"551":0,"552":0,"557":0,"559":0,"566":0,"568":0,"570":0,"578":0,"579":0,"581":0,"583":0,"584":0,"592":0,"593":0,"594":0,"596":0,"597":0,"599":0,"604":0,"605":0,"606":0,"608":0,"609":0,"614":0,"625":0,"627":0,"628":0,"633":0,"634":0,"635":0,"637":0,"638":0,"641":0,"642":0,"645":0,"646":0,"650":0,"651":0,"652":0,"657":0,"659":0,"663":0,"664":0,"666":0,"671":0,"672":0,"677":0,"679":0,"681":0,"683":0,"687":0,"688":0,"691":0,"692":0,"694":0,"696":0,"702":0,"704":0,"705":0,"708":0,"710":0,"714":0,"716":0,"717":0,"720":0,"726":0};
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"].functions = {"isNodeList:68":0,"concat:72":0,"nodeListSetter:76":0,"getNumStyle:80":0,"setter:147":0,"setter:171":0,"value:181":0,"setter:202":0,"setter:225":0,"initializer:252":0,"bindUI:258":0,"addDropNode:276":0,"addDropTarget:300":0,"alignPlaceholder:308":0,"calculateDirections:324":0,"calculateQuadrant:348":0,"getPlaceholderXY:376":0,"removeDropTarget:404":0,"_alignCondition:412":0,"_bindDDEvents:427":0,"(anonymous 2):454":0,"_bindDropZones:449":0,"_defPlaceholderAlign:460":0,"_evOutput:480":0,"_fireQuadrantEvents:492":0,"_getAppendNode:532":0,"_positionNode:536":0,"_syncPlaceholderUI:565":0,"_syncPlaceholderSize:577":0,"_syncProxyNodeUI:591":0,"_syncProxyNodeSize:603":0,"_afterDragStart:624":0,"_onDragEnd:632":0,"_onDragEnter:656":0,"_onDragExit:676":0,"_onDragOver:686":0,"_onDragStart:701":0,"_setDropNodes:713":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"].coveredLines = 212;
_yuitest_coverage["build/aui-sortable-layout/aui-sortable-layout.js"].coveredFunctions = 39;
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 1);
YUI.add('aui-sortable-layout', function (A, NAME) {

/**
 * The SortableLayout Utility - Full documentation coming soon.
 *
 * @module aui-sortable-layout
 */

_yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 9);
var Lang = A.Lang,
    isBoolean = Lang.isBoolean,
    isFunction = Lang.isFunction,
    isObject = Lang.isObject,
    isString = Lang.isString,
    isValue = Lang.isValue,

    toInt = Lang.toInt,

    ceil = Math.ceil,

    DDM = A.DD.DDM,

    APPEND = 'append',
    CIRCLE = 'circle',
    DELEGATE_CONFIG = 'delegateConfig',
    DOWN = 'down',
    DRAG = 'drag',
    DRAG_NODE = 'dragNode',
    DRAG_NODES = 'dragNodes',
    DROP_CONTAINER = 'dropContainer',
    DROP_NODES = 'dropNodes',
    GROUPS = 'groups',
    ICON = 'icon',
    INDICATOR = 'indicator',
    L = 'l',
    LAZY_START = 'lazyStart',
    LEFT = 'left',
    MARGIN_BOTTOM = 'marginBottom',
    MARGIN_TOP = 'marginTop',
    NODE = 'node',
    OFFSET_HEIGHT = 'offsetHeight',
    OFFSET_WIDTH = 'offsetWidth',
    PLACE_AFTER = 'placeAfter',
    PLACE_BEFORE = 'placeBefore',
    PLACEHOLDER = 'placeholder',
    PREPEND = 'prepend',
    PROXY = 'proxy',
    PROXY_NODE = 'proxyNode',
    R = 'r',
    REGION = 'region',
    RIGHT = 'right',
    SORTABLE_LAYOUT = 'sortable-layout',
    SPACE = ' ',
    TARGET = 'target',
    TRIANGLE = 'triangle',
    UP = 'up',

    EV_PLACEHOLDER_ALIGN = 'placeholderAlign',
    EV_QUADRANT_ENTER = 'quadrantEnter',
    EV_QUADRANT_EXIT = 'quadrantExit',
    EV_QUADRANT_OVER = 'quadrantOver',

    // caching these values for performance
    PLACEHOLDER_MARGIN_BOTTOM = 0,
    PLACEHOLDER_MARGIN_TOP = 0,
    PLACEHOLDER_TARGET_MARGIN_BOTTOM = 0,
    PLACEHOLDER_TARGET_MARGIN_TOP = 0,

    isNodeList = function(v) {
        _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "isNodeList", 68);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 69);
return (v instanceof A.NodeList);
    },

    concat = function() {
        _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "concat", 72);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 73);
return Array.prototype.slice.call(arguments).join(SPACE);
    },

    nodeListSetter = function(val) {
        _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "nodeListSetter", 76);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 77);
return isNodeList(val) ? val : A.all(val);
    },

    getNumStyle = function(elem, styleName) {
        _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "getNumStyle", 80);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 81);
return toInt(elem.getStyle(styleName));
    },

    getCN = A.getClassName,

    CSS_DRAG_INDICATOR = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR),
    CSS_DRAG_INDICATOR_ICON = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON),
    CSS_DRAG_INDICATOR_ICON_LEFT = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON, LEFT),
    CSS_DRAG_INDICATOR_ICON_RIGHT = getCN(SORTABLE_LAYOUT, DRAG, INDICATOR, ICON, RIGHT),
    CSS_DRAG_TARGET_INDICATOR = getCN(SORTABLE_LAYOUT, DRAG, TARGET, INDICATOR),
    CSS_ICON = getCN(ICON),
    CSS_ICON_CIRCLE_TRIANGLE_L = getCN(ICON, CIRCLE, TRIANGLE, L),
    CSS_ICON_CIRCLE_TRIANGLE_R = getCN(ICON, CIRCLE, TRIANGLE, R),

    TPL_PLACEHOLDER = '<div class="'+CSS_DRAG_INDICATOR+'">' +
                            '<div class="'+concat(CSS_DRAG_INDICATOR_ICON, CSS_DRAG_INDICATOR_ICON_LEFT, CSS_ICON, CSS_ICON_CIRCLE_TRIANGLE_R)+'"></div>' +
                            '<div class="'+concat(CSS_DRAG_INDICATOR_ICON, CSS_DRAG_INDICATOR_ICON_RIGHT, CSS_ICON, CSS_ICON_CIRCLE_TRIANGLE_L)+'"></div>' +
                        '<div>';

/**
 * A base class for SortableLayout, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li>DragDrop utility for drag lists, portal layouts (portlets)</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var SortableLayout = new A.SortableLayout({
 *      dragNodes: '.portlet',
 *      dropNodes: '.column',
 *      proxyNode: A.Node.create('<div class="aui-sortable-layout-proxy"></div>'),
 *      lazyStart: true
 * </code></pre>
 *
 * Check the list of <a href="SortableLayout.html#configattributes">Configuration Attributes</a> available for
 * SortableLayout.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class SortableLayout
 * @constructor
 * @extends Base
 */
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 125);
var SortableLayout = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property SortableLayout.NAME
         * @type String
         * @static
         */
        NAME: SORTABLE_LAYOUT,

        /**
         * Static property used to define the default attribute
         * configuration for the SortableLayout.
         *
         * @property SortableLayout.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            delegateConfig: {
                value: null,
                setter: function(val) {
                    _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "setter", 147);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 148);
var instance = this;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 150);
var config = A.merge(
                        {
                            bubbleTargets: instance,
                            dragConfig: {},
                            nodes: instance.get(DRAG_NODES),
                            target: true
                        },
                        val
                    );

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 160);
A.mix(config.dragConfig, {
                        groups: instance.get(GROUPS),
                        startCentered: true
                    });

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 165);
return config;
                },
                validator: isObject
            },

            proxyNode: {
                setter: function(val) {
                    _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "setter", 171);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 172);
return isString(val) ? A.Node.create(val) : val;
                }
            },

            dragNodes: {
                validator: isString
            },

            dropContainer: {
                value: function(dropNode) {
                    _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "value", 181);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 182);
return dropNode;
                },
                validator: isFunction
            },

            dropNodes: {
                setter: '_setDropNodes'
            },

            groups: {
                value: [SORTABLE_LAYOUT]
            },

            lazyStart: {
                value: false,
                validator: isBoolean
            },

            placeholder: {
                value: TPL_PLACEHOLDER,
                setter: function(val) {
                    _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "setter", 202);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 203);
var placeholder = isString(val) ? A.Node.create(val) : val;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 205);
if (!placeholder.inDoc()) {
                        _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 206);
A.getBody().prepend(
                            placeholder.hide()
                        );
                    }

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 211);
PLACEHOLDER_MARGIN_BOTTOM = getNumStyle(placeholder, MARGIN_BOTTOM);
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 212);
PLACEHOLDER_MARGIN_TOP = getNumStyle(placeholder, MARGIN_TOP);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 214);
placeholder.addClass(CSS_DRAG_TARGET_INDICATOR);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 216);
PLACEHOLDER_TARGET_MARGIN_BOTTOM = getNumStyle(placeholder, MARGIN_BOTTOM);
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 217);
PLACEHOLDER_TARGET_MARGIN_TOP = getNumStyle(placeholder, MARGIN_TOP);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 219);
return placeholder;
                }
            },

            proxy: {
                value: null,
                setter: function(val) {
                    _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "setter", 225);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 226);
var instance = this;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 228);
var defaults = {
                        moveOnEnd: false,
                        positionProxy: false
                    };

                    // if proxyNode is set remove the border from the default proxy
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 234);
if (instance.get(PROXY_NODE)) {
                        _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 235);
defaults.borderStyle = null;
                    }

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 238);
return A.merge(defaults, val || {});
                }
            }
        },

        EXTENDS: A.Base,

        prototype: {
            /**
             * Construction logic executed during SortableLayout instantiation. Lifecycle.
             *
             * @method initializer
             * @protected
             */
            initializer: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "initializer", 252);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 253);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 255);
instance.bindUI();
            },

            bindUI: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "bindUI", 258);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 259);
var instance = this;

                // publishing placeholderAlign event
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 262);
instance.publish(EV_PLACEHOLDER_ALIGN, {
                    defaultFn: instance._defPlaceholderAlign,
                    queuable: false,
                    emitFacade: true,
                    bubbles: true
                });

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 269);
instance._bindDDEvents();
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 270);
instance._bindDropZones();
            },

            /*
            * Methods
            */
            addDropNode: function(node, config) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "addDropNode", 276);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 277);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 279);
node = A.one(node);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 281);
if (!DDM.getDrop(node)) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 282);
instance.addDropTarget(
                        // Do not use DropPlugin to create the DropZones on
                        // this component, the ".drop" namespace is used to check
                        // for the DD.Delegate target nodes
                        new A.DD.Drop(
                            A.merge(
                                {
                                    bubbleTargets: instance,
                                    groups: instance.get(GROUPS),
                                    node: node
                                },
                                config
                            )
                        )
                    );
                }
            },

            addDropTarget: function(drop) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "addDropTarget", 300);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 301);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 303);
drop.addToGroup(
                    instance.get(GROUPS)
                );
            },

            alignPlaceholder: function(region, isTarget) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "alignPlaceholder", 308);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 309);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 310);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 312);
if (!instance.lazyEvents) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 313);
placeholder.show();
                }

                // sync placeholder size
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 317);
instance._syncPlaceholderSize();

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 319);
placeholder.setXY(
                    instance.getPlaceholderXY(region, isTarget)
                );
            },

            calculateDirections: function(drag) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "calculateDirections", 324);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 325);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 326);
var lastY = instance.lastY;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 327);
var lastX = instance.lastX;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 329);
var x = drag.lastXY[0];
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 330);
var y = drag.lastXY[1];

                // if the x change
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 333);
if (x != lastX) {
                    // set the drag direction
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 335);
instance.XDirection = (x < lastX) ? LEFT : RIGHT;
                }

                // if the y change
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 339);
if (y != lastY) {
                    // set the drag direction
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 341);
instance.YDirection = (y < lastY) ? UP : DOWN;
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 344);
instance.lastX = x;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 345);
instance.lastY = y;
            },

            calculateQuadrant: function(drag, drop) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "calculateQuadrant", 348);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 349);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 350);
var quadrant = 1;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 351);
var region = drop.get(NODE).get(REGION);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 352);
var mouseXY = drag.mouseXY;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 353);
var mouseX = mouseXY[0];
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 354);
var mouseY = mouseXY[1];

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 356);
var top = region.top;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 357);
var left = region.left;

                // (region.bottom - top) finds the height of the region
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 360);
var vCenter = top + (region.bottom - top)/2;
                // (region.right - left) finds the width of the region
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 362);
var hCenter = left + (region.right - left)/2;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 364);
if (mouseY < vCenter) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 365);
quadrant = (mouseX > hCenter) ? 1 : 2;
                }
                else {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 368);
quadrant = (mouseX < hCenter) ? 3 : 4;
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 371);
instance.quadrant = quadrant;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 373);
return quadrant;
            },

            getPlaceholderXY: function(region, isTarget) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "getPlaceholderXY", 376);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 377);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 378);
var placeholder = instance.get(PLACEHOLDER);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 379);
var marginBottom = PLACEHOLDER_MARGIN_BOTTOM;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 380);
var marginTop = PLACEHOLDER_MARGIN_TOP;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 382);
if (isTarget) {
                    // update the margin values in case of the target placeholder has a different margin
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 384);
marginBottom = PLACEHOLDER_TARGET_MARGIN_BOTTOM;
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 385);
marginTop = PLACEHOLDER_TARGET_MARGIN_TOP;
                }

                // update the className of the placeholder when interact with target (drag/drop) elements
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 389);
placeholder.toggleClass(CSS_DRAG_TARGET_INDICATOR, isTarget);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 391);
var regionBottom = ceil(region.bottom);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 392);
var regionLeft = ceil(region.left);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 393);
var regionTop = ceil(region.top);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 395);
var x = regionLeft;

                // 1 and 2 quadrants are the top quadrants, so align to the region.top when quadrant < 3
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 398);
var y = (instance.quadrant < 3) ?
                            (regionTop - (placeholder.get(OFFSET_HEIGHT) + marginBottom)) : (regionBottom + marginTop);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 401);
return [ x, y ];
            },

            removeDropTarget: function(drop) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "removeDropTarget", 404);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 405);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 407);
drop.removeFromGroup(
                    instance.get(GROUPS)
                );
            },

            _alignCondition: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_alignCondition", 412);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 413);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 414);
var activeDrag = DDM.activeDrag;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 415);
var activeDrop = instance.activeDrop;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 417);
if (activeDrag && activeDrop) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 418);
var dragNode = activeDrag.get(NODE);
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 419);
var dropNode = activeDrop.get(NODE);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 421);
return !dragNode.contains(dropNode);
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 424);
return true;
            },

            _bindDDEvents: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_bindDDEvents", 427);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 428);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 429);
var delegateConfig = instance.get(DELEGATE_CONFIG);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 430);
var proxy = instance.get(PROXY);

                // creating DD.Delegate instance
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 433);
instance.delegate = new A.DD.Delegate(delegateConfig);

                // plugging the DDProxy
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 436);
instance.delegate.dd.plug(A.Plugin.DDProxy, proxy);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 438);
instance.on('drag:end', A.bind(instance._onDragEnd, instance));
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 439);
instance.on('drag:enter', A.bind(instance._onDragEnter, instance));
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 440);
instance.on('drag:exit', A.bind(instance._onDragExit, instance));
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 441);
instance.on('drag:over', A.bind(instance._onDragOver, instance));
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 442);
instance.on('drag:start', A.bind(instance._onDragStart, instance));
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 443);
instance.after('drag:start', A.bind(instance._afterDragStart, instance));

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 445);
instance.on(EV_QUADRANT_ENTER, instance._syncPlaceholderUI);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 446);
instance.on(EV_QUADRANT_EXIT, instance._syncPlaceholderUI);
            },

            _bindDropZones: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_bindDropZones", 449);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 450);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 451);
var dropNodes = instance.get(DROP_NODES);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 453);
if (dropNodes) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 454);
dropNodes.each(function(node, i) {
                        _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "(anonymous 2)", 454);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 455);
instance.addDropNode(node);
                    });
                }
            },

            _defPlaceholderAlign: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_defPlaceholderAlign", 460);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 461);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 462);
var activeDrop = instance.activeDrop;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 463);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 465);
if (activeDrop && placeholder) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 466);
var node = activeDrop.get('node');
                    // DD.Delegate use the Drop Plugin on its "target" items. Using Drop Plugin a "node.drop" namespace is created.
                    // Using the .drop namespace to detect when the node is also a "target" DD.Delegate node
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 469);
var isTarget = !!node.drop;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 471);
instance.lastAlignDrop = activeDrop;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 473);
instance.alignPlaceholder(
                        activeDrop.get(NODE).get(REGION),
                        isTarget
                    );
                }
            },

            _evOutput: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_evOutput", 480);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 481);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 483);
return {
                    drag: DDM.activeDrag,
                    drop: instance.activeDrop,
                    quadrant: instance.quadrant,
                    XDirection: instance.XDirection,
                    YDirection: instance.YDirection
                };
            },

            _fireQuadrantEvents: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_fireQuadrantEvents", 492);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 493);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 494);
var evOutput = instance._evOutput();
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 495);
var lastQuadrant = instance.lastQuadrant;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 496);
var quadrant = instance.quadrant;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 498);
if (quadrant != lastQuadrant) {
                    // only trigger exit if it has previously entered in any quadrant
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 500);
if (lastQuadrant) {
                        // merging event with the "last" information
                        _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 502);
instance.fire(
                            EV_QUADRANT_EXIT,
                            A.merge(
                                {
                                    lastDrag: instance.lastDrag,
                                    lastDrop: instance.lastDrop,
                                    lastQuadrant: instance.lastQuadrant,
                                    lastXDirection: instance.lastXDirection,
                                    lastYDirection: instance.lastYDirection
                                },
                                evOutput
                            )
                        );
                    }

                    // firing EV_QUADRANT_ENTER event
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 518);
instance.fire(EV_QUADRANT_ENTER, evOutput);
                }

                // firing EV_QUADRANT_OVER, align event fires like the drag over without bubbling for performance reasons
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 522);
instance.fire(EV_QUADRANT_OVER, evOutput);

                // updating "last" information
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 525);
instance.lastDrag = DDM.activeDrag;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 526);
instance.lastDrop = instance.activeDrop;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 527);
instance.lastQuadrant = quadrant;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 528);
instance.lastXDirection = instance.XDirection;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 529);
instance.lastYDirection = instance.YDirection;
            },

            _getAppendNode: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_getAppendNode", 532);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 533);
return DDM.activeDrag.get(NODE);
            },

            _positionNode: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_positionNode", 536);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 537);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 538);
var activeDrop = instance.lastAlignDrop || instance.activeDrop;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 540);
if (activeDrop) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 541);
var dragNode = instance._getAppendNode();
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 542);
var dropNode = activeDrop.get(NODE);

                    // detects if the activeDrop is a dd target (portlet) or a drop area only (column)
                    // DD.Delegate use the Drop Plugin on its "target" items. Using Drop Plugin a "node.drop" namespace is created.
                    // Using the .drop namespace to detect when the node is also a "target" DD.Delegate node
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 547);
var isTarget = isValue(dropNode.drop);
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 548);
var topQuadrants = (instance.quadrant < 3);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 550);
if (instance._alignCondition()) {
                        _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 551);
if (isTarget) {
                            _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 552);
dropNode[ topQuadrants ? PLACE_BEFORE : PLACE_AFTER ](dragNode);
                        }
                        // interacting with the columns (drop areas only)
                        else {
                            // find the dropContainer of the dropNode, the default DROP_CONTAINER function returns the dropNode
                            _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 557);
var dropContainer = instance.get(DROP_CONTAINER).apply(instance, [dropNode]);

                            _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 559);
dropContainer[ topQuadrants ? PREPEND : APPEND ](dragNode);
                        }
                    }
                }
            },

            _syncPlaceholderUI: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_syncPlaceholderUI", 565);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 566);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 568);
if (instance._alignCondition()) {
                    // firing placeholderAlign event
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 570);
instance.fire(EV_PLACEHOLDER_ALIGN, {
                        drop: instance.activeDrop,
                        originalEvent: event
                    });
                }
            },

            _syncPlaceholderSize: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_syncPlaceholderSize", 577);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 578);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 579);
var node = instance.activeDrop.get(NODE);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 581);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 583);
if (placeholder) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 584);
placeholder.set(
                        OFFSET_WIDTH,
                        node.get(OFFSET_WIDTH)
                    );
                }
            },

            _syncProxyNodeUI: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_syncProxyNodeUI", 591);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 592);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 593);
var dragNode = DDM.activeDrag.get(DRAG_NODE);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 594);
var proxyNode = instance.get(PROXY_NODE);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 596);
if (proxyNode && !proxyNode.compareTo(dragNode)) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 597);
dragNode.append(proxyNode);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 599);
instance._syncProxyNodeSize();
                }
            },

            _syncProxyNodeSize: function() {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_syncProxyNodeSize", 603);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 604);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 605);
var node = DDM.activeDrag.get(NODE);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 606);
var proxyNode = instance.get(PROXY_NODE);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 608);
if (node && proxyNode) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 609);
proxyNode.set(
                        OFFSET_HEIGHT,
                        node.get(OFFSET_HEIGHT)
                    );

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 614);
proxyNode.set(
                        OFFSET_WIDTH,
                        node.get(OFFSET_WIDTH)
                    );
                }
            },

            /*
            * Listeners
            */
            _afterDragStart: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_afterDragStart", 624);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 625);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 627);
if (instance.get(PROXY)) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 628);
instance._syncProxyNodeUI(event);
                }
            },

            _onDragEnd: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_onDragEnd", 632);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 633);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 634);
var placeholder = instance.get(PLACEHOLDER);
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 635);
var proxyNode = instance.get(PROXY_NODE);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 637);
if (!instance.lazyEvents) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 638);
instance._positionNode(event);
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 641);
if (proxyNode) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 642);
proxyNode.remove();
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 645);
if (placeholder) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 646);
placeholder.hide();
                }

                // reset the last information
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 650);
instance.lastQuadrant = null;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 651);
instance.lastXDirection = null;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 652);
instance.lastYDirection = null;
            },

            // fires after drag:start
            _onDragEnter: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_onDragEnter", 656);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 657);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 659);
instance.activeDrop = DDM.activeDrop;

                // check if lazyEvents is true and if there is a lastActiveDrop
                // the checking for lastActiveDrop prevents fire the _syncPlaceholderUI when quadrant* events fires
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 663);
if (instance.lazyEvents && instance.lastActiveDrop) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 664);
instance.lazyEvents = false;

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 666);
instance._syncPlaceholderUI(event);
                }

                // lastActiveDrop is always updated by the drag exit,
                // but if there is no lastActiveDrop update it on drag enter update it
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 671);
if (!instance.lastActiveDrop) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 672);
instance.lastActiveDrop = DDM.activeDrop;
                }
            },

            _onDragExit: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_onDragExit", 676);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 677);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 679);
instance._syncPlaceholderUI(event);

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 681);
instance.activeDrop = DDM.activeDrop;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 683);
instance.lastActiveDrop = DDM.activeDrop;
            },

            _onDragOver: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_onDragOver", 686);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 687);
var instance = this;
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 688);
var drag = event.drag;

                // prevent drag over bubbling, filtering the top most element
                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 691);
if (instance.activeDrop == DDM.activeDrop) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 692);
instance.calculateDirections(drag);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 694);
instance.calculateQuadrant(drag, instance.activeDrop);

                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 696);
instance._fireQuadrantEvents();
                }
            },

            // fires before drag:enter
            _onDragStart: function(event) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_onDragStart", 701);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 702);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 704);
if (instance.get(LAZY_START)) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 705);
instance.lazyEvents = true;
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 708);
instance.lastActiveDrop = null;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 710);
instance.activeDrop = DDM.activeDrop;
            },

            _setDropNodes: function(val) {
                _yuitest_coverfunc("build/aui-sortable-layout/aui-sortable-layout.js", "_setDropNodes", 713);
_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 714);
var instance = this;

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 716);
if (isFunction(val)) {
                    _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 717);
val = val.call(instance);
                }

                _yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 720);
return nodeListSetter(val);
            }
        }
    }
);

_yuitest_coverline("build/aui-sortable-layout/aui-sortable-layout.js", 726);
A.SortableLayout = SortableLayout;

}, '2.0.0pr1', {
    "requires": [
        "dd-delegate",
        "dd-drag",
        "dd-drop",
        "dd-proxy",
        "aui-node",
        "aui-component"
    ],
    "skinnable": true
});
