if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-sortable-list/aui-sortable-list.js",
    code: []
};
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"].code=["YUI.add('aui-sortable-list', function (A, NAME) {","","/**"," * The SortableList Utility - Full documentation coming soon."," *"," * @module aui-sortable-list"," */","","var L = A.Lang,","    isString = L.isString,","    isFunction = L.isFunction,","","    BLOCK = 'block',","    BODY = 'body',","    DD = 'dd',","    DISPLAY = 'display',","    DOWN = 'down',","    DRAG_NODE = 'dragNode',","    DROP_CONDITION = 'dropCondition',","    DROP_CONTAINER = 'dropContainer',","    DROP_ON = 'dropOn',","    FLOAT = 'float',","    HEIGHT = 'height',","    HELPER = 'helper',","    HIDDEN = 'hidden',","    LEFT = 'left',","    NODE = 'node',","    NODES = 'nodes',","    NONE = 'none',","    OFFSET_HEIGHT = 'offsetHeight',","    PLACEHOLDER = 'placeholder',","    PROXY = 'proxy',","    PX = 'px',","    RIGHT = 'right',","    SORT_CONDITION = 'sortCondition',","    SORTABLE_LIST = 'sortable-list',","    UP = 'up',","    VISIBILITY = 'visibility',","    VISIBLE = 'visible',","","    DDM = A.DD.DDM,","","    isNodeList = function(v) {","        return (v instanceof A.NodeList);","    };","","/**"," * A base class for SortableList, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li>Sortable list utility</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var nl = new A.SortableList({"," *      nodes: '#demo li',"," *      dropContainer: 'ul.droppable'"," *  });"," * </code></pre>"," *"," * Check the list of <a href=\"SortableList.html#configattributes\">Configuration Attributes</a> available for"," * SortableList."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class SortableList"," * @constructor"," * @extends Base"," */","var SortableList = A.Component.create(","    {","        /**","         * Static property provides a string to identify the class.","         *","         * @property SortableList.NAME","         * @type String","         * @static","         */","        NAME: SORTABLE_LIST,","","        /**","         * Static property used to define the default attribute","         * configuration for the SortableList.","         *","         * @property SortableList.ATTRS","         * @type Object","         * @static","         */","        ATTRS: {","            dd: {","                value: null","            },","","            dropCondition: {","                value: function() {","                    return true;","                },","                setter: function(v) {","                    return A.bind(v, this);","                },","                validator: isFunction","            },","","            dropContainer: {","                value: function(event) {","                    var instance = this;","                    var drop = event.drop;","                    var dropNode = drop.get(NODE);","                    var dropOn = instance.get(DROP_ON);","","                    return dropNode.one(dropOn);","                },","                validator: isFunction","            },","","            dropOn: {","                validator: isString","            },","","            helper: {","                value: null","            },","","            nodes: {","                setter: function(v) {","                    return this._setNodes(v);","                }","            },","","            placeholder: {","                value: null","            },","","            proxy: {","                value: null,","                setter: function(val) {","                    return A.merge(","                        {","                            moveOnEnd: false,","                            positionProxy: false","                        },","                        val || {}","                    );","                }","            },","","            sortCondition: {","                value: function() {","                    return true;","                },","                setter: function(v) {","                    return A.bind(v, this);","                },","                validator: isFunction","            }","        },","","        EXTENDS: A.Base,","","        prototype: {","            /**","             * Construction logic executed during SortableList instantiation. Lifecycle.","             *","             * @method initializer","             * @protected","             */","            initializer: function() {","                var instance = this;","                var nodes = instance.get(NODES);","","                // drag & drop listeners","                instance.on('drag:align', instance._onDragAlign);","                instance.on('drag:end', instance._onDragEnd);","                instance.on('drag:exit', instance._onDragExit);","                instance.on('drag:mouseDown', instance._onDragMouseDown);","                instance.on('drag:over', instance._onDragOver);","                instance.on('drag:start', instance._onDragStart);","","                instance._createHelper();","","                if (nodes) {","                    instance.addAll(nodes);","                }","            },","","            /*","            * Methods","            */","            add: function(node) {","                var instance = this;","","                instance._createDrag(node);","            },","","            addAll: function(nodes) {","                var instance = this;","","                nodes.each(function(node) {","                    instance.add(node);","                });","            },","","            _createDrag: function(node) {","                var instance = this;","                var helper = instance.get(HELPER);","","                if (!DDM.getDrag(node)) {","                    var dragOptions = {","                        bubbleTargets: instance,","                        node: node,","                        target: true","                    };","","                    var proxyOptions = instance.get(PROXY);","","                    if (helper) {","                        proxyOptions.borderStyle = null;","                    }","","                    // creating delayed drag instance","                    new A.DD.Drag(","                        A.mix(dragOptions, instance.get(DD))","                    )","                    .plug(A.Plugin.DDProxy, proxyOptions);","                }","            },","","            _createHelper: function() {","                var instance = this;","                var helper = instance.get(HELPER);","","                if (helper) {","                    // append helper to the body","                    A.one(BODY).append( helper.hide() );","","                    instance.set(HELPER, helper);","                }","            },","","            _updatePlaceholder: function(event, cancelAppend) {","                var instance = this;","                var drag = event.target;","                var drop = event.drop;","                var dragNode = drag.get(NODE);","                var dropNode = drop.get(NODE);","                var dropContainer = instance.get(DROP_CONTAINER);","                var container;","","                if (dropContainer) {","                    container = dropContainer.apply(instance, arguments);","                }","","                var floating = false;","                var xDirection = instance.XDirection;","                var yDirection = instance.YDirection;","","                if (dropNode.getStyle(FLOAT) !== NONE) {","                    floating = true;","                }","","                var placeholder = instance.get(PLACEHOLDER);","","                if (!placeholder) {","                    // if no placeholder use the dragNode instead","                    placeholder = dragNode;","                }","","                if (!placeholder.contains(dropNode)) {","                    // check for the user dropCondition","                    var dropCondition = instance.get(DROP_CONDITION);","","                    // if there is a container waiting for nodes to be appended it's priority","                    if (container && !cancelAppend && dropCondition(event)) {","                        // this checking avoid the parent bubbling drag:over","                        if (!container.contains(placeholder) &&","                            !placeholder.contains(container)) {","                                // append placeholder on the found container","                                container.append(placeholder);","                        }","                    }","                    // otherwise, check if it's floating and the xDirection","                    // or if it's not floating and the yDirection","                    else {","                        if ((floating && (xDirection === LEFT)) || (!floating && (yDirection === UP))) {","                            // LEFT or UP directions means to place the placeholder before","                            dropNode.placeBefore(placeholder);","                        }","                        else {","                            // RIGHT or DOWN directions means to place the placeholder after","                            dropNode.placeAfter(placeholder);","                        }","                    }","                }","            },","","            /*","            * Listeners","            */","            _onDragAlign: function(event) {","                var instance = this;","                var lastX = instance.lastX;","                var lastY = instance.lastY;","                var xy = event.target.lastXY;","","                var x = xy[0];","                var y = xy[1];","","                // if the y change","                if (y !== lastY) {","                    // set the drag vertical direction","                    instance.YDirection = (y < lastY) ? UP : DOWN;","                }","","                // if the x change","                if (x !== lastX) {","                    // set the drag horizontal direction","                    instance.XDirection = (x < lastX) ? LEFT : RIGHT;","                }","","                instance.lastX = x;","                instance.lastY = y;","            },","","            _onDragEnd: function(event) {","                var instance = this;","                var drag = event.target;","                var dragNode = drag.get(NODE);","                var placeholder = instance.get(PLACEHOLDER);","","                if (placeholder) {","                    dragNode.show();","                    placeholder.hide();","","                    if (!dragNode.contains(placeholder)) {","                        // position dragNode after the placeholder","                        placeholder.placeAfter(dragNode);","                    }","                }","            },","","            _onDragExit: function(event) {","                var instance = this;","                var sortCondition = instance.get(SORT_CONDITION);","","                if (sortCondition(event)) {","                    instance._updatePlaceholder(event, true);","                }","            },","","            _onDragMouseDown: function(event) {","                var instance = this;","                var drag = event.target;","                var helper = instance.get(HELPER);","","                if (helper) {","                    // update the DRAG_NODE with the new helper","                    drag.set(DRAG_NODE, helper);","                }","            },","","            _onDragStart: function(event) {","                var instance = this;","                var drag = event.target;","                var node = drag.get(NODE);","                var helper = instance.get(HELPER);","                var placeholder = instance.get(PLACEHOLDER);","","                if (placeholder) {","                    // update placeholder height","                    placeholder.setStyle(","                        HEIGHT,","                        node.get(OFFSET_HEIGHT) + PX","                    );","","                    node.hide();","                    placeholder.show();","                    // position placeholder after the node","                    node.placeAfter(placeholder);","","                    if (helper) {","                        // show helper, we need display block here, yui dd hide it with display none","                        helper.setStyles({","                            display: BLOCK,","                            visibility: VISIBLE","                        }).show();","                    }","                }","            },","","            _onDragOver: function(event) {","                var instance = this;","                var sortCondition = instance.get(SORT_CONDITION);","","                if (sortCondition(event)) {","                    instance._updatePlaceholder(event);","                }","            },","","            /*","            * Setters","            */","            _setNodes: function(v) {","                var instance = this;","","                if (isNodeList(v)) {","                    return v;","                }","                else if (isString(v)) {","                    return A.all(v);","                }","","                return new A.NodeList([v]);","            }","        }","    }",");","","A.SortableList = SortableList;","","}, '2.0.0pr1', {\"requires\": [\"dd-drag\", \"dd-drop\", \"dd-proxy\", \"aui-node\", \"aui-component\"]});"];
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"].lines = {"1":0,"9":0,"44":0,"71":0,"97":0,"100":0,"107":0,"108":0,"109":0,"110":0,"112":0,"127":0,"138":0,"150":0,"153":0,"169":0,"170":0,"173":0,"174":0,"175":0,"176":0,"177":0,"178":0,"180":0,"182":0,"183":0,"191":0,"193":0,"197":0,"199":0,"200":0,"205":0,"206":0,"208":0,"209":0,"215":0,"217":0,"218":0,"222":0,"230":0,"231":0,"233":0,"235":0,"237":0,"242":0,"243":0,"244":0,"245":0,"246":0,"247":0,"248":0,"250":0,"251":0,"254":0,"255":0,"256":0,"258":0,"259":0,"262":0,"264":0,"266":0,"269":0,"271":0,"274":0,"276":0,"279":0,"285":0,"287":0,"291":0,"301":0,"302":0,"303":0,"304":0,"306":0,"307":0,"310":0,"312":0,"316":0,"318":0,"321":0,"322":0,"326":0,"327":0,"328":0,"329":0,"331":0,"332":0,"333":0,"335":0,"337":0,"343":0,"344":0,"346":0,"347":0,"352":0,"353":0,"354":0,"356":0,"358":0,"363":0,"364":0,"365":0,"366":0,"367":0,"369":0,"371":0,"376":0,"377":0,"379":0,"381":0,"383":0,"392":0,"393":0,"395":0,"396":0,"404":0,"406":0,"407":0,"409":0,"410":0,"413":0,"419":0};
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"].functions = {"isNodeList:43":0,"value:96":0,"setter:99":0,"value:106":0,"setter:126":0,"setter:137":0,"value:149":0,"setter:152":0,"initializer:168":0,"add:190":0,"(anonymous 2):199":0,"addAll:196":0,"_createDrag:204":0,"_createHelper:229":0,"_updatePlaceholder:241":0,"_onDragAlign:300":0,"_onDragEnd:325":0,"_onDragExit:342":0,"_onDragMouseDown:351":0,"_onDragStart:362":0,"_onDragOver:391":0,"_setNodes:403":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"].coveredLines = 122;
_yuitest_coverage["build/aui-sortable-list/aui-sortable-list.js"].coveredFunctions = 23;
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 1);
YUI.add('aui-sortable-list', function (A, NAME) {

/**
 * The SortableList Utility - Full documentation coming soon.
 *
 * @module aui-sortable-list
 */

_yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 9);
var L = A.Lang,
    isString = L.isString,
    isFunction = L.isFunction,

    BLOCK = 'block',
    BODY = 'body',
    DD = 'dd',
    DISPLAY = 'display',
    DOWN = 'down',
    DRAG_NODE = 'dragNode',
    DROP_CONDITION = 'dropCondition',
    DROP_CONTAINER = 'dropContainer',
    DROP_ON = 'dropOn',
    FLOAT = 'float',
    HEIGHT = 'height',
    HELPER = 'helper',
    HIDDEN = 'hidden',
    LEFT = 'left',
    NODE = 'node',
    NODES = 'nodes',
    NONE = 'none',
    OFFSET_HEIGHT = 'offsetHeight',
    PLACEHOLDER = 'placeholder',
    PROXY = 'proxy',
    PX = 'px',
    RIGHT = 'right',
    SORT_CONDITION = 'sortCondition',
    SORTABLE_LIST = 'sortable-list',
    UP = 'up',
    VISIBILITY = 'visibility',
    VISIBLE = 'visible',

    DDM = A.DD.DDM,

    isNodeList = function(v) {
        _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "isNodeList", 43);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 44);
return (v instanceof A.NodeList);
    };

/**
 * A base class for SortableList, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li>Sortable list utility</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var nl = new A.SortableList({
 *      nodes: '#demo li',
 *      dropContainer: 'ul.droppable'
 *  });
 * </code></pre>
 *
 * Check the list of <a href="SortableList.html#configattributes">Configuration Attributes</a> available for
 * SortableList.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class SortableList
 * @constructor
 * @extends Base
 */
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 71);
var SortableList = A.Component.create(
    {
        /**
         * Static property provides a string to identify the class.
         *
         * @property SortableList.NAME
         * @type String
         * @static
         */
        NAME: SORTABLE_LIST,

        /**
         * Static property used to define the default attribute
         * configuration for the SortableList.
         *
         * @property SortableList.ATTRS
         * @type Object
         * @static
         */
        ATTRS: {
            dd: {
                value: null
            },

            dropCondition: {
                value: function() {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "value", 96);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 97);
return true;
                },
                setter: function(v) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "setter", 99);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 100);
return A.bind(v, this);
                },
                validator: isFunction
            },

            dropContainer: {
                value: function(event) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "value", 106);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 107);
var instance = this;
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 108);
var drop = event.drop;
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 109);
var dropNode = drop.get(NODE);
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 110);
var dropOn = instance.get(DROP_ON);

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 112);
return dropNode.one(dropOn);
                },
                validator: isFunction
            },

            dropOn: {
                validator: isString
            },

            helper: {
                value: null
            },

            nodes: {
                setter: function(v) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "setter", 126);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 127);
return this._setNodes(v);
                }
            },

            placeholder: {
                value: null
            },

            proxy: {
                value: null,
                setter: function(val) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "setter", 137);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 138);
return A.merge(
                        {
                            moveOnEnd: false,
                            positionProxy: false
                        },
                        val || {}
                    );
                }
            },

            sortCondition: {
                value: function() {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "value", 149);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 150);
return true;
                },
                setter: function(v) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "setter", 152);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 153);
return A.bind(v, this);
                },
                validator: isFunction
            }
        },

        EXTENDS: A.Base,

        prototype: {
            /**
             * Construction logic executed during SortableList instantiation. Lifecycle.
             *
             * @method initializer
             * @protected
             */
            initializer: function() {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "initializer", 168);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 169);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 170);
var nodes = instance.get(NODES);

                // drag & drop listeners
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 173);
instance.on('drag:align', instance._onDragAlign);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 174);
instance.on('drag:end', instance._onDragEnd);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 175);
instance.on('drag:exit', instance._onDragExit);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 176);
instance.on('drag:mouseDown', instance._onDragMouseDown);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 177);
instance.on('drag:over', instance._onDragOver);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 178);
instance.on('drag:start', instance._onDragStart);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 180);
instance._createHelper();

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 182);
if (nodes) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 183);
instance.addAll(nodes);
                }
            },

            /*
            * Methods
            */
            add: function(node) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "add", 190);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 191);
var instance = this;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 193);
instance._createDrag(node);
            },

            addAll: function(nodes) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "addAll", 196);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 197);
var instance = this;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 199);
nodes.each(function(node) {
                    _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "(anonymous 2)", 199);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 200);
instance.add(node);
                });
            },

            _createDrag: function(node) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_createDrag", 204);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 205);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 206);
var helper = instance.get(HELPER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 208);
if (!DDM.getDrag(node)) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 209);
var dragOptions = {
                        bubbleTargets: instance,
                        node: node,
                        target: true
                    };

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 215);
var proxyOptions = instance.get(PROXY);

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 217);
if (helper) {
                        _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 218);
proxyOptions.borderStyle = null;
                    }

                    // creating delayed drag instance
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 222);
new A.DD.Drag(
                        A.mix(dragOptions, instance.get(DD))
                    )
                    .plug(A.Plugin.DDProxy, proxyOptions);
                }
            },

            _createHelper: function() {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_createHelper", 229);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 230);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 231);
var helper = instance.get(HELPER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 233);
if (helper) {
                    // append helper to the body
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 235);
A.one(BODY).append( helper.hide() );

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 237);
instance.set(HELPER, helper);
                }
            },

            _updatePlaceholder: function(event, cancelAppend) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_updatePlaceholder", 241);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 242);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 243);
var drag = event.target;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 244);
var drop = event.drop;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 245);
var dragNode = drag.get(NODE);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 246);
var dropNode = drop.get(NODE);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 247);
var dropContainer = instance.get(DROP_CONTAINER);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 248);
var container;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 250);
if (dropContainer) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 251);
container = dropContainer.apply(instance, arguments);
                }

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 254);
var floating = false;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 255);
var xDirection = instance.XDirection;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 256);
var yDirection = instance.YDirection;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 258);
if (dropNode.getStyle(FLOAT) !== NONE) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 259);
floating = true;
                }

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 262);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 264);
if (!placeholder) {
                    // if no placeholder use the dragNode instead
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 266);
placeholder = dragNode;
                }

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 269);
if (!placeholder.contains(dropNode)) {
                    // check for the user dropCondition
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 271);
var dropCondition = instance.get(DROP_CONDITION);

                    // if there is a container waiting for nodes to be appended it's priority
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 274);
if (container && !cancelAppend && dropCondition(event)) {
                        // this checking avoid the parent bubbling drag:over
                        _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 276);
if (!container.contains(placeholder) &&
                            !placeholder.contains(container)) {
                                // append placeholder on the found container
                                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 279);
container.append(placeholder);
                        }
                    }
                    // otherwise, check if it's floating and the xDirection
                    // or if it's not floating and the yDirection
                    else {
                        _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 285);
if ((floating && (xDirection === LEFT)) || (!floating && (yDirection === UP))) {
                            // LEFT or UP directions means to place the placeholder before
                            _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 287);
dropNode.placeBefore(placeholder);
                        }
                        else {
                            // RIGHT or DOWN directions means to place the placeholder after
                            _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 291);
dropNode.placeAfter(placeholder);
                        }
                    }
                }
            },

            /*
            * Listeners
            */
            _onDragAlign: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragAlign", 300);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 301);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 302);
var lastX = instance.lastX;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 303);
var lastY = instance.lastY;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 304);
var xy = event.target.lastXY;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 306);
var x = xy[0];
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 307);
var y = xy[1];

                // if the y change
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 310);
if (y !== lastY) {
                    // set the drag vertical direction
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 312);
instance.YDirection = (y < lastY) ? UP : DOWN;
                }

                // if the x change
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 316);
if (x !== lastX) {
                    // set the drag horizontal direction
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 318);
instance.XDirection = (x < lastX) ? LEFT : RIGHT;
                }

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 321);
instance.lastX = x;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 322);
instance.lastY = y;
            },

            _onDragEnd: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragEnd", 325);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 326);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 327);
var drag = event.target;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 328);
var dragNode = drag.get(NODE);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 329);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 331);
if (placeholder) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 332);
dragNode.show();
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 333);
placeholder.hide();

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 335);
if (!dragNode.contains(placeholder)) {
                        // position dragNode after the placeholder
                        _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 337);
placeholder.placeAfter(dragNode);
                    }
                }
            },

            _onDragExit: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragExit", 342);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 343);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 344);
var sortCondition = instance.get(SORT_CONDITION);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 346);
if (sortCondition(event)) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 347);
instance._updatePlaceholder(event, true);
                }
            },

            _onDragMouseDown: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragMouseDown", 351);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 352);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 353);
var drag = event.target;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 354);
var helper = instance.get(HELPER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 356);
if (helper) {
                    // update the DRAG_NODE with the new helper
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 358);
drag.set(DRAG_NODE, helper);
                }
            },

            _onDragStart: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragStart", 362);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 363);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 364);
var drag = event.target;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 365);
var node = drag.get(NODE);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 366);
var helper = instance.get(HELPER);
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 367);
var placeholder = instance.get(PLACEHOLDER);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 369);
if (placeholder) {
                    // update placeholder height
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 371);
placeholder.setStyle(
                        HEIGHT,
                        node.get(OFFSET_HEIGHT) + PX
                    );

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 376);
node.hide();
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 377);
placeholder.show();
                    // position placeholder after the node
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 379);
node.placeAfter(placeholder);

                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 381);
if (helper) {
                        // show helper, we need display block here, yui dd hide it with display none
                        _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 383);
helper.setStyles({
                            display: BLOCK,
                            visibility: VISIBLE
                        }).show();
                    }
                }
            },

            _onDragOver: function(event) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_onDragOver", 391);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 392);
var instance = this;
                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 393);
var sortCondition = instance.get(SORT_CONDITION);

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 395);
if (sortCondition(event)) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 396);
instance._updatePlaceholder(event);
                }
            },

            /*
            * Setters
            */
            _setNodes: function(v) {
                _yuitest_coverfunc("build/aui-sortable-list/aui-sortable-list.js", "_setNodes", 403);
_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 404);
var instance = this;

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 406);
if (isNodeList(v)) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 407);
return v;
                }
                else {_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 409);
if (isString(v)) {
                    _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 410);
return A.all(v);
                }}

                _yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 413);
return new A.NodeList([v]);
            }
        }
    }
);

_yuitest_coverline("build/aui-sortable-list/aui-sortable-list.js", 419);
A.SortableList = SortableList;

}, '2.0.0pr1', {"requires": ["dd-drag", "dd-drop", "dd-proxy", "aui-node", "aui-component"]});
