if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-tree-data/aui-tree-data.js",
    code: []
};
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"].code=["YUI.add('aui-tree-data', function (A, NAME) {","","/**"," * The TreeData Utility"," *"," * @module aui-tree"," * @submodule aui-tree-data"," */","","var L = A.Lang,","	isArray = L.isArray,","	isBoolean = L.isBoolean,","	isObject = L.isObject,","	isUndefined = L.isUndefined,","","	BOUNDING_BOX = 'boundingBox',","	CHILDREN = 'children',","	CONTAINER = 'container',","	DOT = '.',","	ID = 'id',","	INDEX = 'index',","	LAZY_LOAD = 'lazyLoad',","	LEAF = 'leaf',","	NEXT_SIBLING = 'nextSibling',","	NODE = 'node',","	OWNER_TREE = 'ownerTree',","	PARENT_NODE = 'parentNode',","	PREV_SIBLING = 'prevSibling',","	PREVIOUS_SIBLING = 'previousSibling',","	TREE = 'tree',","	TREE_NODE = 'tree-node',","	TREE_DATA = 'tree-data',","","	isTreeNode = function(v) {","		return ( A.instanceOf(v, A.TreeNode) );","	},","","	isTreeView = function(v) {","		return ( A.instanceOf(v, A.TreeView) );","	},","","	getCN = A.getClassName,","","	CSS_TREE_NODE = getCN(TREE, NODE);","","/**"," * A base class for TreeData, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li>Handle the data of the tree</li>"," *    <li>Basic DOM implementation (append/remove/insert)</li>"," *    <li>Indexing management to handle the children nodes</li>"," * </ul>"," *"," * Check the list of <a href=\"TreeData.html#configattributes\">Configuration Attributes</a> available for"," * TreeData."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeData"," * @constructor"," * @extends Base"," */","","var TreeData = function () {};","","TreeData.ATTRS = {","	/**","	 * Container to nest children nodes. If has cntainer it's not a leaf.","	 *","	 * @attribute container","	 * @default null","	 * @type Node | String","	 */","	container: {","		setter: A.one","	},","","	/**","	 * Array of children (i.e. could be a JSON metadata object or a TreeNode instance).","	 *","	 * @attribute children","	 * @default []","	 * @type Array","	 */","	children: {","		value: [],","		validator: isArray,","		setter: '_setChildren'","	},","","	/**","	 * Index the nodes.","	 *","	 * @attribute index","	 * @default {}","	 * @type Object","	 */","	index: {","		value: {}","	}","};","","A.mix(TreeData.prototype, {","	childrenLength: 0,","","	/**","	 * Construction logic executed during TreeData instantiation. Lifecycle.","	 *","	 * @method initializer","	 * @protected","	 */","	initializer: function() {","		var instance = this;","","		// binding on initializer, needed before .render() phase","		instance.publish('move');","		instance.publish('append', { defaultFn: instance._appendChild });","		instance.publish('remove', { defaultFn: instance._removeChild });","	},","","	/**","	 * Descructor lifecycle implementation for the TreeData class.","	 * Purges events attached to the node (and all child nodes).","	 *","	 * @method destructor","	 * @protected","	 */","	destructor: function() {","		var instance = this;","","		instance.eachChildren(function(node) {","			node.destroy();","		}, true);","	},","","	/**","	 * Get a TreeNode by id.","	 *","	 * @method getNodeById","	 * @param {String} uid","	 * @return {TreeNode}","	 */","	getNodeById: function(uid) {","		var instance = this;","","		return instance.get(INDEX)[uid];","	},","","	/**","	 * Whether the TreeNode is registered on this TreeData.","	 *","	 * @method isRegistered","	 * @param {TreeNode} node","	 * @return {boolean}","	 */","	isRegistered: function(node) {","		var instance = this;","","		return !!(instance.get(INDEX)[ node.get(ID) ]);","	},","","	/**","	 * Update the references of the passed TreeNode.","	 *","	 * @method updateReferences","	 * @param {node} TreeNode","	 * @param {parentNode} TreeNode","	 * @param {ownerTree} TreeView","	 */","	updateReferences: function(node, parentNode, ownerTree) {","		var instance = this;","		var oldParent = node.get(PARENT_NODE);","		var oldOwnerTree = node.get(OWNER_TREE);","		var moved = oldParent && (oldParent !== parentNode);","","		if (oldParent) {","			if (moved) {","				// when moved update the oldParent children","				var children = oldParent.get(CHILDREN);","","				A.Array.removeItem(children, node);","","				oldParent.set(CHILDREN, children);","			}","","			oldParent.unregisterNode(node);","		}","","		if (oldOwnerTree) {","			oldOwnerTree.unregisterNode(node);","		}","","		// update parent reference when registered","		node.set(PARENT_NODE, parentNode);","","		// update the ownerTree of the node","		node.set(OWNER_TREE, ownerTree);","","		if (parentNode) {","			// register the new node on the parentNode index","			parentNode.registerNode(node);","		}","","		if (ownerTree) {","			// register the new node to the ownerTree index","			ownerTree.registerNode(node);","		}","","		if (oldOwnerTree != ownerTree) {","			// when change the OWNER_TREE update the children references also","			node.eachChildren(function(child) {","				instance.updateReferences(child, child.get(PARENT_NODE), ownerTree);","			});","		}","","		// trigger move event","		if (moved) {","			var output = instance.getEventOutputMap(node);","","			if (!oldParent.get('children').length) {","				oldParent.collapse();","				oldParent.hideHitArea();","			}","","			output.tree.oldParent = oldParent;","			output.tree.oldOwnerTree = oldOwnerTree;","","			instance.bubbleEvent('move', output);","		}","	},","","	/**","	 * Refresh the index (i.e. re-index all nodes).","	 *","	 * @method refreshIndex","	 */","	refreshIndex: function() {","		var instance = this;","","		// reset index","		instance.updateIndex({});","","		// get all descendent children - deep","		instance.eachChildren(function(node) {","			instance.registerNode(node);","		}, true);","	},","","	/**","	 * Register the passed TreeNode on this TreeData.","	 *","	 * @method registerNode","	 * @param {TreeNode} node","	 */","	registerNode: function(node) {","		var instance = this;","		var uid = node.get(ID);","		var index = instance.get(INDEX);","","		if (uid) {","			index[uid] = node;","		}","","		if (isTreeView(instance)) {","			node.addTarget(instance);","","			// when the node is appended to the TreeView set the OWNER_TREE","			node.set(OWNER_TREE, instance);","		}","","		node._inheritOwnerTreeAttrs();","","		instance.updateIndex(index);","	},","","	/**","	 * Update the <a href=\"TreeData.html#config_index\">index</a> attribute value.","	 *","	 * @method updateIndex","	 * @param {Object} index","	 */","	updateIndex: function(index) {","		var instance = this;","","		if (index) {","			instance.set(INDEX, index);","		}","	},","","	/**","	 * Unregister the passed TreeNode from this TreeData.","	 *","	 * @method unregisterNode","	 * @param {TreeNode} node","	 */","	unregisterNode: function(node) {","		var instance = this;","		var index = instance.get(INDEX);","","		delete index[ node.get(ID) ];","","		if (isTreeView(instance)) {","			node.removeTarget(instance);","		}","","		instance.updateIndex(index);","	},","","	/**","	 * Collapse all children of the TreeData.","	 *","	 * @method collapseAll","	 */","	collapseAll: function() {","		var instance = this;","","		instance.eachChildren(function(node) {","			node.collapse();","		}, true);","	},","","	/**","	 * Expand all children of the TreeData.","	 *","	 * @method expandAll","	 */","	expandAll: function() {","		var instance = this;","","		instance.eachChildren(function(node) {","			node.expand();","		}, true);","	},","","	/**","	 * Select all children of the TreeData.","	 *","	 * @method selectAll","	 */","	selectAll: function() {","		var instance = this;","","		instance.eachChildren(function(child) {","			child.select();","		}, true);","	},","","	/**","	 * Unselect all children of the TreeData.","	 *","	 * @method selectAll","	 */","	unselectAll: function() {","		var instance = this;","","		instance.eachChildren(function(child) {","			child.unselect();","		}, true);","	},","","	/**","	 * Loop each children and execute the <code>fn</code> callback.","	 *","	 * @method eachChildren","	 * @param {function} fn callback","	 * @param {boolean} fn recursive","	 */","	eachChildren: function(fn, deep) {","		var instance = this;","		var children = instance.getChildren(deep);","","		A.Array.each(children, function(node) {","			if (node) {","				fn.apply(instance, arguments);","			}","		});","	},","","	/**","	 * Loop each parent node and execute the <code>fn</code> callback.","	 *","	 * @method eachChildren","	 * @param {function} fn callback","	 */","	eachParent: function(fn) {","		var instance = this;","		var parentNode = instance.get(PARENT_NODE);","","		while (parentNode) {","			if (parentNode) {","				fn.call(instance, parentNode);","			}","			parentNode = parentNode.get(PARENT_NODE);","		}","	},","","	/**","	 * Bubble event to all parent nodes.","	 *","	 * @method bubbleEvent","	 * @param {String} eventType","	 * @param {Array} args","	 * @param {boolean} cancelBubbling","	 * @param {boolean} stopActionPropagation","	 */","	bubbleEvent: function(eventType, args, cancelBubbling, stopActionPropagation) {","		var instance = this;","","		// event.stopActionPropagation === undefined, invoke the event native action","		instance.fire(eventType, args);","","		if (!cancelBubbling) {","			var parentNode = instance.get(PARENT_NODE);","","			// Avoid execution of the native action (private methods) while propagate","			// for example: private _appendChild() is invoked only on the first level of the bubbling","			// the intention is only invoke the user callback on parent nodes.","			args = args || {};","","			if (isUndefined(stopActionPropagation)) {","				stopActionPropagation = true;","			}","","			args.stopActionPropagation = stopActionPropagation;","","			while(parentNode) {","				parentNode.fire(eventType, args);","				parentNode = parentNode.get(PARENT_NODE);","			}","		}","	},","","	/**","	 * Create a TreeNode instance.","	 *","	 * @method createNode","	 * @param {Object} options","	 * @return {TreeNode}","	 */","	createNode: function(options) {","		var instance = this;","		var classType = A.TreeNode.nodeTypes[ isObject(options) ? options.type : options ] || A.TreeNode;","","		return new classType(","			isObject(options) ? options : {}","		);","	},","","	/**","	 * Append a child node to the TreeData.","	 *","	 * @method appendChild","	 * @param {TreeNode} node","	 * @param {boolean} cancelBubbling","	 */","	appendChild: function(node, cancelBubbling) {","		var instance = this;","		var output = instance.getEventOutputMap(node);","","		instance.bubbleEvent('append', output, cancelBubbling);","	},","","	/**","	 * Append a child node to the TreeData.","	 *","	 * @method _appendChild","	 * @param {TreeNode} node","	 * @param {boolean} cancelBubbling","	 * @protected","	 */","	_appendChild: function(event) {","		// stopActionPropagation while bubbling","		if (event.stopActionPropagation) {","			return false;","		}","","		var instance = this;","		var node = event.tree.node;","		var ownerTree = instance.get(OWNER_TREE);","		var children = instance.get(CHILDREN);","","		// updateReferences first","		instance.updateReferences(node, instance, ownerTree);","		// and then set the children, to have the appendChild propagation","		// the PARENT_NODE references should be updated","		var length = children.push(node);","		instance.set(CHILDREN, children);","","		// updating prev/nextSibling attributes","		var prevIndex = length - 2;","		var prevSibling = instance.item(prevIndex);","","		node._nextSibling = null;","		node._prevSibling = prevSibling;","","		// render node","		node.render(instance.get(CONTAINER));","	},","","	/**","	 * Get a TreeNode children by index.","	 *","	 * @method item","	 * @param {Number} index","	 * @return {TreeNode}","	 */","	item: function(index) {","		var instance = this;","","		return instance.get(CHILDREN)[index];","	},","","	/**","	 * Index of the passed TreeNode on the <a","     * href=\"TreeData.html#config_children\">children</a> attribute.","	 *","	 * @method indexOf","	 * @param {TreeNode} node","	 * @return {Number}","	 */","	indexOf: function(node) {","		var instance = this;","","		return A.Array.indexOf( instance.get(CHILDREN), node );","	},","","	/**","	 * Whether the TreeData contains children or not.","	 *","	 * @method hasChildNodes","	 * @return {boolean}","	 */","	hasChildNodes: function() {","		var instance = this;","","		return (instance.getChildrenLength() > 0);","	},","","	/**","	 * Get an Array of the children nodes of the current TreeData.","	 *","	 * @method getChildren","	 * @param {boolean} deep","	 * @return {Array}","	 */","	getChildren: function(deep) {","		var instance = this;","		var cNodes = [];","		var children = instance.get(CHILDREN);","","		cNodes = cNodes.concat(children);","","		if (deep) {","			instance.eachChildren(function(child) {","				cNodes = cNodes.concat( child.getChildren(deep) );","			});","		}","","		return cNodes;","	},","","	getChildrenLength: function() {","		var instance = this;","","		return (instance.childrenLength || instance.get(CHILDREN).length);","	},","","	/**","	 * Get an object containing metadata for the custom events.","	 *","	 * @method getEventOutputMap","	 * @param {TreeData} node","	 * @return {Object}","	 */","	getEventOutputMap: function(node) {","		var instance = this;","","		return {","			tree: {","				instance: instance,","				node: node || instance","			}","		};","	},","","	/**","	 * Remove the passed <code>node</code> from the current TreeData.","	 *","	 * @method removeChild","	 * @param {TreeData} node","	 */","	removeChild: function(node) {","		var instance = this;","		var output = instance.getEventOutputMap(node);","","		instance.bubbleEvent('remove', output);","	},","","	/**","	 * Remove the passed <code>node</code> from the current TreeData.","	 *","	 * @method _removeChild","	 * @param {TreeData} node","	 */","	_removeChild: function(event) {","		// stopActionPropagation while bubbling","		if (event.stopActionPropagation) {","			return false;","		}","","		var instance = this;","		var node = event.tree.node;","		var ownerTree = instance.get(OWNER_TREE);","","		if (instance.isRegistered(node)) {","			// update parent reference when removed","			node.set(PARENT_NODE, null);","","			// unregister the node","			instance.unregisterNode(node);","","			// no parent, no ownerTree","			node.set(OWNER_TREE, null);","","			if (ownerTree) {","				// unregister the removed node from the tree index","				ownerTree.unregisterNode(node);","			}","","			// remove child from the container","			node.get(BOUNDING_BOX).remove();","","			var children = instance.get(CHILDREN);","","			A.Array.removeItem(children, node);","			instance.set(CHILDREN, children);","		}","	},","","	/**","	 * Delete all children of the current TreeData.","	 *","	 * @method empty","	 */","	empty: function() {","		var instance = this;","","		instance.eachChildren(function(node) {","			var parentNode = node.get(PARENT_NODE);","","			if (parentNode) {","				parentNode.removeChild(node);","			}","		});","	},","","	/**","	 * Insert <code>treeNode</code> before or after the <code>refTreeNode</code>.","	 *","	 * @method insert","	 * @param {TreeNode} treeNode","	 * @param {TreeNode} refTreeNode","	 * @param {TreeNode} where 'before' or 'after'","	 */","	insert: function(treeNode, refTreeNode, where) {","		var instance = this;","		refTreeNode = refTreeNode || this;","","		if (refTreeNode === treeNode) {","			return false; // NOTE: return","		}","","		var refParentTreeNode = refTreeNode.get(PARENT_NODE);","","		if (treeNode && refParentTreeNode) {","			var nodeBoundingBox = treeNode.get(BOUNDING_BOX);","			var refBoundingBox = refTreeNode.get(BOUNDING_BOX);","			var ownerTree = refTreeNode.get(OWNER_TREE);","","			if (where === 'before') {","				refBoundingBox.placeBefore(nodeBoundingBox);","			}","			else if (where === 'after') {","				refBoundingBox.placeAfter(nodeBoundingBox);","			}","","			var refSiblings = [];","			// using the YUI selector to regenerate the index based on the real dom","			// this avoid misscalculations on the nodes index number","			var DOMChildren = refParentTreeNode.get(BOUNDING_BOX).all('> ul > li');","","			DOMChildren.each(function(child) {","				refSiblings.push( child.getData(TREE_NODE) );","			});","","			// updating prev/nextSibling attributes","			var nextSiblingNode = nodeBoundingBox.get(NEXT_SIBLING);","","			treeNode.set(NEXT_SIBLING, nextSiblingNode && nextSiblingNode.getData(TREE_NODE));","","			var prevSiblingNode = nodeBoundingBox.get(PREVIOUS_SIBLING);","","			treeNode.set(PREV_SIBLING, prevSiblingNode && prevSiblingNode.getData(TREE_NODE));","","			// update all references","			refTreeNode.updateReferences(treeNode, refParentTreeNode, ownerTree);","","			// updating refParentTreeNode childTreeNodes","			refParentTreeNode.set(CHILDREN, refSiblings);","		}","","		// render treeNode after it's inserted","		treeNode.render();","","		// invoking insert event","		var output = refTreeNode.getEventOutputMap(treeNode);","","		output.tree.refTreeNode = refTreeNode;","","		refTreeNode.bubbleEvent('insert', output);","	},","","	/**","	 * Insert <code>treeNode</code> after the <code>refTreeNode</code>.","	 *","	 * @method insertAfter","	 * @param {TreeNode} treeNode","	 * @param {TreeNode} refTreeNode","	 */","	insertAfter: function(treeNode, refTreeNode) {","		var instance = this;","","		instance.insert(treeNode, refTreeNode, 'after');","	},","","	/**","	 * Insert <code>treeNode</code> before the <code>refTreeNode</code>.","	 *","	 * @method insertBefore","	 * @param {TreeNode} treeNode","	 * @param {TreeNode} refTreeNode","	 */","	insertBefore: function(treeNode, refTreeNode) {","		var instance = this;","","		instance.insert(treeNode, refTreeNode, 'before');","	},","","	/**","	 * Get a TreeNode instance by a child DOM Node.","	 *","	 * @method getNodeByChild","	 * @param {Node} child","	 * @return {TreeNode}","	 */","	getNodeByChild: function(child) {","		var instance = this;","		var treeNodeEl = child.ancestor(DOT+CSS_TREE_NODE);","","		if (treeNodeEl) {","			return treeNodeEl.getData(TREE_NODE);","		}","","		return null;","	},","","	_inheritOwnerTreeAttrs: L.emptyFn,","","	/**","	 * Setter for <a href=\"TreeData.html#config_children\">children</a>.","	 *","	 * @method _setChildren","	 * @protected","	 * @param {Array} v","	 * @return {Array}","	 */","	_setChildren: function(v) {","		var instance = this;","		var childNodes = [];","		var container = instance.get(CONTAINER);","","		if (!container) {","			container = instance._createNodeContainer();","		}","","		instance.childrenLength = v.length;","","		// before render the node, make sure the PARENT_NODE and OWNER_TREE references are updated","		// this is required on the render phase of the TreeNode (_createNodeContainer)","		// to propagate the events callback (appendChild/expand)","		var ownerTree = instance;","","		if (isTreeNode(instance)) {","			ownerTree = instance.get(OWNER_TREE);","		}","","		var hasOwnerTree = isTreeView(ownerTree);","		var lazyLoad = true;","","		if (hasOwnerTree) {","			lazyLoad = ownerTree.get(LAZY_LOAD);","		}","","		instance.updateIndex({});","","		if (instance.childrenLength > 0) {","			instance.set(LEAF, false);","		}","","		A.Array.each(v, function(node, index) {","			if (node) {","				if (!isTreeNode(node) && isObject(node)) {","					// cache and remove children to lazy add them later for","					// performance reasons","					var children = node[CHILDREN];","					var hasChildren = children && children.length;","","					node[OWNER_TREE] = ownerTree;","					node[PARENT_NODE] = instance;","","					if (hasChildren && lazyLoad) {","						delete node[CHILDREN];","					}","","					// creating node from json","					node = instance.createNode(node);","","					if (hasChildren && lazyLoad) {","						A.setTimeout(function() {","							node.set(CHILDREN, children);","						}, 50);","					}","				}","","				if (hasOwnerTree) {","					ownerTree.registerNode(node);","				}","","				node.render(container);","","				// avoid duplicated children on the childNodes list","				if (A.Array.indexOf(childNodes, node) === -1) {","					childNodes.push(node);","				}","			}","		});","","		return childNodes;","	}","});","","A.TreeData = TreeData;","","}, '2.0.0pr1', {\"requires\": [\"aui-base-core\", \"aui-base-lang\", \"aui-node-base\", \"aui-timer\", \"aui-component\"]});"];
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"].lines = {"1":0,"10":0,"35":0,"39":0,"65":0,"67":0,"104":0,"114":0,"117":0,"118":0,"119":0,"130":0,"132":0,"133":0,"145":0,"147":0,"158":0,"160":0,"172":0,"173":0,"174":0,"175":0,"177":0,"178":0,"180":0,"182":0,"184":0,"187":0,"190":0,"191":0,"195":0,"198":0,"200":0,"202":0,"205":0,"207":0,"210":0,"212":0,"213":0,"218":0,"219":0,"221":0,"222":0,"223":0,"226":0,"227":0,"229":0,"239":0,"242":0,"245":0,"246":0,"257":0,"258":0,"259":0,"261":0,"262":0,"265":0,"266":0,"269":0,"272":0,"274":0,"284":0,"286":0,"287":0,"298":0,"299":0,"301":0,"303":0,"304":0,"307":0,"316":0,"318":0,"319":0,"329":0,"331":0,"332":0,"342":0,"344":0,"345":0,"355":0,"357":0,"358":0,"370":0,"371":0,"373":0,"374":0,"375":0,"387":0,"388":0,"390":0,"391":0,"392":0,"394":0,"408":0,"411":0,"413":0,"414":0,"419":0,"421":0,"422":0,"425":0,"427":0,"428":0,"429":0,"442":0,"443":0,"445":0,"458":0,"459":0,"461":0,"474":0,"475":0,"478":0,"479":0,"480":0,"481":0,"484":0,"487":0,"488":0,"491":0,"492":0,"494":0,"495":0,"498":0,"509":0,"511":0,"523":0,"525":0,"535":0,"537":0,"548":0,"549":0,"550":0,"552":0,"554":0,"555":0,"556":0,"560":0,"564":0,"566":0,"577":0,"579":0,"594":0,"595":0,"597":0,"608":0,"609":0,"612":0,"613":0,"614":0,"616":0,"618":0,"621":0,"624":0,"626":0,"628":0,"632":0,"634":0,"636":0,"637":0,"647":0,"649":0,"650":0,"652":0,"653":0,"667":0,"668":0,"670":0,"671":0,"674":0,"676":0,"677":0,"678":0,"679":0,"681":0,"682":0,"684":0,"685":0,"688":0,"691":0,"693":0,"694":0,"698":0,"700":0,"702":0,"704":0,"707":0,"710":0,"714":0,"717":0,"719":0,"721":0,"732":0,"734":0,"745":0,"747":0,"758":0,"759":0,"761":0,"762":0,"765":0,"779":0,"780":0,"781":0,"783":0,"784":0,"787":0,"792":0,"794":0,"795":0,"798":0,"799":0,"801":0,"802":0,"805":0,"807":0,"808":0,"811":0,"812":0,"813":0,"816":0,"817":0,"819":0,"820":0,"822":0,"823":0,"827":0,"829":0,"830":0,"831":0,"836":0,"837":0,"840":0,"843":0,"844":0,"849":0,"853":0};
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"].functions = {"isTreeNode:34":0,"isTreeView:38":0,"initializer:113":0,"(anonymous 2):132":0,"destructor:129":0,"getNodeById:144":0,"isRegistered:157":0,"(anonymous 3):212":0,"updateReferences:171":0,"(anonymous 4):245":0,"refreshIndex:238":0,"registerNode:256":0,"updateIndex:283":0,"unregisterNode:297":0,"(anonymous 5):318":0,"collapseAll:315":0,"(anonymous 6):331":0,"expandAll:328":0,"(anonymous 7):344":0,"selectAll:341":0,"(anonymous 8):357":0,"unselectAll:354":0,"(anonymous 9):373":0,"eachChildren:369":0,"eachParent:386":0,"bubbleEvent:407":0,"createNode:441":0,"appendChild:457":0,"_appendChild:472":0,"item:508":0,"indexOf:522":0,"hasChildNodes:534":0,"(anonymous 10):555":0,"getChildren:547":0,"getChildrenLength:563":0,"getEventOutputMap:576":0,"removeChild:593":0,"_removeChild:606":0,"(anonymous 11):649":0,"empty:646":0,"(anonymous 12):693":0,"insert:666":0,"insertAfter:731":0,"insertBefore:744":0,"getNodeByChild:757":0,"(anonymous 14):830":0,"(anonymous 13):811":0,"_setChildren:778":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"].coveredLines = 237;
_yuitest_coverage["build/aui-tree-data/aui-tree-data.js"].coveredFunctions = 49;
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 1);
YUI.add('aui-tree-data', function (A, NAME) {

/**
 * The TreeData Utility
 *
 * @module aui-tree
 * @submodule aui-tree-data
 */

_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 10);
var L = A.Lang,
	isArray = L.isArray,
	isBoolean = L.isBoolean,
	isObject = L.isObject,
	isUndefined = L.isUndefined,

	BOUNDING_BOX = 'boundingBox',
	CHILDREN = 'children',
	CONTAINER = 'container',
	DOT = '.',
	ID = 'id',
	INDEX = 'index',
	LAZY_LOAD = 'lazyLoad',
	LEAF = 'leaf',
	NEXT_SIBLING = 'nextSibling',
	NODE = 'node',
	OWNER_TREE = 'ownerTree',
	PARENT_NODE = 'parentNode',
	PREV_SIBLING = 'prevSibling',
	PREVIOUS_SIBLING = 'previousSibling',
	TREE = 'tree',
	TREE_NODE = 'tree-node',
	TREE_DATA = 'tree-data',

	isTreeNode = function(v) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "isTreeNode", 34);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 35);
return ( A.instanceOf(v, A.TreeNode) );
	},

	isTreeView = function(v) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "isTreeView", 38);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 39);
return ( A.instanceOf(v, A.TreeView) );
	},

	getCN = A.getClassName,

	CSS_TREE_NODE = getCN(TREE, NODE);

/**
 * A base class for TreeData, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li>Handle the data of the tree</li>
 *    <li>Basic DOM implementation (append/remove/insert)</li>
 *    <li>Indexing management to handle the children nodes</li>
 * </ul>
 *
 * Check the list of <a href="TreeData.html#configattributes">Configuration Attributes</a> available for
 * TreeData.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeData
 * @constructor
 * @extends Base
 */

_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 65);
var TreeData = function () {};

_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 67);
TreeData.ATTRS = {
	/**
	 * Container to nest children nodes. If has cntainer it's not a leaf.
	 *
	 * @attribute container
	 * @default null
	 * @type Node | String
	 */
	container: {
		setter: A.one
	},

	/**
	 * Array of children (i.e. could be a JSON metadata object or a TreeNode instance).
	 *
	 * @attribute children
	 * @default []
	 * @type Array
	 */
	children: {
		value: [],
		validator: isArray,
		setter: '_setChildren'
	},

	/**
	 * Index the nodes.
	 *
	 * @attribute index
	 * @default {}
	 * @type Object
	 */
	index: {
		value: {}
	}
};

_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 104);
A.mix(TreeData.prototype, {
	childrenLength: 0,

	/**
	 * Construction logic executed during TreeData instantiation. Lifecycle.
	 *
	 * @method initializer
	 * @protected
	 */
	initializer: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "initializer", 113);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 114);
var instance = this;

		// binding on initializer, needed before .render() phase
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 117);
instance.publish('move');
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 118);
instance.publish('append', { defaultFn: instance._appendChild });
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 119);
instance.publish('remove', { defaultFn: instance._removeChild });
	},

	/**
	 * Descructor lifecycle implementation for the TreeData class.
	 * Purges events attached to the node (and all child nodes).
	 *
	 * @method destructor
	 * @protected
	 */
	destructor: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "destructor", 129);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 130);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 132);
instance.eachChildren(function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 2)", 132);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 133);
node.destroy();
		}, true);
	},

	/**
	 * Get a TreeNode by id.
	 *
	 * @method getNodeById
	 * @param {String} uid
	 * @return {TreeNode}
	 */
	getNodeById: function(uid) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "getNodeById", 144);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 145);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 147);
return instance.get(INDEX)[uid];
	},

	/**
	 * Whether the TreeNode is registered on this TreeData.
	 *
	 * @method isRegistered
	 * @param {TreeNode} node
	 * @return {boolean}
	 */
	isRegistered: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "isRegistered", 157);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 158);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 160);
return !!(instance.get(INDEX)[ node.get(ID) ]);
	},

	/**
	 * Update the references of the passed TreeNode.
	 *
	 * @method updateReferences
	 * @param {node} TreeNode
	 * @param {parentNode} TreeNode
	 * @param {ownerTree} TreeView
	 */
	updateReferences: function(node, parentNode, ownerTree) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "updateReferences", 171);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 172);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 173);
var oldParent = node.get(PARENT_NODE);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 174);
var oldOwnerTree = node.get(OWNER_TREE);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 175);
var moved = oldParent && (oldParent !== parentNode);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 177);
if (oldParent) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 178);
if (moved) {
				// when moved update the oldParent children
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 180);
var children = oldParent.get(CHILDREN);

				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 182);
A.Array.removeItem(children, node);

				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 184);
oldParent.set(CHILDREN, children);
			}

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 187);
oldParent.unregisterNode(node);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 190);
if (oldOwnerTree) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 191);
oldOwnerTree.unregisterNode(node);
		}

		// update parent reference when registered
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 195);
node.set(PARENT_NODE, parentNode);

		// update the ownerTree of the node
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 198);
node.set(OWNER_TREE, ownerTree);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 200);
if (parentNode) {
			// register the new node on the parentNode index
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 202);
parentNode.registerNode(node);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 205);
if (ownerTree) {
			// register the new node to the ownerTree index
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 207);
ownerTree.registerNode(node);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 210);
if (oldOwnerTree != ownerTree) {
			// when change the OWNER_TREE update the children references also
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 212);
node.eachChildren(function(child) {
				_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 3)", 212);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 213);
instance.updateReferences(child, child.get(PARENT_NODE), ownerTree);
			});
		}

		// trigger move event
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 218);
if (moved) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 219);
var output = instance.getEventOutputMap(node);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 221);
if (!oldParent.get('children').length) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 222);
oldParent.collapse();
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 223);
oldParent.hideHitArea();
			}

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 226);
output.tree.oldParent = oldParent;
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 227);
output.tree.oldOwnerTree = oldOwnerTree;

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 229);
instance.bubbleEvent('move', output);
		}
	},

	/**
	 * Refresh the index (i.e. re-index all nodes).
	 *
	 * @method refreshIndex
	 */
	refreshIndex: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "refreshIndex", 238);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 239);
var instance = this;

		// reset index
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 242);
instance.updateIndex({});

		// get all descendent children - deep
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 245);
instance.eachChildren(function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 4)", 245);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 246);
instance.registerNode(node);
		}, true);
	},

	/**
	 * Register the passed TreeNode on this TreeData.
	 *
	 * @method registerNode
	 * @param {TreeNode} node
	 */
	registerNode: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "registerNode", 256);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 257);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 258);
var uid = node.get(ID);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 259);
var index = instance.get(INDEX);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 261);
if (uid) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 262);
index[uid] = node;
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 265);
if (isTreeView(instance)) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 266);
node.addTarget(instance);

			// when the node is appended to the TreeView set the OWNER_TREE
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 269);
node.set(OWNER_TREE, instance);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 272);
node._inheritOwnerTreeAttrs();

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 274);
instance.updateIndex(index);
	},

	/**
	 * Update the <a href="TreeData.html#config_index">index</a> attribute value.
	 *
	 * @method updateIndex
	 * @param {Object} index
	 */
	updateIndex: function(index) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "updateIndex", 283);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 284);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 286);
if (index) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 287);
instance.set(INDEX, index);
		}
	},

	/**
	 * Unregister the passed TreeNode from this TreeData.
	 *
	 * @method unregisterNode
	 * @param {TreeNode} node
	 */
	unregisterNode: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "unregisterNode", 297);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 298);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 299);
var index = instance.get(INDEX);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 301);
delete index[ node.get(ID) ];

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 303);
if (isTreeView(instance)) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 304);
node.removeTarget(instance);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 307);
instance.updateIndex(index);
	},

	/**
	 * Collapse all children of the TreeData.
	 *
	 * @method collapseAll
	 */
	collapseAll: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "collapseAll", 315);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 316);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 318);
instance.eachChildren(function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 5)", 318);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 319);
node.collapse();
		}, true);
	},

	/**
	 * Expand all children of the TreeData.
	 *
	 * @method expandAll
	 */
	expandAll: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "expandAll", 328);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 329);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 331);
instance.eachChildren(function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 6)", 331);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 332);
node.expand();
		}, true);
	},

	/**
	 * Select all children of the TreeData.
	 *
	 * @method selectAll
	 */
	selectAll: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "selectAll", 341);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 342);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 344);
instance.eachChildren(function(child) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 7)", 344);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 345);
child.select();
		}, true);
	},

	/**
	 * Unselect all children of the TreeData.
	 *
	 * @method selectAll
	 */
	unselectAll: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "unselectAll", 354);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 355);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 357);
instance.eachChildren(function(child) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 8)", 357);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 358);
child.unselect();
		}, true);
	},

	/**
	 * Loop each children and execute the <code>fn</code> callback.
	 *
	 * @method eachChildren
	 * @param {function} fn callback
	 * @param {boolean} fn recursive
	 */
	eachChildren: function(fn, deep) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "eachChildren", 369);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 370);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 371);
var children = instance.getChildren(deep);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 373);
A.Array.each(children, function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 9)", 373);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 374);
if (node) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 375);
fn.apply(instance, arguments);
			}
		});
	},

	/**
	 * Loop each parent node and execute the <code>fn</code> callback.
	 *
	 * @method eachChildren
	 * @param {function} fn callback
	 */
	eachParent: function(fn) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "eachParent", 386);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 387);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 388);
var parentNode = instance.get(PARENT_NODE);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 390);
while (parentNode) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 391);
if (parentNode) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 392);
fn.call(instance, parentNode);
			}
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 394);
parentNode = parentNode.get(PARENT_NODE);
		}
	},

	/**
	 * Bubble event to all parent nodes.
	 *
	 * @method bubbleEvent
	 * @param {String} eventType
	 * @param {Array} args
	 * @param {boolean} cancelBubbling
	 * @param {boolean} stopActionPropagation
	 */
	bubbleEvent: function(eventType, args, cancelBubbling, stopActionPropagation) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "bubbleEvent", 407);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 408);
var instance = this;

		// event.stopActionPropagation === undefined, invoke the event native action
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 411);
instance.fire(eventType, args);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 413);
if (!cancelBubbling) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 414);
var parentNode = instance.get(PARENT_NODE);

			// Avoid execution of the native action (private methods) while propagate
			// for example: private _appendChild() is invoked only on the first level of the bubbling
			// the intention is only invoke the user callback on parent nodes.
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 419);
args = args || {};

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 421);
if (isUndefined(stopActionPropagation)) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 422);
stopActionPropagation = true;
			}

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 425);
args.stopActionPropagation = stopActionPropagation;

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 427);
while(parentNode) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 428);
parentNode.fire(eventType, args);
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 429);
parentNode = parentNode.get(PARENT_NODE);
			}
		}
	},

	/**
	 * Create a TreeNode instance.
	 *
	 * @method createNode
	 * @param {Object} options
	 * @return {TreeNode}
	 */
	createNode: function(options) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "createNode", 441);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 442);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 443);
var classType = A.TreeNode.nodeTypes[ isObject(options) ? options.type : options ] || A.TreeNode;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 445);
return new classType(
			isObject(options) ? options : {}
		);
	},

	/**
	 * Append a child node to the TreeData.
	 *
	 * @method appendChild
	 * @param {TreeNode} node
	 * @param {boolean} cancelBubbling
	 */
	appendChild: function(node, cancelBubbling) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "appendChild", 457);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 458);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 459);
var output = instance.getEventOutputMap(node);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 461);
instance.bubbleEvent('append', output, cancelBubbling);
	},

	/**
	 * Append a child node to the TreeData.
	 *
	 * @method _appendChild
	 * @param {TreeNode} node
	 * @param {boolean} cancelBubbling
	 * @protected
	 */
	_appendChild: function(event) {
		// stopActionPropagation while bubbling
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "_appendChild", 472);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 474);
if (event.stopActionPropagation) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 475);
return false;
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 478);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 479);
var node = event.tree.node;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 480);
var ownerTree = instance.get(OWNER_TREE);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 481);
var children = instance.get(CHILDREN);

		// updateReferences first
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 484);
instance.updateReferences(node, instance, ownerTree);
		// and then set the children, to have the appendChild propagation
		// the PARENT_NODE references should be updated
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 487);
var length = children.push(node);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 488);
instance.set(CHILDREN, children);

		// updating prev/nextSibling attributes
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 491);
var prevIndex = length - 2;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 492);
var prevSibling = instance.item(prevIndex);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 494);
node._nextSibling = null;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 495);
node._prevSibling = prevSibling;

		// render node
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 498);
node.render(instance.get(CONTAINER));
	},

	/**
	 * Get a TreeNode children by index.
	 *
	 * @method item
	 * @param {Number} index
	 * @return {TreeNode}
	 */
	item: function(index) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "item", 508);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 509);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 511);
return instance.get(CHILDREN)[index];
	},

	/**
	 * Index of the passed TreeNode on the <a
     * href="TreeData.html#config_children">children</a> attribute.
	 *
	 * @method indexOf
	 * @param {TreeNode} node
	 * @return {Number}
	 */
	indexOf: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "indexOf", 522);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 523);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 525);
return A.Array.indexOf( instance.get(CHILDREN), node );
	},

	/**
	 * Whether the TreeData contains children or not.
	 *
	 * @method hasChildNodes
	 * @return {boolean}
	 */
	hasChildNodes: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "hasChildNodes", 534);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 535);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 537);
return (instance.getChildrenLength() > 0);
	},

	/**
	 * Get an Array of the children nodes of the current TreeData.
	 *
	 * @method getChildren
	 * @param {boolean} deep
	 * @return {Array}
	 */
	getChildren: function(deep) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "getChildren", 547);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 548);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 549);
var cNodes = [];
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 550);
var children = instance.get(CHILDREN);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 552);
cNodes = cNodes.concat(children);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 554);
if (deep) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 555);
instance.eachChildren(function(child) {
				_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 10)", 555);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 556);
cNodes = cNodes.concat( child.getChildren(deep) );
			});
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 560);
return cNodes;
	},

	getChildrenLength: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "getChildrenLength", 563);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 564);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 566);
return (instance.childrenLength || instance.get(CHILDREN).length);
	},

	/**
	 * Get an object containing metadata for the custom events.
	 *
	 * @method getEventOutputMap
	 * @param {TreeData} node
	 * @return {Object}
	 */
	getEventOutputMap: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "getEventOutputMap", 576);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 577);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 579);
return {
			tree: {
				instance: instance,
				node: node || instance
			}
		};
	},

	/**
	 * Remove the passed <code>node</code> from the current TreeData.
	 *
	 * @method removeChild
	 * @param {TreeData} node
	 */
	removeChild: function(node) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "removeChild", 593);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 594);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 595);
var output = instance.getEventOutputMap(node);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 597);
instance.bubbleEvent('remove', output);
	},

	/**
	 * Remove the passed <code>node</code> from the current TreeData.
	 *
	 * @method _removeChild
	 * @param {TreeData} node
	 */
	_removeChild: function(event) {
		// stopActionPropagation while bubbling
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "_removeChild", 606);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 608);
if (event.stopActionPropagation) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 609);
return false;
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 612);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 613);
var node = event.tree.node;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 614);
var ownerTree = instance.get(OWNER_TREE);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 616);
if (instance.isRegistered(node)) {
			// update parent reference when removed
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 618);
node.set(PARENT_NODE, null);

			// unregister the node
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 621);
instance.unregisterNode(node);

			// no parent, no ownerTree
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 624);
node.set(OWNER_TREE, null);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 626);
if (ownerTree) {
				// unregister the removed node from the tree index
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 628);
ownerTree.unregisterNode(node);
			}

			// remove child from the container
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 632);
node.get(BOUNDING_BOX).remove();

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 634);
var children = instance.get(CHILDREN);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 636);
A.Array.removeItem(children, node);
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 637);
instance.set(CHILDREN, children);
		}
	},

	/**
	 * Delete all children of the current TreeData.
	 *
	 * @method empty
	 */
	empty: function() {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "empty", 646);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 647);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 649);
instance.eachChildren(function(node) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 11)", 649);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 650);
var parentNode = node.get(PARENT_NODE);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 652);
if (parentNode) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 653);
parentNode.removeChild(node);
			}
		});
	},

	/**
	 * Insert <code>treeNode</code> before or after the <code>refTreeNode</code>.
	 *
	 * @method insert
	 * @param {TreeNode} treeNode
	 * @param {TreeNode} refTreeNode
	 * @param {TreeNode} where 'before' or 'after'
	 */
	insert: function(treeNode, refTreeNode, where) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "insert", 666);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 667);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 668);
refTreeNode = refTreeNode || this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 670);
if (refTreeNode === treeNode) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 671);
return false; // NOTE: return
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 674);
var refParentTreeNode = refTreeNode.get(PARENT_NODE);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 676);
if (treeNode && refParentTreeNode) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 677);
var nodeBoundingBox = treeNode.get(BOUNDING_BOX);
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 678);
var refBoundingBox = refTreeNode.get(BOUNDING_BOX);
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 679);
var ownerTree = refTreeNode.get(OWNER_TREE);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 681);
if (where === 'before') {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 682);
refBoundingBox.placeBefore(nodeBoundingBox);
			}
			else {_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 684);
if (where === 'after') {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 685);
refBoundingBox.placeAfter(nodeBoundingBox);
			}}

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 688);
var refSiblings = [];
			// using the YUI selector to regenerate the index based on the real dom
			// this avoid misscalculations on the nodes index number
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 691);
var DOMChildren = refParentTreeNode.get(BOUNDING_BOX).all('> ul > li');

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 693);
DOMChildren.each(function(child) {
				_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 12)", 693);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 694);
refSiblings.push( child.getData(TREE_NODE) );
			});

			// updating prev/nextSibling attributes
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 698);
var nextSiblingNode = nodeBoundingBox.get(NEXT_SIBLING);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 700);
treeNode.set(NEXT_SIBLING, nextSiblingNode && nextSiblingNode.getData(TREE_NODE));

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 702);
var prevSiblingNode = nodeBoundingBox.get(PREVIOUS_SIBLING);

			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 704);
treeNode.set(PREV_SIBLING, prevSiblingNode && prevSiblingNode.getData(TREE_NODE));

			// update all references
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 707);
refTreeNode.updateReferences(treeNode, refParentTreeNode, ownerTree);

			// updating refParentTreeNode childTreeNodes
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 710);
refParentTreeNode.set(CHILDREN, refSiblings);
		}

		// render treeNode after it's inserted
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 714);
treeNode.render();

		// invoking insert event
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 717);
var output = refTreeNode.getEventOutputMap(treeNode);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 719);
output.tree.refTreeNode = refTreeNode;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 721);
refTreeNode.bubbleEvent('insert', output);
	},

	/**
	 * Insert <code>treeNode</code> after the <code>refTreeNode</code>.
	 *
	 * @method insertAfter
	 * @param {TreeNode} treeNode
	 * @param {TreeNode} refTreeNode
	 */
	insertAfter: function(treeNode, refTreeNode) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "insertAfter", 731);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 732);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 734);
instance.insert(treeNode, refTreeNode, 'after');
	},

	/**
	 * Insert <code>treeNode</code> before the <code>refTreeNode</code>.
	 *
	 * @method insertBefore
	 * @param {TreeNode} treeNode
	 * @param {TreeNode} refTreeNode
	 */
	insertBefore: function(treeNode, refTreeNode) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "insertBefore", 744);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 745);
var instance = this;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 747);
instance.insert(treeNode, refTreeNode, 'before');
	},

	/**
	 * Get a TreeNode instance by a child DOM Node.
	 *
	 * @method getNodeByChild
	 * @param {Node} child
	 * @return {TreeNode}
	 */
	getNodeByChild: function(child) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "getNodeByChild", 757);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 758);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 759);
var treeNodeEl = child.ancestor(DOT+CSS_TREE_NODE);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 761);
if (treeNodeEl) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 762);
return treeNodeEl.getData(TREE_NODE);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 765);
return null;
	},

	_inheritOwnerTreeAttrs: L.emptyFn,

	/**
	 * Setter for <a href="TreeData.html#config_children">children</a>.
	 *
	 * @method _setChildren
	 * @protected
	 * @param {Array} v
	 * @return {Array}
	 */
	_setChildren: function(v) {
		_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "_setChildren", 778);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 779);
var instance = this;
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 780);
var childNodes = [];
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 781);
var container = instance.get(CONTAINER);

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 783);
if (!container) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 784);
container = instance._createNodeContainer();
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 787);
instance.childrenLength = v.length;

		// before render the node, make sure the PARENT_NODE and OWNER_TREE references are updated
		// this is required on the render phase of the TreeNode (_createNodeContainer)
		// to propagate the events callback (appendChild/expand)
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 792);
var ownerTree = instance;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 794);
if (isTreeNode(instance)) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 795);
ownerTree = instance.get(OWNER_TREE);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 798);
var hasOwnerTree = isTreeView(ownerTree);
		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 799);
var lazyLoad = true;

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 801);
if (hasOwnerTree) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 802);
lazyLoad = ownerTree.get(LAZY_LOAD);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 805);
instance.updateIndex({});

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 807);
if (instance.childrenLength > 0) {
			_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 808);
instance.set(LEAF, false);
		}

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 811);
A.Array.each(v, function(node, index) {
			_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 13)", 811);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 812);
if (node) {
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 813);
if (!isTreeNode(node) && isObject(node)) {
					// cache and remove children to lazy add them later for
					// performance reasons
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 816);
var children = node[CHILDREN];
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 817);
var hasChildren = children && children.length;

					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 819);
node[OWNER_TREE] = ownerTree;
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 820);
node[PARENT_NODE] = instance;

					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 822);
if (hasChildren && lazyLoad) {
						_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 823);
delete node[CHILDREN];
					}

					// creating node from json
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 827);
node = instance.createNode(node);

					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 829);
if (hasChildren && lazyLoad) {
						_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 830);
A.setTimeout(function() {
							_yuitest_coverfunc("build/aui-tree-data/aui-tree-data.js", "(anonymous 14)", 830);
_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 831);
node.set(CHILDREN, children);
						}, 50);
					}
				}

				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 836);
if (hasOwnerTree) {
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 837);
ownerTree.registerNode(node);
				}

				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 840);
node.render(container);

				// avoid duplicated children on the childNodes list
				_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 843);
if (A.Array.indexOf(childNodes, node) === -1) {
					_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 844);
childNodes.push(node);
				}
			}
		});

		_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 849);
return childNodes;
	}
});

_yuitest_coverline("build/aui-tree-data/aui-tree-data.js", 853);
A.TreeData = TreeData;

}, '2.0.0pr1', {"requires": ["aui-base-core", "aui-base-lang", "aui-node-base", "aui-timer", "aui-component"]});
