if (typeof _yuitest_coverage == "undefined"){
    _yuitest_coverage = {};
    _yuitest_coverline = function(src, line){
        var coverage = _yuitest_coverage[src];
        if (!coverage.lines[line]){
            coverage.calledLines++;
        }
        coverage.lines[line]++;
    };
    _yuitest_coverfunc = function(src, name, line){
        var coverage = _yuitest_coverage[src],
            funcId = name + ":" + line;
        if (!coverage.functions[funcId]){
            coverage.calledFunctions++;
        }
        coverage.functions[funcId]++;
    };
}
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"] = {
    lines: {},
    functions: {},
    coveredLines: 0,
    calledLines: 0,
    coveredFunctions: 0,
    calledFunctions: 0,
    path: "build/aui-tree-view/aui-tree-view.js",
    code: []
};
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"].code=["YUI.add('aui-tree-view', function (A, NAME) {","","/**"," * The TreeView Utility"," *"," * @module aui-tree"," * @submodule aui-tree-view"," */","","var L = A.Lang,","	isBoolean = L.isBoolean,","	isString = L.isString,","","	UA = A.UA,","","	BOUNDING_BOX = 'boundingBox',","	CHILDREN = 'children',","	CONTAINER = 'container',","	CONTENT = 'content',","	CONTENT_BOX = 'contentBox',","	DOT = '.',","	FILE = 'file',","	HITAREA = 'hitarea',","	ICON = 'icon',","	INVALID = 'invalid',","	LABEL = 'label',","	LAST_SELECTED = 'lastSelected',","	LEAF = 'leaf',","	NODE = 'node',","	OWNER_TREE = 'ownerTree',","	ROOT = 'root',","	SELECT_ON_TOGGLE = 'selectOnToggle',","	SPACE = ' ',","	TREE = 'tree',","	TREE_NODE = 'tree-node',","	TREE_VIEW = 'tree-view',","	TYPE = 'type',","	VIEW = 'view',","","	concat = function() {","		return Array.prototype.slice.call(arguments).join(SPACE);","	},","","	isTreeNode = function(v) {","		return ( v instanceof A.TreeNode );","	},","","	getCN = A.getClassName,","","	CSS_TREE_HITAREA = getCN(TREE, HITAREA),","	CSS_TREE_ICON = getCN(TREE, ICON),","	CSS_TREE_LABEL = getCN(TREE, LABEL),","	CSS_TREE_NODE_CONTENT = getCN(TREE, NODE, CONTENT),","	CSS_TREE_NODE_CONTENT_INVALID = getCN(TREE, NODE, CONTENT, INVALID),","	CSS_TREE_ROOT_CONTAINER = getCN(TREE, ROOT, CONTAINER),","	CSS_TREE_VIEW_CONTENT = getCN(TREE, VIEW, CONTENT);","","/**"," * <p><img src=\"assets/images/aui-tree-view/main.png\"/></p>"," *"," * A base class for TreeView, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * <pre><code>var tree2 = new A.TreeView({"," *  	width: 200,"," *  	type: 'normal',"," *  	boundingBox: '#tree',"," *  	children: ["," *  		{ label: 'Folder 1', children: [ { label: 'file' }, { label: 'file' }, { label: 'file' } ] },"," *  		{ label: 'Folder 2', expanded: true, children: [ { label: 'file' }, { label: 'file' } ] },"," *  		{ label: 'Folder 3', children: [ { label: 'file' } ] },"," *  		{ label: 'Folder 4', expanded: true, children: [ { label: 'Folder 4-1', expanded: true, children: [ { label: 'file' } ] } ] }"," *  	]"," *  })"," *  .render();"," * </code></pre>"," *"," * Check the list of <a href=\"TreeView.html#configattributes\">Configuration Attributes</a> available for"," * TreeView."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeView"," * @constructor"," * @extends TreeData"," */","var TreeView = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeView.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_VIEW,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the TreeView.","		 *","		 * @property TreeView.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * Type of the treeview (i.e. could be 'file' or 'normal').","			 *","			 * @attribute type","			 * @default 'file'","			 * @type String","			 */","			type: {","				value: FILE,","				validator: isString","			},","","			/**","			 * Last selected TreeNode.","			 *","			 * @attribute lastSelected","			 * @default null","			 * @type TreeNode","			 */","			lastSelected: {","				value: null,","				validator: isTreeNode","			},","","			lazyLoad: {","				validator: isBoolean,","				value: true","			},","","			selectOnToggle: {","				validator: isBoolean,","				value: false","			}","		},","","		AUGMENTS: [A.TreeData, A.TreeViewPaginator, A.TreeViewIO],","","		prototype: {","			CONTENT_TEMPLATE: '<ul></ul>',","","			initializer: function() {","				var instance = this;","				var boundingBox = instance.get(BOUNDING_BOX);","","				boundingBox.setData(TREE_VIEW, instance);","			},","","			/**","			 * Bind the events on the TreeView UI. Lifecycle.","			 *","			 * @method bindUI","			 * @protected","			 */","			bindUI: function() {","				var instance = this;","","				instance._delegateDOM();","			},","","			createNodes: function(nodes) {","				var instance = this;","","				A.Array.each(A.Array(nodes), function(node) {","					var newNode = instance.createNode(node);","","					instance.appendChild(newNode);","				});","","				instance._syncPaginatorUI(nodes);","			},","","			/**","			 * Create the DOM structure for the TreeView. Lifecycle.","			 *","			 * @method renderUI","			 * @protected","			 */","			renderUI: function() {","				var instance = this;","","				instance._renderElements();","			},","","			/**","			 * Create TreeNode from HTML markup.","			 *","			 * @method _createFromHTMLMarkup","			 * @param {Node} container","			 * @protected","			 */","			_createFromHTMLMarkup: function(container) {","				var instance = this;","","				container.all('> li').each(function(node) {","					// use firstChild as label","					var labelEl = node.one('> *').remove();","					var label = labelEl.outerHTML();","					var deepContainer = node.one('> ul');","","					var treeNode = new A.TreeNode({","						boundingBox: node,","						container: deepContainer,","						label: label,","						leaf: !deepContainer,","						ownerTree: instance","					});","","					if (deepContainer) {","						// render node before invoke the recursion","						treeNode.render();","","						// propagating markup recursion","						instance._createFromHTMLMarkup(deepContainer);","					}","					else {","						treeNode.render();","					}","","					// find the parent TreeNode...","					var parentNode = node.get(PARENT_NODE).get(PARENT_NODE);","					var parentInstance = parentNode.getData(TREE_NODE);","","					if (!A.instanceOf(parentInstance, A.TreeNode)) {","						parentInstance = parentNode.getData(TREE_VIEW);","					}","","					// and simulate the appendChild.","					parentInstance.appendChild(treeNode);","				});","			},","","			_createNodeContainer: function() {","				var instance = this;","				var contentBox = instance.get(CONTENT_BOX);","","				instance.set(CONTAINER, contentBox);","","				return contentBox;","			},","","			/**","			 * Render elements.","			 *","			 * @method _renderElements","			 * @protected","			 */","			_renderElements: function() {","				var instance = this;","				var contentBox = instance.get(CONTENT_BOX);","				var children = instance.get(CHILDREN);","				var type = instance.get(TYPE);","				var CSS_TREE_TYPE = getCN(TREE, type);","","				contentBox.addClass(CSS_TREE_VIEW_CONTENT);","","				contentBox.addClass(","					concat(CSS_TREE_TYPE, CSS_TREE_ROOT_CONTAINER)","				);","","				if (!children.length) {","					// if children not specified try to create from markup","					instance._createFromHTMLMarkup(contentBox);","				}","			},","","			/**","			 * Delegate events.","			 *","			 * @method _delegateDOM","			 * @protected","			 */","			_delegateDOM: function() {","				var instance = this;","","				var boundingBox = instance.get(BOUNDING_BOX);","","				// expand/collapse delegations","				boundingBox.delegate('click', A.bind(instance._onClickNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);","				boundingBox.delegate('dblclick', A.bind(instance._onClickHitArea, instance), DOT+CSS_TREE_ICON);","				boundingBox.delegate('dblclick', A.bind(instance._onClickHitArea, instance), DOT+CSS_TREE_LABEL);","				// other delegations","				boundingBox.delegate('mouseenter', A.bind(instance._onMouseEnterNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);","				boundingBox.delegate('mouseleave', A.bind(instance._onMouseLeaveNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);","			},","","			/**","			 * Fires on click the TreeView (i.e. set the select/unselect state).","			 *","			 * @method _onClickNodeEl","			 * @param {EventFacade} event","			 * @protected","			 */","			_onClickNodeEl: function(event) {","				var instance = this;","","				var treeNode = instance.getNodeByChild( event.currentTarget );","","				if (treeNode) {","					if (event.target.test(DOT+CSS_TREE_HITAREA)) {","						treeNode.toggle();","","						if (!instance.get(SELECT_ON_TOGGLE)) {","							return;","						}","					}","","					if (!treeNode.isSelected()) {","						var lastSelected = instance.get(LAST_SELECTED);","","						// select drag node","						if (lastSelected) {","							lastSelected.unselect();","						}","","						treeNode.select();","					}","				}","			},","","			/**","			 * Fires on <code>mouseeneter</code> the TreeNode.","			 *","			 * @method _onMouseEnterNodeEl","			 * @param {EventFacade} event","			 * @protected","			 */","			_onMouseEnterNodeEl: function(event) {","				var instance = this;","				var treeNode = instance.getNodeByChild( event.currentTarget );","","				if (treeNode) {","					treeNode.over();","				}","			},","","			/**","			 * Fires on <code>mouseleave</code> the TreeNode.","			 *","			 * @method _onMouseLeaveNodeEl","			 * @param {EventFacade} event","			 * @protected","			 */","			_onMouseLeaveNodeEl: function(event) {","				var instance = this;","				var treeNode = instance.getNodeByChild( event.currentTarget );","","				if (treeNode) {","					treeNode.out();","				}","			},","","			/**","			 * Fires on <code>click</code> the TreeNode hitarea.","			 *","			 * @method _onClickHitArea","			 * @param {EventFacade} event","			 * @protected","			 */","			_onClickHitArea: function(event) {","				var instance = this;","				var treeNode = instance.getNodeByChild( event.currentTarget );","","				if (treeNode) {","					treeNode.toggle();","				}","			}","		}","	}",");","","A.TreeView = TreeView;","","/*","* TreeViewDD - Drag & Drop","*/","var isNumber = L.isNumber,","","	ABOVE = 'above',","	APPEND = 'append',","	BELOW = 'below',","	BLOCK = 'block',","	BODY = 'body',","	CLEARFIX = 'clearfix',","	DEFAULT = 'default',","	DISPLAY = 'display',","	DOWN = 'down',","	DRAG = 'drag',","	DRAGGABLE = 'draggable',","	DRAG_CURSOR = 'dragCursor',","	DRAG_NODE = 'dragNode',","	EXPANDED = 'expanded',","	HELPER = 'helper',","	INSERT = 'insert',","	OFFSET_HEIGHT = 'offsetHeight',","	PARENT_NODE = 'parentNode',","	SCROLL_DELAY = 'scrollDelay',","	STATE = 'state',","	TREE_DRAG_DROP = 'tree-drag-drop',","	UP = 'up',","","	DDM = A.DD.DDM,","","	CSS_CLEARFIX = getCN(CLEARFIX),","	CSS_ICON = getCN(ICON),","	CSS_TREE_DRAG_HELPER = getCN(TREE, DRAG, HELPER),","	CSS_TREE_DRAG_HELPER_CONTENT = getCN(TREE, DRAG, HELPER, CONTENT),","	CSS_TREE_DRAG_HELPER_LABEL = getCN(TREE, DRAG, HELPER, LABEL),","	CSS_TREE_DRAG_INSERT_ABOVE = getCN(TREE, DRAG, INSERT, ABOVE),","	CSS_TREE_DRAG_INSERT_APPEND = getCN(TREE, DRAG, INSERT, APPEND),","	CSS_TREE_DRAG_INSERT_BELOW = getCN(TREE, DRAG, INSERT, BELOW),","	CSS_TREE_DRAG_STATE_APPEND = getCN(TREE, DRAG, STATE, APPEND),","	CSS_TREE_DRAG_STATE_INSERT_ABOVE = getCN(TREE, DRAG, STATE, INSERT, ABOVE),","	CSS_TREE_DRAG_STATE_INSERT_BELOW = getCN(TREE, DRAG, STATE, INSERT, BELOW),","","	HELPER_TPL = '<div class=\"'+CSS_TREE_DRAG_HELPER+'\">'+","					'<div class=\"'+[CSS_TREE_DRAG_HELPER_CONTENT, CSS_CLEARFIX].join(SPACE)+'\">'+","						'<span class=\"'+CSS_ICON+'\"></span>'+","						'<span class=\"'+CSS_TREE_DRAG_HELPER_LABEL+'\"></span>'+","					'</div>'+","				 '</div>';","","/**"," * A base class for TreeViewDD, providing:"," * <ul>"," *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>"," *    <li>DragDrop support for the TreeNodes</li>"," * </ul>"," *"," * Quick Example:<br/>"," *"," * Check the list of <a href=\"TreeViewDD.html#configattributes\">Configuration Attributes</a> available for"," * TreeViewDD."," *"," * @param config {Object} Object literal specifying widget configuration properties."," *"," * @class TreeViewDD"," * @constructor"," * @extends TreeView"," */","var TreeViewDD = A.Component.create(","	{","		/**","		 * Static property provides a string to identify the class.","		 *","		 * @property TreeViewDD.NAME","		 * @type String","		 * @static","		 */","		NAME: TREE_DRAG_DROP,","","		/**","		 * Static property used to define the default attribute","		 * configuration for the TreeViewDD.","		 *","		 * @property TreeViewDD.ATTRS","		 * @type Object","		 * @static","		 */","		ATTRS: {","			/**","			 * Dragdrop helper element.","			 *","			 * @attribute helper","			 * @default null","			 * @type Node | String","			 */","			helper: {","				value: null","			},","","			/**","			 * Delay of the scroll while dragging the TreeNodes.","			 *","			 * @attribute scrollDelay","			 * @default 100","			 * @type Number","			 */","			scrollDelay: {","				value: 100,","				validator: isNumber","			}","		},","","		EXTENDS: A.TreeView,","","		prototype: {","			/**","			 * Direction of the drag (i.e. could be 'up' or 'down').","			 *","			 * @property direction","			 * @type String","			 * @protected","			 */","			direction: BELOW,","","			/**","			 * Drop action (i.e. could be 'append', 'below' or 'above').","			 *","			 * @attribute dropAction","			 * @default null","			 * @type String","			 */","			dropAction: null,","","			/**","			 * Last Y.","			 *","			 * @attribute lastY","			 * @default 0","			 * @type Number","			 */","			lastY: 0,","","			node: null,","","			/**","			 * Reference for the current drop node.","			 *","			 * @attribute nodeContent","			 * @default null","			 * @type Node","			 */","			nodeContent: null,","","			/**","			 * Descructor lifecycle implementation for the TreeViewDD class.","			 * Purges events attached to the node (and all child nodes).","			 *","			 * @method destructor","			 * @protected","			 */","			destructor: function() {","				var instance = this;","				var helper = instance.get(HELPER);","","				if (helper) {","					helper.remove(true);","				}","","				if (instance.ddDelegate) {","					instance.ddDelegate.destroy();","				}","			},","","			/**","			 * Bind the events on the TreeViewDD UI. Lifecycle.","			 *","			 * @method bindUI","			 * @protected","			 */","			bindUI: function() {","				var instance = this;","","				A.TreeViewDD.superclass.bindUI.apply(this, arguments);","","				instance._bindDragDrop();","			},","","			/**","			 * Create the DOM structure for the TreeViewDD. Lifecycle.","			 *","			 * @method renderUI","			 * @protected","			 */","			renderUI: function() {","				var instance = this;","","				A.TreeViewDD.superclass.renderUI.apply(this, arguments);","","				// creating drag helper and hiding it","				var helper = A.Node.create(HELPER_TPL).hide();","","				// append helper to the body","				A.one(BODY).append(helper);","","				instance.set(HELPER, helper);","","				// set DRAG_CURSOR to the default arrow","				DDM.set(DRAG_CURSOR, DEFAULT);","			},","","			/**","			 * Bind DragDrop events.","			 *","			 * @method _bindDragDrop","			 * @protected","			 */","			_bindDragDrop: function() {","				var instance = this,","					boundingBox = instance.get(BOUNDING_BOX),","					dragInitHandle = null;","","				instance._createDragInitHandler = function() {","					instance.ddDelegate = new A.DD.Delegate(","						{","							bubbleTargets: instance,","							container: boundingBox,","							invalid: DOT+CSS_TREE_NODE_CONTENT_INVALID,","							nodes: DOT+CSS_TREE_NODE_CONTENT,","							target: true","						}","					);","","					var dd = instance.ddDelegate.dd;","","					dd.plug(A.Plugin.DDProxy, {","						moveOnEnd: false,","						positionProxy: false,","						borderStyle: null","					})","					.plug(A.Plugin.DDNodeScroll, {","						scrollDelay: instance.get(SCROLL_DELAY),","						node: boundingBox","					});","","					dd.removeInvalid('a');","","					if (dragInitHandle) {","						dragInitHandle.detach();","					}","","				};","","				// Check for mobile devices and execute _createDragInitHandler before events","				if (!UA.touch) {","					// only create the drag on the init elements if the user mouseover the boundingBox for init performance reasons","					dragInitHandle = boundingBox.on(['focus', 'mousedown', 'mousemove'], instance._createDragInitHandler);","				}","				else {","					instance._createDragInitHandler();","				}","","				// drag & drop listeners","				instance.on('drag:align', instance._onDragAlign);","				instance.on('drag:start', instance._onDragStart);","				instance.on('drop:exit', instance._onDropExit);","				instance.after('drop:hit', instance._afterDropHit);","				instance.on('drop:hit', instance._onDropHit);","				instance.on('drop:over', instance._onDropOver);","			},","","			/**","			 * Set the append CSS state on the passed <code>nodeContent</code>.","			 *","			 * @method _appendState","			 * @param {Node} nodeContent","			 * @protected","			 */","			_appendState: function(nodeContent) {","				var instance = this;","","				instance.dropAction = APPEND;","","				instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_APPEND);","","				nodeContent.addClass(CSS_TREE_DRAG_INSERT_APPEND);","			},","","			/**","			 * Set the going down CSS state on the passed <code>nodeContent</code>.","			 *","			 * @method _goingDownState","			 * @param {Node} nodeContent","			 * @protected","			 */","			_goingDownState: function(nodeContent) {","				var instance = this;","","				instance.dropAction = BELOW;","","				instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_INSERT_BELOW);","","				nodeContent.addClass(CSS_TREE_DRAG_INSERT_BELOW);","			},","","			/**","			 * Set the going up CSS state on the passed <code>nodeContent</code>.","			 *","			 * @method _goingUpState","			 * @param {Node} nodeContent","			 * @protected","			 */","			_goingUpState: function(nodeContent) {","				var instance = this;","","				instance.dropAction = ABOVE;","","				instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_INSERT_ABOVE);","","				nodeContent.addClass(CSS_TREE_DRAG_INSERT_ABOVE);","			},","","			/**","			 * Set the reset CSS state on the passed <code>nodeContent</code>.","			 *","			 * @method _resetState","			 * @param {Node} nodeContent","			 * @protected","			 */","			_resetState: function(nodeContent) {","				var instance = this;","				var helper = instance.get(HELPER);","","				helper.removeClass(CSS_TREE_DRAG_STATE_APPEND);","				helper.removeClass(CSS_TREE_DRAG_STATE_INSERT_ABOVE);","				helper.removeClass(CSS_TREE_DRAG_STATE_INSERT_BELOW);","","				if (nodeContent) {","					nodeContent.removeClass(CSS_TREE_DRAG_INSERT_ABOVE);","					nodeContent.removeClass(CSS_TREE_DRAG_INSERT_APPEND);","					nodeContent.removeClass(CSS_TREE_DRAG_INSERT_BELOW);","				}","			},","","			/**","			 * Update the CSS node state (i.e. going down, going up, append etc).","			 *","			 * @method _updateNodeState","			 * @param {EventFacade} event","			 * @protected","			 */","			_updateNodeState: function(event) {","				var instance = this;","				var drag = event.drag;","				var drop = event.drop;","				var nodeContent = drop.get(NODE);","				var dropNode = nodeContent.get(PARENT_NODE);","				var dragNode = drag.get(NODE).get(PARENT_NODE);","				var dropTreeNode = dropNode.getData(TREE_NODE);","","				// reset the classNames from the last nodeContent","				instance._resetState(instance.nodeContent);","","				// cannot drop the dragged element into any of its children","				// using DOM contains method for performance reason","				if ( !dragNode.contains(dropNode) ) {","					// nArea splits the height in 3 areas top/center/bottom","					// these areas are responsible for defining the state when the mouse is over any of them","					var nArea = nodeContent.get(OFFSET_HEIGHT) / 3;","					var yTop = nodeContent.getY();","					var yCenter = yTop + nArea;","					var yBottom = yTop + nArea*2;","					var mouseY = drag.mouseXY[1];","","					// UP: mouse on the top area of the node","					if ((mouseY > yTop) && (mouseY < yCenter)) {","						instance._goingUpState(nodeContent);","					}","					// DOWN: mouse on the bottom area of the node","					else if (mouseY > yBottom) {","						instance._goingDownState(nodeContent);","					}","					// APPEND: mouse on the center area of the node","					else if ((mouseY > yCenter) && (mouseY < yBottom)) {","						// if it's a folder set the state to append","						if (dropTreeNode && !dropTreeNode.isLeaf()) {","							instance._appendState(nodeContent);","						}","						// if it's a leaf we need to set the ABOVE or BELOW state instead of append","						else {","							if (instance.direction === UP) {","								instance._goingUpState(nodeContent);","							}","							else {","								instance._goingDownState(nodeContent);","							}","						}","					}","				}","","				instance.nodeContent = nodeContent;","			},","","			/**","			 * Fires after the drop hit event.","			 *","			 * @method _afterDropHit","			 * @param {EventFacade} event drop hit event facade","			 * @protected","			 */","			_afterDropHit: function(event) {","				var instance = this;","				var dropAction = instance.dropAction;","				var dragNode = event.drag.get(NODE).get(PARENT_NODE);","				var dropNode = event.drop.get(NODE).get(PARENT_NODE);","","				var dropTreeNode = dropNode.getData(TREE_NODE);","				var dragTreeNode = dragNode.getData(TREE_NODE);","","				var output = instance.getEventOutputMap(instance);","","				output.tree.dropNode = dropTreeNode;","				output.tree.dragNode = dragTreeNode;","","				if (dropAction === ABOVE) {","					dropTreeNode.insertBefore(dragTreeNode);","","					instance.bubbleEvent('dropInsert', output);","				}","				else if (dropAction === BELOW) {","					dropTreeNode.insertAfter(dragTreeNode);","","					instance.bubbleEvent('dropInsert', output);","				}","				else if (dropAction === APPEND) {","					if (dropTreeNode && !dropTreeNode.isLeaf()) {","						dropTreeNode.appendChild(dragTreeNode);","","						if (!dropTreeNode.get(EXPANDED)) {","							// expand node when drop a child on it","							dropTreeNode.expand();","						}","","						instance.bubbleEvent('dropAppend', output);","					}","				}","","				instance._resetState(instance.nodeContent);","","				// bubbling drop event","				instance.bubbleEvent('drop', output);","","				instance.dropAction = null;","			},","","			/**","			 * Fires on drag align event.","			 *","			 * @method _onDragAlign","			 * @param {EventFacade} event append event facade","			 * @protected","			 */","			_onDragAlign: function(event) {","				var instance = this;","				var lastY = instance.lastY;","				var y = event.target.lastXY[1];","","				// if the y change","				if (y !== lastY) {","					// set the drag direction","					instance.direction = (y < lastY) ? UP : DOWN;","				}","","				instance.lastY = y;","			},","","			/**","			 * Fires on drag start event.","			 *","			 * @method _onDragStart","			 * @param {EventFacade} event append event facade","			 * @protected","			 */","			_onDragStart: function(event) {","				var instance = this;","				var drag = event.target;","				var dragNode = drag.get(NODE).get(PARENT_NODE);","				var dragTreeNode = dragNode.getData(TREE_NODE);","				var lastSelected = instance.get(LAST_SELECTED);","","				// select drag node","				if (lastSelected) {","					lastSelected.unselect();","				}","","				dragTreeNode.select();","","				// initialize drag helper","				var helper = instance.get(HELPER);","				var helperLabel = helper.one(DOT+CSS_TREE_DRAG_HELPER_LABEL);","","				// show helper, we need display block here, yui dd hide it with display none","				helper.setStyle(DISPLAY, BLOCK).show();","","				// set the CSS_TREE_DRAG_HELPER_LABEL html with the label of the dragged node","				helperLabel.html( dragTreeNode.get(LABEL) );","","				// update the DRAG_NODE with the new helper","				drag.set(DRAG_NODE, helper);","			},","","			/**","			 * Fires on drop over event.","			 *","			 * @method _onDropOver","			 * @param {EventFacade} event append event facade","			 * @protected","			 */","			_onDropOver: function(event) {","				var instance = this;","","				instance._updateNodeState(event);","			},","","			/**","			 * Fires on drop hit event.","			 *","			 * @method _onDropHit","			 * @param {EventFacade} event append event facade","			 * @protected","			 */","			_onDropHit: function(event) {","				var dropNode = event.drop.get(NODE).get(PARENT_NODE);","				var dropTreeNode = dropNode.getData(TREE_NODE);","","				if (!isTreeNode(dropTreeNode)) {","					event.preventDefault();","				}","			},","","			/**","			 * Fires on drop exit event.","			 *","			 * @method _onDropExit","			 * @param {EventFacade} event append event facade","			 * @protected","			 */","			_onDropExit: function() {","				var instance = this;","","				instance.dropAction = null;","","				instance._resetState(instance.nodeContent);","			}","		}","	}",");","","A.TreeViewDD = TreeViewDD;","","}, '2.0.0pr1', {","    \"requires\": [","        \"dd-delegate\",","        \"dd-proxy\",","        \"aui-tree-node\",","        \"aui-tree-paginator\",","        \"aui-tree-io\"","    ],","    \"skinnable\": true","});"];
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"].lines = {"1":0,"10":0,"41":0,"45":0,"91":0,"152":0,"153":0,"155":0,"165":0,"167":0,"171":0,"173":0,"174":0,"176":0,"179":0,"189":0,"191":0,"202":0,"204":0,"206":0,"207":0,"208":0,"210":0,"218":0,"220":0,"223":0,"226":0,"230":0,"231":0,"233":0,"234":0,"238":0,"243":0,"244":0,"246":0,"248":0,"258":0,"259":0,"260":0,"261":0,"262":0,"264":0,"266":0,"270":0,"272":0,"283":0,"285":0,"288":0,"289":0,"290":0,"292":0,"293":0,"304":0,"306":0,"308":0,"309":0,"310":0,"312":0,"313":0,"317":0,"318":0,"321":0,"322":0,"325":0,"338":0,"339":0,"341":0,"342":0,"354":0,"355":0,"357":0,"358":0,"370":0,"371":0,"373":0,"374":0,"381":0,"386":0,"450":0,"543":0,"544":0,"546":0,"547":0,"550":0,"551":0,"562":0,"564":0,"566":0,"576":0,"578":0,"581":0,"584":0,"586":0,"589":0,"599":0,"603":0,"604":0,"614":0,"616":0,"626":0,"628":0,"629":0,"635":0,"637":0,"640":0,"644":0,"645":0,"646":0,"647":0,"648":0,"649":0,"660":0,"662":0,"664":0,"666":0,"677":0,"679":0,"681":0,"683":0,"694":0,"696":0,"698":0,"700":0,"711":0,"712":0,"714":0,"715":0,"716":0,"718":0,"719":0,"720":0,"721":0,"733":0,"734":0,"735":0,"736":0,"737":0,"738":0,"739":0,"742":0,"746":0,"749":0,"750":0,"751":0,"752":0,"753":0,"756":0,"757":0,"760":0,"761":0,"764":0,"766":0,"767":0,"771":0,"772":0,"775":0,"781":0,"792":0,"793":0,"794":0,"795":0,"797":0,"798":0,"800":0,"802":0,"803":0,"805":0,"806":0,"808":0,"810":0,"811":0,"813":0,"815":0,"816":0,"817":0,"819":0,"821":0,"824":0,"828":0,"831":0,"833":0,"844":0,"845":0,"846":0,"849":0,"851":0,"854":0,"865":0,"866":0,"867":0,"868":0,"869":0,"872":0,"873":0,"876":0,"879":0,"880":0,"883":0,"886":0,"889":0,"900":0,"902":0,"913":0,"914":0,"916":0,"917":0,"929":0,"931":0,"933":0,"939":0};
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"].functions = {"concat:40":0,"isTreeNode:44":0,"initializer:151":0,"bindUI:164":0,"(anonymous 2):173":0,"createNodes:170":0,"renderUI:188":0,"(anonymous 3):204":0,"_createFromHTMLMarkup:201":0,"_createNodeContainer:242":0,"_renderElements:257":0,"_delegateDOM:282":0,"_onClickNodeEl:303":0,"_onMouseEnterNodeEl:337":0,"_onMouseLeaveNodeEl:353":0,"_onClickHitArea:369":0,"destructor:542":0,"bindUI:561":0,"renderUI:575":0,"_createDragInitHandler:603":0,"_bindDragDrop:598":0,"_appendState:659":0,"_goingDownState:676":0,"_goingUpState:693":0,"_resetState:710":0,"_updateNodeState:732":0,"_afterDropHit:791":0,"_onDragAlign:843":0,"_onDragStart:864":0,"_onDropOver:899":0,"_onDropHit:912":0,"_onDropExit:928":0,"(anonymous 1):1":0};
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"].coveredLines = 210;
_yuitest_coverage["build/aui-tree-view/aui-tree-view.js"].coveredFunctions = 33;
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 1);
YUI.add('aui-tree-view', function (A, NAME) {

/**
 * The TreeView Utility
 *
 * @module aui-tree
 * @submodule aui-tree-view
 */

_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "(anonymous 1)", 1);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 10);
var L = A.Lang,
	isBoolean = L.isBoolean,
	isString = L.isString,

	UA = A.UA,

	BOUNDING_BOX = 'boundingBox',
	CHILDREN = 'children',
	CONTAINER = 'container',
	CONTENT = 'content',
	CONTENT_BOX = 'contentBox',
	DOT = '.',
	FILE = 'file',
	HITAREA = 'hitarea',
	ICON = 'icon',
	INVALID = 'invalid',
	LABEL = 'label',
	LAST_SELECTED = 'lastSelected',
	LEAF = 'leaf',
	NODE = 'node',
	OWNER_TREE = 'ownerTree',
	ROOT = 'root',
	SELECT_ON_TOGGLE = 'selectOnToggle',
	SPACE = ' ',
	TREE = 'tree',
	TREE_NODE = 'tree-node',
	TREE_VIEW = 'tree-view',
	TYPE = 'type',
	VIEW = 'view',

	concat = function() {
		_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "concat", 40);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 41);
return Array.prototype.slice.call(arguments).join(SPACE);
	},

	isTreeNode = function(v) {
		_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "isTreeNode", 44);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 45);
return ( v instanceof A.TreeNode );
	},

	getCN = A.getClassName,

	CSS_TREE_HITAREA = getCN(TREE, HITAREA),
	CSS_TREE_ICON = getCN(TREE, ICON),
	CSS_TREE_LABEL = getCN(TREE, LABEL),
	CSS_TREE_NODE_CONTENT = getCN(TREE, NODE, CONTENT),
	CSS_TREE_NODE_CONTENT_INVALID = getCN(TREE, NODE, CONTENT, INVALID),
	CSS_TREE_ROOT_CONTAINER = getCN(TREE, ROOT, CONTAINER),
	CSS_TREE_VIEW_CONTENT = getCN(TREE, VIEW, CONTENT);

/**
 * <p><img src="assets/images/aui-tree-view/main.png"/></p>
 *
 * A base class for TreeView, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * <pre><code>var tree2 = new A.TreeView({
 *  	width: 200,
 *  	type: 'normal',
 *  	boundingBox: '#tree',
 *  	children: [
 *  		{ label: 'Folder 1', children: [ { label: 'file' }, { label: 'file' }, { label: 'file' } ] },
 *  		{ label: 'Folder 2', expanded: true, children: [ { label: 'file' }, { label: 'file' } ] },
 *  		{ label: 'Folder 3', children: [ { label: 'file' } ] },
 *  		{ label: 'Folder 4', expanded: true, children: [ { label: 'Folder 4-1', expanded: true, children: [ { label: 'file' } ] } ] }
 *  	]
 *  })
 *  .render();
 * </code></pre>
 *
 * Check the list of <a href="TreeView.html#configattributes">Configuration Attributes</a> available for
 * TreeView.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeView
 * @constructor
 * @extends TreeData
 */
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 91);
var TreeView = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeView.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_VIEW,

		/**
		 * Static property used to define the default attribute
		 * configuration for the TreeView.
		 *
		 * @property TreeView.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * Type of the treeview (i.e. could be 'file' or 'normal').
			 *
			 * @attribute type
			 * @default 'file'
			 * @type String
			 */
			type: {
				value: FILE,
				validator: isString
			},

			/**
			 * Last selected TreeNode.
			 *
			 * @attribute lastSelected
			 * @default null
			 * @type TreeNode
			 */
			lastSelected: {
				value: null,
				validator: isTreeNode
			},

			lazyLoad: {
				validator: isBoolean,
				value: true
			},

			selectOnToggle: {
				validator: isBoolean,
				value: false
			}
		},

		AUGMENTS: [A.TreeData, A.TreeViewPaginator, A.TreeViewIO],

		prototype: {
			CONTENT_TEMPLATE: '<ul></ul>',

			initializer: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "initializer", 151);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 152);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 153);
var boundingBox = instance.get(BOUNDING_BOX);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 155);
boundingBox.setData(TREE_VIEW, instance);
			},

			/**
			 * Bind the events on the TreeView UI. Lifecycle.
			 *
			 * @method bindUI
			 * @protected
			 */
			bindUI: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "bindUI", 164);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 165);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 167);
instance._delegateDOM();
			},

			createNodes: function(nodes) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "createNodes", 170);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 171);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 173);
A.Array.each(A.Array(nodes), function(node) {
					_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "(anonymous 2)", 173);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 174);
var newNode = instance.createNode(node);

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 176);
instance.appendChild(newNode);
				});

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 179);
instance._syncPaginatorUI(nodes);
			},

			/**
			 * Create the DOM structure for the TreeView. Lifecycle.
			 *
			 * @method renderUI
			 * @protected
			 */
			renderUI: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "renderUI", 188);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 189);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 191);
instance._renderElements();
			},

			/**
			 * Create TreeNode from HTML markup.
			 *
			 * @method _createFromHTMLMarkup
			 * @param {Node} container
			 * @protected
			 */
			_createFromHTMLMarkup: function(container) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_createFromHTMLMarkup", 201);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 202);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 204);
container.all('> li').each(function(node) {
					// use firstChild as label
					_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "(anonymous 3)", 204);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 206);
var labelEl = node.one('> *').remove();
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 207);
var label = labelEl.outerHTML();
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 208);
var deepContainer = node.one('> ul');

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 210);
var treeNode = new A.TreeNode({
						boundingBox: node,
						container: deepContainer,
						label: label,
						leaf: !deepContainer,
						ownerTree: instance
					});

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 218);
if (deepContainer) {
						// render node before invoke the recursion
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 220);
treeNode.render();

						// propagating markup recursion
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 223);
instance._createFromHTMLMarkup(deepContainer);
					}
					else {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 226);
treeNode.render();
					}

					// find the parent TreeNode...
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 230);
var parentNode = node.get(PARENT_NODE).get(PARENT_NODE);
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 231);
var parentInstance = parentNode.getData(TREE_NODE);

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 233);
if (!A.instanceOf(parentInstance, A.TreeNode)) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 234);
parentInstance = parentNode.getData(TREE_VIEW);
					}

					// and simulate the appendChild.
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 238);
parentInstance.appendChild(treeNode);
				});
			},

			_createNodeContainer: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_createNodeContainer", 242);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 243);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 244);
var contentBox = instance.get(CONTENT_BOX);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 246);
instance.set(CONTAINER, contentBox);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 248);
return contentBox;
			},

			/**
			 * Render elements.
			 *
			 * @method _renderElements
			 * @protected
			 */
			_renderElements: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_renderElements", 257);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 258);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 259);
var contentBox = instance.get(CONTENT_BOX);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 260);
var children = instance.get(CHILDREN);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 261);
var type = instance.get(TYPE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 262);
var CSS_TREE_TYPE = getCN(TREE, type);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 264);
contentBox.addClass(CSS_TREE_VIEW_CONTENT);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 266);
contentBox.addClass(
					concat(CSS_TREE_TYPE, CSS_TREE_ROOT_CONTAINER)
				);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 270);
if (!children.length) {
					// if children not specified try to create from markup
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 272);
instance._createFromHTMLMarkup(contentBox);
				}
			},

			/**
			 * Delegate events.
			 *
			 * @method _delegateDOM
			 * @protected
			 */
			_delegateDOM: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_delegateDOM", 282);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 283);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 285);
var boundingBox = instance.get(BOUNDING_BOX);

				// expand/collapse delegations
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 288);
boundingBox.delegate('click', A.bind(instance._onClickNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 289);
boundingBox.delegate('dblclick', A.bind(instance._onClickHitArea, instance), DOT+CSS_TREE_ICON);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 290);
boundingBox.delegate('dblclick', A.bind(instance._onClickHitArea, instance), DOT+CSS_TREE_LABEL);
				// other delegations
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 292);
boundingBox.delegate('mouseenter', A.bind(instance._onMouseEnterNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 293);
boundingBox.delegate('mouseleave', A.bind(instance._onMouseLeaveNodeEl, instance), DOT+CSS_TREE_NODE_CONTENT);
			},

			/**
			 * Fires on click the TreeView (i.e. set the select/unselect state).
			 *
			 * @method _onClickNodeEl
			 * @param {EventFacade} event
			 * @protected
			 */
			_onClickNodeEl: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onClickNodeEl", 303);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 304);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 306);
var treeNode = instance.getNodeByChild( event.currentTarget );

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 308);
if (treeNode) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 309);
if (event.target.test(DOT+CSS_TREE_HITAREA)) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 310);
treeNode.toggle();

						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 312);
if (!instance.get(SELECT_ON_TOGGLE)) {
							_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 313);
return;
						}
					}

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 317);
if (!treeNode.isSelected()) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 318);
var lastSelected = instance.get(LAST_SELECTED);

						// select drag node
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 321);
if (lastSelected) {
							_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 322);
lastSelected.unselect();
						}

						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 325);
treeNode.select();
					}
				}
			},

			/**
			 * Fires on <code>mouseeneter</code> the TreeNode.
			 *
			 * @method _onMouseEnterNodeEl
			 * @param {EventFacade} event
			 * @protected
			 */
			_onMouseEnterNodeEl: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onMouseEnterNodeEl", 337);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 338);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 339);
var treeNode = instance.getNodeByChild( event.currentTarget );

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 341);
if (treeNode) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 342);
treeNode.over();
				}
			},

			/**
			 * Fires on <code>mouseleave</code> the TreeNode.
			 *
			 * @method _onMouseLeaveNodeEl
			 * @param {EventFacade} event
			 * @protected
			 */
			_onMouseLeaveNodeEl: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onMouseLeaveNodeEl", 353);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 354);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 355);
var treeNode = instance.getNodeByChild( event.currentTarget );

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 357);
if (treeNode) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 358);
treeNode.out();
				}
			},

			/**
			 * Fires on <code>click</code> the TreeNode hitarea.
			 *
			 * @method _onClickHitArea
			 * @param {EventFacade} event
			 * @protected
			 */
			_onClickHitArea: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onClickHitArea", 369);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 370);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 371);
var treeNode = instance.getNodeByChild( event.currentTarget );

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 373);
if (treeNode) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 374);
treeNode.toggle();
				}
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 381);
A.TreeView = TreeView;

/*
* TreeViewDD - Drag & Drop
*/
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 386);
var isNumber = L.isNumber,

	ABOVE = 'above',
	APPEND = 'append',
	BELOW = 'below',
	BLOCK = 'block',
	BODY = 'body',
	CLEARFIX = 'clearfix',
	DEFAULT = 'default',
	DISPLAY = 'display',
	DOWN = 'down',
	DRAG = 'drag',
	DRAGGABLE = 'draggable',
	DRAG_CURSOR = 'dragCursor',
	DRAG_NODE = 'dragNode',
	EXPANDED = 'expanded',
	HELPER = 'helper',
	INSERT = 'insert',
	OFFSET_HEIGHT = 'offsetHeight',
	PARENT_NODE = 'parentNode',
	SCROLL_DELAY = 'scrollDelay',
	STATE = 'state',
	TREE_DRAG_DROP = 'tree-drag-drop',
	UP = 'up',

	DDM = A.DD.DDM,

	CSS_CLEARFIX = getCN(CLEARFIX),
	CSS_ICON = getCN(ICON),
	CSS_TREE_DRAG_HELPER = getCN(TREE, DRAG, HELPER),
	CSS_TREE_DRAG_HELPER_CONTENT = getCN(TREE, DRAG, HELPER, CONTENT),
	CSS_TREE_DRAG_HELPER_LABEL = getCN(TREE, DRAG, HELPER, LABEL),
	CSS_TREE_DRAG_INSERT_ABOVE = getCN(TREE, DRAG, INSERT, ABOVE),
	CSS_TREE_DRAG_INSERT_APPEND = getCN(TREE, DRAG, INSERT, APPEND),
	CSS_TREE_DRAG_INSERT_BELOW = getCN(TREE, DRAG, INSERT, BELOW),
	CSS_TREE_DRAG_STATE_APPEND = getCN(TREE, DRAG, STATE, APPEND),
	CSS_TREE_DRAG_STATE_INSERT_ABOVE = getCN(TREE, DRAG, STATE, INSERT, ABOVE),
	CSS_TREE_DRAG_STATE_INSERT_BELOW = getCN(TREE, DRAG, STATE, INSERT, BELOW),

	HELPER_TPL = '<div class="'+CSS_TREE_DRAG_HELPER+'">'+
					'<div class="'+[CSS_TREE_DRAG_HELPER_CONTENT, CSS_CLEARFIX].join(SPACE)+'">'+
						'<span class="'+CSS_ICON+'"></span>'+
						'<span class="'+CSS_TREE_DRAG_HELPER_LABEL+'"></span>'+
					'</div>'+
				 '</div>';

/**
 * A base class for TreeViewDD, providing:
 * <ul>
 *    <li>Widget Lifecycle (initializer, renderUI, bindUI, syncUI, destructor)</li>
 *    <li>DragDrop support for the TreeNodes</li>
 * </ul>
 *
 * Quick Example:<br/>
 *
 * Check the list of <a href="TreeViewDD.html#configattributes">Configuration Attributes</a> available for
 * TreeViewDD.
 *
 * @param config {Object} Object literal specifying widget configuration properties.
 *
 * @class TreeViewDD
 * @constructor
 * @extends TreeView
 */
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 450);
var TreeViewDD = A.Component.create(
	{
		/**
		 * Static property provides a string to identify the class.
		 *
		 * @property TreeViewDD.NAME
		 * @type String
		 * @static
		 */
		NAME: TREE_DRAG_DROP,

		/**
		 * Static property used to define the default attribute
		 * configuration for the TreeViewDD.
		 *
		 * @property TreeViewDD.ATTRS
		 * @type Object
		 * @static
		 */
		ATTRS: {
			/**
			 * Dragdrop helper element.
			 *
			 * @attribute helper
			 * @default null
			 * @type Node | String
			 */
			helper: {
				value: null
			},

			/**
			 * Delay of the scroll while dragging the TreeNodes.
			 *
			 * @attribute scrollDelay
			 * @default 100
			 * @type Number
			 */
			scrollDelay: {
				value: 100,
				validator: isNumber
			}
		},

		EXTENDS: A.TreeView,

		prototype: {
			/**
			 * Direction of the drag (i.e. could be 'up' or 'down').
			 *
			 * @property direction
			 * @type String
			 * @protected
			 */
			direction: BELOW,

			/**
			 * Drop action (i.e. could be 'append', 'below' or 'above').
			 *
			 * @attribute dropAction
			 * @default null
			 * @type String
			 */
			dropAction: null,

			/**
			 * Last Y.
			 *
			 * @attribute lastY
			 * @default 0
			 * @type Number
			 */
			lastY: 0,

			node: null,

			/**
			 * Reference for the current drop node.
			 *
			 * @attribute nodeContent
			 * @default null
			 * @type Node
			 */
			nodeContent: null,

			/**
			 * Descructor lifecycle implementation for the TreeViewDD class.
			 * Purges events attached to the node (and all child nodes).
			 *
			 * @method destructor
			 * @protected
			 */
			destructor: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "destructor", 542);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 543);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 544);
var helper = instance.get(HELPER);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 546);
if (helper) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 547);
helper.remove(true);
				}

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 550);
if (instance.ddDelegate) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 551);
instance.ddDelegate.destroy();
				}
			},

			/**
			 * Bind the events on the TreeViewDD UI. Lifecycle.
			 *
			 * @method bindUI
			 * @protected
			 */
			bindUI: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "bindUI", 561);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 562);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 564);
A.TreeViewDD.superclass.bindUI.apply(this, arguments);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 566);
instance._bindDragDrop();
			},

			/**
			 * Create the DOM structure for the TreeViewDD. Lifecycle.
			 *
			 * @method renderUI
			 * @protected
			 */
			renderUI: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "renderUI", 575);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 576);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 578);
A.TreeViewDD.superclass.renderUI.apply(this, arguments);

				// creating drag helper and hiding it
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 581);
var helper = A.Node.create(HELPER_TPL).hide();

				// append helper to the body
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 584);
A.one(BODY).append(helper);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 586);
instance.set(HELPER, helper);

				// set DRAG_CURSOR to the default arrow
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 589);
DDM.set(DRAG_CURSOR, DEFAULT);
			},

			/**
			 * Bind DragDrop events.
			 *
			 * @method _bindDragDrop
			 * @protected
			 */
			_bindDragDrop: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_bindDragDrop", 598);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 599);
var instance = this,
					boundingBox = instance.get(BOUNDING_BOX),
					dragInitHandle = null;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 603);
instance._createDragInitHandler = function() {
					_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_createDragInitHandler", 603);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 604);
instance.ddDelegate = new A.DD.Delegate(
						{
							bubbleTargets: instance,
							container: boundingBox,
							invalid: DOT+CSS_TREE_NODE_CONTENT_INVALID,
							nodes: DOT+CSS_TREE_NODE_CONTENT,
							target: true
						}
					);

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 614);
var dd = instance.ddDelegate.dd;

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 616);
dd.plug(A.Plugin.DDProxy, {
						moveOnEnd: false,
						positionProxy: false,
						borderStyle: null
					})
					.plug(A.Plugin.DDNodeScroll, {
						scrollDelay: instance.get(SCROLL_DELAY),
						node: boundingBox
					});

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 626);
dd.removeInvalid('a');

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 628);
if (dragInitHandle) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 629);
dragInitHandle.detach();
					}

				};

				// Check for mobile devices and execute _createDragInitHandler before events
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 635);
if (!UA.touch) {
					// only create the drag on the init elements if the user mouseover the boundingBox for init performance reasons
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 637);
dragInitHandle = boundingBox.on(['focus', 'mousedown', 'mousemove'], instance._createDragInitHandler);
				}
				else {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 640);
instance._createDragInitHandler();
				}

				// drag & drop listeners
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 644);
instance.on('drag:align', instance._onDragAlign);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 645);
instance.on('drag:start', instance._onDragStart);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 646);
instance.on('drop:exit', instance._onDropExit);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 647);
instance.after('drop:hit', instance._afterDropHit);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 648);
instance.on('drop:hit', instance._onDropHit);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 649);
instance.on('drop:over', instance._onDropOver);
			},

			/**
			 * Set the append CSS state on the passed <code>nodeContent</code>.
			 *
			 * @method _appendState
			 * @param {Node} nodeContent
			 * @protected
			 */
			_appendState: function(nodeContent) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_appendState", 659);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 660);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 662);
instance.dropAction = APPEND;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 664);
instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_APPEND);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 666);
nodeContent.addClass(CSS_TREE_DRAG_INSERT_APPEND);
			},

			/**
			 * Set the going down CSS state on the passed <code>nodeContent</code>.
			 *
			 * @method _goingDownState
			 * @param {Node} nodeContent
			 * @protected
			 */
			_goingDownState: function(nodeContent) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_goingDownState", 676);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 677);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 679);
instance.dropAction = BELOW;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 681);
instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_INSERT_BELOW);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 683);
nodeContent.addClass(CSS_TREE_DRAG_INSERT_BELOW);
			},

			/**
			 * Set the going up CSS state on the passed <code>nodeContent</code>.
			 *
			 * @method _goingUpState
			 * @param {Node} nodeContent
			 * @protected
			 */
			_goingUpState: function(nodeContent) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_goingUpState", 693);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 694);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 696);
instance.dropAction = ABOVE;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 698);
instance.get(HELPER).addClass(CSS_TREE_DRAG_STATE_INSERT_ABOVE);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 700);
nodeContent.addClass(CSS_TREE_DRAG_INSERT_ABOVE);
			},

			/**
			 * Set the reset CSS state on the passed <code>nodeContent</code>.
			 *
			 * @method _resetState
			 * @param {Node} nodeContent
			 * @protected
			 */
			_resetState: function(nodeContent) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_resetState", 710);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 711);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 712);
var helper = instance.get(HELPER);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 714);
helper.removeClass(CSS_TREE_DRAG_STATE_APPEND);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 715);
helper.removeClass(CSS_TREE_DRAG_STATE_INSERT_ABOVE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 716);
helper.removeClass(CSS_TREE_DRAG_STATE_INSERT_BELOW);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 718);
if (nodeContent) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 719);
nodeContent.removeClass(CSS_TREE_DRAG_INSERT_ABOVE);
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 720);
nodeContent.removeClass(CSS_TREE_DRAG_INSERT_APPEND);
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 721);
nodeContent.removeClass(CSS_TREE_DRAG_INSERT_BELOW);
				}
			},

			/**
			 * Update the CSS node state (i.e. going down, going up, append etc).
			 *
			 * @method _updateNodeState
			 * @param {EventFacade} event
			 * @protected
			 */
			_updateNodeState: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_updateNodeState", 732);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 733);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 734);
var drag = event.drag;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 735);
var drop = event.drop;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 736);
var nodeContent = drop.get(NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 737);
var dropNode = nodeContent.get(PARENT_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 738);
var dragNode = drag.get(NODE).get(PARENT_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 739);
var dropTreeNode = dropNode.getData(TREE_NODE);

				// reset the classNames from the last nodeContent
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 742);
instance._resetState(instance.nodeContent);

				// cannot drop the dragged element into any of its children
				// using DOM contains method for performance reason
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 746);
if ( !dragNode.contains(dropNode) ) {
					// nArea splits the height in 3 areas top/center/bottom
					// these areas are responsible for defining the state when the mouse is over any of them
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 749);
var nArea = nodeContent.get(OFFSET_HEIGHT) / 3;
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 750);
var yTop = nodeContent.getY();
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 751);
var yCenter = yTop + nArea;
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 752);
var yBottom = yTop + nArea*2;
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 753);
var mouseY = drag.mouseXY[1];

					// UP: mouse on the top area of the node
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 756);
if ((mouseY > yTop) && (mouseY < yCenter)) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 757);
instance._goingUpState(nodeContent);
					}
					// DOWN: mouse on the bottom area of the node
					else {_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 760);
if (mouseY > yBottom) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 761);
instance._goingDownState(nodeContent);
					}
					// APPEND: mouse on the center area of the node
					else {_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 764);
if ((mouseY > yCenter) && (mouseY < yBottom)) {
						// if it's a folder set the state to append
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 766);
if (dropTreeNode && !dropTreeNode.isLeaf()) {
							_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 767);
instance._appendState(nodeContent);
						}
						// if it's a leaf we need to set the ABOVE or BELOW state instead of append
						else {
							_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 771);
if (instance.direction === UP) {
								_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 772);
instance._goingUpState(nodeContent);
							}
							else {
								_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 775);
instance._goingDownState(nodeContent);
							}
						}
					}}}
				}

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 781);
instance.nodeContent = nodeContent;
			},

			/**
			 * Fires after the drop hit event.
			 *
			 * @method _afterDropHit
			 * @param {EventFacade} event drop hit event facade
			 * @protected
			 */
			_afterDropHit: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_afterDropHit", 791);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 792);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 793);
var dropAction = instance.dropAction;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 794);
var dragNode = event.drag.get(NODE).get(PARENT_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 795);
var dropNode = event.drop.get(NODE).get(PARENT_NODE);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 797);
var dropTreeNode = dropNode.getData(TREE_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 798);
var dragTreeNode = dragNode.getData(TREE_NODE);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 800);
var output = instance.getEventOutputMap(instance);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 802);
output.tree.dropNode = dropTreeNode;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 803);
output.tree.dragNode = dragTreeNode;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 805);
if (dropAction === ABOVE) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 806);
dropTreeNode.insertBefore(dragTreeNode);

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 808);
instance.bubbleEvent('dropInsert', output);
				}
				else {_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 810);
if (dropAction === BELOW) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 811);
dropTreeNode.insertAfter(dragTreeNode);

					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 813);
instance.bubbleEvent('dropInsert', output);
				}
				else {_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 815);
if (dropAction === APPEND) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 816);
if (dropTreeNode && !dropTreeNode.isLeaf()) {
						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 817);
dropTreeNode.appendChild(dragTreeNode);

						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 819);
if (!dropTreeNode.get(EXPANDED)) {
							// expand node when drop a child on it
							_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 821);
dropTreeNode.expand();
						}

						_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 824);
instance.bubbleEvent('dropAppend', output);
					}
				}}}

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 828);
instance._resetState(instance.nodeContent);

				// bubbling drop event
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 831);
instance.bubbleEvent('drop', output);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 833);
instance.dropAction = null;
			},

			/**
			 * Fires on drag align event.
			 *
			 * @method _onDragAlign
			 * @param {EventFacade} event append event facade
			 * @protected
			 */
			_onDragAlign: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onDragAlign", 843);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 844);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 845);
var lastY = instance.lastY;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 846);
var y = event.target.lastXY[1];

				// if the y change
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 849);
if (y !== lastY) {
					// set the drag direction
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 851);
instance.direction = (y < lastY) ? UP : DOWN;
				}

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 854);
instance.lastY = y;
			},

			/**
			 * Fires on drag start event.
			 *
			 * @method _onDragStart
			 * @param {EventFacade} event append event facade
			 * @protected
			 */
			_onDragStart: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onDragStart", 864);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 865);
var instance = this;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 866);
var drag = event.target;
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 867);
var dragNode = drag.get(NODE).get(PARENT_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 868);
var dragTreeNode = dragNode.getData(TREE_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 869);
var lastSelected = instance.get(LAST_SELECTED);

				// select drag node
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 872);
if (lastSelected) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 873);
lastSelected.unselect();
				}

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 876);
dragTreeNode.select();

				// initialize drag helper
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 879);
var helper = instance.get(HELPER);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 880);
var helperLabel = helper.one(DOT+CSS_TREE_DRAG_HELPER_LABEL);

				// show helper, we need display block here, yui dd hide it with display none
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 883);
helper.setStyle(DISPLAY, BLOCK).show();

				// set the CSS_TREE_DRAG_HELPER_LABEL html with the label of the dragged node
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 886);
helperLabel.html( dragTreeNode.get(LABEL) );

				// update the DRAG_NODE with the new helper
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 889);
drag.set(DRAG_NODE, helper);
			},

			/**
			 * Fires on drop over event.
			 *
			 * @method _onDropOver
			 * @param {EventFacade} event append event facade
			 * @protected
			 */
			_onDropOver: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onDropOver", 899);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 900);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 902);
instance._updateNodeState(event);
			},

			/**
			 * Fires on drop hit event.
			 *
			 * @method _onDropHit
			 * @param {EventFacade} event append event facade
			 * @protected
			 */
			_onDropHit: function(event) {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onDropHit", 912);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 913);
var dropNode = event.drop.get(NODE).get(PARENT_NODE);
				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 914);
var dropTreeNode = dropNode.getData(TREE_NODE);

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 916);
if (!isTreeNode(dropTreeNode)) {
					_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 917);
event.preventDefault();
				}
			},

			/**
			 * Fires on drop exit event.
			 *
			 * @method _onDropExit
			 * @param {EventFacade} event append event facade
			 * @protected
			 */
			_onDropExit: function() {
				_yuitest_coverfunc("build/aui-tree-view/aui-tree-view.js", "_onDropExit", 928);
_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 929);
var instance = this;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 931);
instance.dropAction = null;

				_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 933);
instance._resetState(instance.nodeContent);
			}
		}
	}
);

_yuitest_coverline("build/aui-tree-view/aui-tree-view.js", 939);
A.TreeViewDD = TreeViewDD;

}, '2.0.0pr1', {
    "requires": [
        "dd-delegate",
        "dd-proxy",
        "aui-tree-node",
        "aui-tree-paginator",
        "aui-tree-io"
    ],
    "skinnable": true
});
